*! version 3.0.1  05mar2010
program _coef_table, rclass
	version 11
	if !c(noisily) {
		exit
	}
	_check_eclass
	syntax [, BMATrix(passthru) VMATrix(passthru) * ]
	if "`e(b)'" == "" & "`e(V)'" == "" & "`bmatrix'`vmatrix'"=="" {
		exit
	}
	if "`e(cmd)'" == "regress" {
		local ALTOPT Beta
	}
	if "`e(mi)'"=="mi" {
		local ALTOPT	`ALTOPT'		///
				DFTable			///
				noCLUSTReport		///
				DFMATrix(string)	///
				PISEMATrix(string)
	}
	syntax [,				///
		DEPNAME(string)			/// NOT DOCUMENTED
		COEFTitle(string)		///
		Level(cilevel)			///
		PLus				///
		NOFirst				///
		First				///
		SHOWEQns			///
		NEQ(integer -1)			///
		NODIPARM			///
		NOTEST				///
		SEParator(integer 0)		///
		NOSKIP				///
		IGNORERC			/// [sic]
		OFFSETONLY1			///
		noCNSReport			/// -_b_table- options
		FULLCNSReport			///
		`ALTOPT'			///
		BMATrix(string)			///
		VMATrix(string)			///
		cformat(passthru)		///
		sformat(passthru)		///
		pformat(passthru)		///
		NOEQCHECK			/// used by -mi estimate-
		EFORMALL			///
		*				/// -eform/diparm- opts
	]

	opts_exclusive "`first' `nofirst'"
	opts_exclusive "`first' `showeqns'"
	local cnsreport `cnsreport' `fullcnsreport'
	opts_exclusive "`cnsreport'"
	if `"`showeqns'"' != "" {
		local nofirst nofirst
	}

	is_svysum `e(cmd)'
	local is_sum = r(is_svysum)

	_get_diopts diopts options, `options'
	local legend coeflegend selegend
	local legend : list legend & diopts
	local diopts : list diopts - legend

	_get_diopts ignore, `diopts' `cformat' `sformat' `pformat'
	local cfmt `"`s(cformat)'"'
	local sfmt `"`s(sformat)'"'
	local pfmt `"`s(pformat)'"'

	// parse `options' for -eform()- and friends
	_get_eformopts , eformopts(`options') allowed(__all__) soptions
	local eform	`"`s(str)'"'
	local coefttl = cond(`"`eform'"'==`""', `"`coeftitle'"', `"`s(str)'"')
	local options	`"`s(options)'"'

	// `options' should only contain -diparm()- options
	_get_diparmopts, diparmopts(`options') level(`level')
	// ignore -diparm()- options; but checked for valid syntax anyway
	local NODIPARM : length local nodiparm
	if `NODIPARM' {
		local options
	}

	local GTOPTS parse(":") bind quotes
	local k 0
	if !`NODIPARM' {
		if `"`e(diparm)'"' != "" {
			local i 0
			local diparm `"`e(diparm)'"'
		}
		else if `"`e(diparm1)'"' != "" {
			local i 1
			local diparm `"`e(diparm1)'"'
		}
		while `:length local diparm' {
			gettoken diparm rest : diparm, `GTOPTS'
			while `:length local rest' {
				local ++k
				local diparm`k' : copy local diparm
				gettoken COLON rest : rest, `GTOPTS'
				gettoken diparm rest : rest, `GTOPTS'
			}
			local ++k
			local diparm`k' : copy local diparm
			local ++i
			local diparm `"`e(diparm`i')'"'
		}
	}
	if `:length local options' {
		local 0 `", `options'"'
		syntax [, diparm(string asis) *]
		if `k' & `:length local diparm' {
			local ++k
			local diparm`k' __sep__
		}
		while `:length local diparm' {
			gettoken diparm rest : diparm, `GTOPTS'
			while `:length local rest' {
				local ++k
				local diparm`k' : copy local diparm
				gettoken COLON rest : rest, `GTOPTS'
				gettoken diparm rest : rest, `GTOPTS'
			}
			local ++k
			local diparm`k' : copy local diparm
			local 0 `", `options'"'
			syntax [, diparm(string asis) *]
		}
	}

	if `"`e(error)'"' == "matrix" {
		local ematrix "e(error)"
	}

	mata: _coef_table(`level', `k')
end

exit

NOTES:

-_coef_table- looks at the following scalars to determine which equations are
put in the table of results, and how they are put there:

	e(k_eq)		-- total number of equations, missing value implies 1
	e(k_aux)	-- number of ancillary parameters (each an equation)
	e(k_extra)	-- extra equations
	e(k_eform)	-- the first e(k_eform) equations' coefficients will
			   be exponentiated when an 'eform' type option is
			   specified; default is 1

