*! version 1.0.1  05mar2010
version 11

local sumcmds mean proportion ratio total

mata:

void _coef_table(real scalar level, real scalar k_diparm)
{
	// info pulled from local macros
	string	scalar	depname
	string	scalar	coefttl
	string	scalar	cnsreport
	real	scalar	clreport
	string	scalar	legend
	string	scalar	diopts
	real	scalar	plus
	real	scalar	first
	real	scalar	nofirst
	real	scalar	neq
	string	scalar	bmat
	string	scalar	vmat
	string	scalar	emat
	real	scalar	eform
	real	scalar	offsetonly1
	real	scalar	beta
	real	scalar	dftable
	string	scalar	dfmat
	string	scalar	pisemat
	real	scalar	separator
	real	scalar	eqcheck
	// info pulled from e()
	real	scalar	is_sum
	real	scalar	k_eq
	real	scalar	k_aux
	real	scalar	k_eq_skip
	real	scalar	k_extra
	real	scalar	k_eform
	real	scalar	k_eq_base
	string	matrix	stripe
	string	scalar	offset
	// work
	real	matrix	ms_info
	real	matrix	i0
	real	matrix	i1
	real	scalar	i
	real	scalar	j
	real	vector	eformlist
	string	scalar	msg
	string	scalar	p
	real	scalar	hideeq
	string	scalar	noprob
	real	scalar	isep
	// coefficient table class	
	class _b_table	scalar	T

	// get info from local macros
	depname		= st_local("depname")
	coefttl		= st_local("coefttl")
	cnsreport	= st_local("cnsreport")
	clreport	= strlen(st_local("clustreport")) == 0
	legend		= st_local("legend")
	diopts		= st_local("diopts")
	plus		= strlen(st_local("plus"))
	first		= strlen(st_local("first"))
	nofirst		= strlen(st_local("nofirst"))
	neq		= strtoreal(st_local("neq"))
	bmat		= st_local("bmatrix")
	vmat		= st_local("vmatrix")
	emat		= st_local("ematrix")
	eform		= strlen(st_local("eform"))
	offsetonly1	= strlen(st_local("offsetonly1"))
	beta		= strlen(st_local("beta"))
	dftable		= strlen(st_local("dftable"))
	dfmat		= st_local("dfmatrix")
	pisemat		= st_local("pisematrix")
	separator	= strtoreal(st_local("separator"))
	if (strlen(st_local("notest"))) {
		noprob = "noprob"
	}
	eqcheck		= strlen(st_local("noeqcheck")) == 0

	// get info from e()
	is_sum = any(strmatch(st_global("e(cmd)"), tokens("`sumcmds'")))
	if (bmat == "") {
		bmat = "e(b)"
	}
	stripe	= st_matrixcolstripe(bmat)
	ms_info	= panelsetup(stripe, 1)
	if (eqcheck) {
		k_eq	= _ct_get_scalar("e(k_eq)")
		if (missing(k_eq)) {
			k_eq = rows(ms_info)
		}
		else if (k_eq > rows(ms_info)) {
			errprintf(
"estimation command error: e(k_eq) is larger than the number of equations")
			exit(322)
		}
		k_aux	= _ct_get_scalar("e(k_aux)")
		if (missing(k_aux)) {
			k_aux = 0
		}
		if (strlen(st_local("noskip"))) {
			k_eq_skip = 0
		}
		else {
			k_eq_skip = _ct_get_scalar("e(k_eq_skip)")
			if (missing(k_eq_skip)) {
				k_eq_skip = 0
			}
		}
		k_extra	= _ct_get_scalar("e(k_extra)")
		if (missing(k_extra)) {
			k_extra = 0
		}
	}
	else {
		k_eq		= rows(ms_info)
		k_aux		= 0
		k_eq_skip	= 0
		k_extra		= 0
	}
	if (k_aux | k_eq_skip | k_extra) {
		if (k_eq != rows(ms_info)) {
			errprintf(
"estimation command error: e(k_eq) does not equal the number of equations\n")
			exit(322)
		}
	}
	k_eform = 0
	if (first) {
		neq = 1
	}
	if (neq > 0) {
		k_aux		= 0
		k_eq_skip	= 0
		k_extra		= 0
		if (strlen(st_local("eformall"))) {
			k_eform = neq
		}
	}
	else {
		neq = k_eq - k_aux - k_extra - k_eq_skip
		if (neq < 0) {
			msg	= ""
			p	= ""
			if (k_aux) {
				msg = sprintf(	"%s%s%s",
						msg,
						p,
						"e(k_aux)")
				p = " + "
			}
			if (k_eq_skip) {
				msg = sprintf(	"%s%s%s",
						msg,
						p,
						"e(k_eq_skip)")
				p = " + "
			}
			if (k_extra) {
				msg = sprintf(	"%s%s%s",
						msg,
						p,
						"e(k_extra)")
				p = " + "
			}
			errprintf(
"estimation command error: e(k_eq) is less than %s\n", msg)
			exit(322)
		}
		if (!is_sum & neq == 1 & k_extra == 0 & !nofirst) {
			first = 1
		}
	}
	hideeq	= first
	if (k_eform == 0) {
		if (any(strmatch(st_global("e(cmd)"),
				tokens("mlogit mprobit")))) {
			k_eform = k_eq - k_extra
		}
		else if (neq) {
			k_eform = _ct_get_scalar("e(k_eform)")
			if (missing(k_eform)) {
				k_eform = 1
			}
			if (k_eform > neq) {
				k_eform = neq
			}
		}
	}

	eformlist = (1..neq) :<= k_eform
	if (k_aux & separator) {
		isep = floor((k_aux-1)/separator)
	}
	else {
		isep = 0
	}

	if (bmat == "e(b)") {
		bmat = ""
	}
	T.set_b(bmat)
	T.set_V(vmat)
	T.set_errmat(emat)
	T.set_df(_ct_get_scalar("e(df_r)"))
	T.set_level(level)
	T.set_legend(legend)
	T.set_diopts(diopts)
	T.set_beta(beta)
	T.set_dftable(dftable)
	T.set_dfmat(dfmat)
	T.set_pisemat(pisemat)
	T.set_cformat(st_local("cfmt"))
	T.set_sformat(st_local("sfmt"))
	T.set_pformat(st_local("pfmt"))
	if (k_aux & k_diparm) {
		isep++
	}
	T.set_ndiparm(k_aux+k_diparm+isep)
	if (rows(ms_info) == 0) {
		neq = 0
	}
	i0	= neq + k_eq_skip + 1
	i1	= neq + k_eq_skip + k_aux
	isep	= 0
	j	= 1
	for (i=i0; i<=i1; i++, j++, isep++) {
		if (isep & mod(isep, separator) == 0) {
			T.set_diparm(j, "__sep__")
			j++
		}
		T.set_diparm(j,
			sprintf("%s, %s %s",
				stripe[ms_info[i,1],1],
				noprob,
				st_global(sprintf("e(diparm_opt%f)",i)))
		)
	}
	if (j != 1 & k_diparm) {
		T.set_diparm(j, "__sep__")
		j++
	}
	for (i=1; i<=k_diparm; i++, j++) {
		T.set_diparm(j, st_local(sprintf("diparm%f",i)))
	}
	T.validate()

	T.di_titles(depname,coefttl,cnsreport,clreport)

	if (eqcheck) {
		k_eq_base = _ct_get_scalar("e(k_eq_base)")
	}
	offset	= st_global("e(offset1)")
	if (strlen(offset) == 0) {
		offset	= st_global("e(offset)")
	}
	for (i=1; i<=neq; i++) {
		if (i == k_eq_base) {
			T.di_eq(i,
				hideeq,
				eform ? eformlist[i] : 0,
				"  (base outcome)")
		}
		else {
			T.di_eq(i,
				hideeq,
				eform ? eformlist[i] : 0,
				"")
		}
		if (offsetonly1 == 0) {
			offset	= st_global(sprintf("e(offset%f)",i))
			if (strlen(offset) == 0) {
				offset	= st_global("e(offset)")
			}
			T.di_offset(offset)
			offset	= ""
		}
		if (i == k_eform & strlen(offset)) {
			T.di_offset(offset)
			offset	= ""
		}
	}
	if (strlen(offset)) {
		if (neq == 0) {
			T.sep()
		}
		T.di_offset(offset)
	}
	T.do_diparms()
	i0	= i1 + 1
	i1	= i0 + k_extra - 1
	for (i=i0; i<=i1; i++) {
		T.di_eq(i, hideeq, 0, "")
	}
	if (plus) {
		T.sep()
	}
	else {
		T.finish()
	}
}

void _st_sum_table(real scalar level)
{
	// info pulled from local macros
	string	scalar	bmat
	string	scalar	vmat
	string	scalar	emat
	// info pulled from e()
	real	scalar	k_eq
	string	matrix	stripe
	// work
	real	matrix	ms_info
	real	scalar	i
	// coefficient table class	
	class _sum_table scalar	T

	// get info from e()
	if (!any(strmatch(st_global("e(cmd)"), tokens("`sumcmds'")))) {
		exit(error(301))
	}

	// get info from local macros
	bmat	= st_local("bmatrix")
	vmat	= st_local("vmatrix")
	emat	= st_local("ematrix")

	if (bmat == "") {
		bmat = "e(b)"
	}
	stripe	= st_matrixcolstripe(bmat)
	ms_info	= panelsetup(stripe, 1)
	k_eq	= rows(ms_info)
	if (bmat == "e(b)") {
		bmat = ""
	}
	T.set_b(bmat)
	T.set_V(vmat)
	T.set_errmat(emat)
	T.set_df(_ct_get_scalar("e(df_r)"))
	T.set_level(level)
	T.set_cformat(st_local("cfmt"))

	T.validate()
	T.di_titles()
	for (i=1; i<=k_eq; i++) {
		T.di_eq(i)
	}
	T.finish()
}

real	scalar	_ct_get_scalar(string scalar name)
{
	real	scalar	x

	x = st_numscalar(name)
	if (length(x) == 0) {
		x = .
		if (strlen(st_global(name))) {
			x = strtoreal(st_global(name))
		}
	}
	return(x)
}

end
