{smcl}
{* *! version 1.1.1  14oct2010}{...}
{cmd:help clonevar}{...}
{right:dialog:  {dialog clonevar}}
{hline}

{title:Title}

{p2colset 5 21 23 2}{...}
{p2col :{manlink D clonevar} {hline 2}}Clone existing variable{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 29 2}
{cmd:clonevar}
{newvar} 
{cmd:=} 
{varname} 
{ifin}


{title:Description}

{pstd}
{cmd:clonevar} generates {newvar} as an exact copy of an existing variable,
{varname}, with the same {help data types:storage type}, values, and 
{help format:display format} as {it:varname}.
{it:varname}'s {help label:variable label}, {help label:value labels},
{help notes}, and {help char:characteristics} will also be copied.


{title:Remarks}

{pstd}
{cmd:clonevar} has various possible uses.  Programmers may desire that a
temporary variable appear to the user exactly like an existing variable.
Interactively, you might want a slightly modified copy of an original
variable, so the natural starting point is a clone of the original.


{title:Examples}

    {hline}
{pstd}Setup{p_end}
{phang2}{cmd:. sysuse auto}{p_end}

{pstd}Create {cmd:Mpg} variable as an exact copy of existing variable
{cmd:mpg}{p_end}
{phang2}{cmd:. clonevar Mpg = mpg}

    {hline}
{pstd}Setup{p_end}
{phang2}{cmd:. webuse travel, clear}{p_end}
{phang2}{cmd:. describe mode}{p_end}
{phang2}{cmd:. label list travel}{p_end}

{pstd}Create {cmd:airtrain} to be a slightly modified copy of {cmd:mode}{p_end}
{phang2}{cmd:. clonevar airtrain = mode if mode==1 | mode==2}{p_end}

{pstd}List first through fifth observations on {cmd:mode} and {cmd:airtrain} variables{p_end}
{phang2}{cmd:. list mode airtrain in 1/5}{p_end}
    {hline}
   

{title:Also see}

{psee}
Manual:  {manlink D clonevar}

{psee}
{space 2}Help:  {manhelp generate D}, {manhelp separate D} 
{p_end}
