{smcl}
{* *! version 1.1.3  29jan2010}{...}
{cmd:help dfgls}{right:dialog:  {dialog dfgls}}
{hline}

{title:Title}

{p2colset 5 19 21 2}{...}
{p2col:{manlink TS dfgls} {hline 2}}DF-GLS unit-root test{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 14 2}
{cmd:dfgls}
{varname}
{ifin}
[{cmd:,}
{it:options}]

{synoptset 13 tabbed}{...}
{synopthdr}
{synoptline}
{syntab:Main}
{synopt:{opt m:axlag(#)}}use {it:#} as the highest lag order for Dickey-Fuller GLS regressions {p_end}
{synopt:{opt not:rend}}series is stationary around a mean instead of around a linear time trend {p_end}
{synopt:{opt ers}}present interpolated critical values from Elliot, Rothenberg, and Stock{p_end}
{synoptline}
{p2colreset}{...}
{p 4 6 2}
You must {opt tsset} your data before using {opt dfgls}; see {manhelp tsset TS}.
{p_end}
{p 4 6 2}
{it:varname} may contain time-series operators; see {help tsvarlist}.
{p_end}


{title:Menu}

{phang}
{bf:Statistics > Time series > Tests > DF-GLS test for a unit root}


{title:Description}

{pstd}
{opt dfgls} performs a modified Dickey-Fuller t test for a unit root in
which the series has been transformed by a generalized least-squares
regression.


{title:Options}

{dlgtab:Main}

{phang}
{opt maxlag(#)} sets the value of k, the highest lag order for the
   first-differenced, detrended variable in the Dickey-Fuller regression.  By
   default, {opt dfgls} sets k according to the method proposed by Schwert;
   i.e., {opt dfgls} sets k_max=int[12{(T+1)/100}^(0.25)].

{phang}
{opt notrend} specifies that the alternative hypothesis be that the series
   is stationary around a mean instead of around a linear time trend.  By
   default, a trend is included.

{phang}
{opt ers} specifies that {opt dfgls} should present interpolated
   critical values from tables presented by Elliott, Rothenberg, and Stock,
   which they obtained from simulations.  See {hi:Critical values}
   under {it:Methods and formulas} in {bind:{bf:[TS] dfgls}} for details.


{title:Examples}

{pstd}Setup{p_end}
{phang2}{cmd:. webuse lutkepohl2}

{pstd}Test whether {cmd:ln_inv} exhibits a unit root{p_end}
{phang2}{cmd:. dfgls ln_inv}{p_end}

{pstd}Same as above, but use 8 as the highest lag order for Dickey-Fuller GLS
regressions{p_end}
{phang2}{cmd:. dfgls ln_inv, maxlag(8)}{p_end}


{title:Saved results}

{pstd}
If {cmd:maxlag(0)} is specified, {cmd:dfgls} saves the following in {cmd:r()}:

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Scalars}{p_end}
{synopt:{cmd:r(rmse0)}}RMSE{p_end}
{synopt:{cmd:r(dft0)}}DF-GLS statistic{p_end}

{pstd}
Otherwise, {cmd:dfgls} saves the following in {cmd:r()}:

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Scalars}{p_end}
{synopt:{cmd:r(maxlag)}}highest lag order k{p_end}
{synopt:{cmd:r(N)}}number of observations{p_end}
{synopt:{cmd:r(sclag)}}lag chosen by Schwarz criterion{p_end}
{synopt:{cmd:r(maiclag)}}lag chosen by modified AIC method{p_end}
{synopt:{cmd:r(optlag)}}lag chosen by sequential-t method{p_end}

{synoptset 15 tabbed}{...}
{p2col 5 15 19 2: Matrices}{p_end}
{synopt:{cmd:r(results)}}k, MAIC, SIC, RMSE, and DF-GLS statistics{p_end}
{p2colreset}{...}


{title:Also see}

{psee}
Manual:  {manlink TS dfgls}

{psee}
{space 2}Help:  
{manhelp dfuller TS},
{manhelp pperron TS},
{manhelp tsset TS},
{manhelp xtunitroot XT}
{p_end}
