{smcl}
{* *! version 1.3.0  04jan2010}{...}
{cmd:help estimation options}
{hline}

{title:Title}

{p2colset 5 31 33 2}{...}
{p2col :{manlink R estimation options} {hline 2}}Estimation options{p_end}


{title:Description}

{pstd}
This entry describes the options common to many estimation commands.
Not all the options documented below work with all estimation commands.
See the documentation for the particular estimation command; if an
option is listed there, it is applicable.


{title:Options}

{dlgtab:Model}

{phang}
{marker noconstant}{...}
{opt noconstant}
suppresses the constant term (intercept) in the model.

{phang}
{marker offset()}{...}
{opth offset(varname)} specifies that {it:varname} be included in the
model with the coefficient constrained to be 1.

{phang}
{marker exposure()}{...}
{opth exposure(varname)}
specifies a variable that reflects the amount of exposure over
which the {depvar} events were observed for each observation;
ln({it:varname}) with coefficient constrained to be 1 is entered into the
log-link function.

{phang}
{marker constraints()}
{cmd:constraints(}{it:{help numlist}}{c |}{it:matname}{cmd:)}
specifies the linear constraints to be applied during estimation.
The default is to perform unconstrained estimation.
See {manhelp reg3 R} for the use of constraints in multiple-equation contexts.

{pmore}
{opt constraints(numlist)} specifies the constraints by number after they
have been defined by using the {cmd:constraint} command; see
{helpb constraint:[R] constraint}.  Some commands
(for example, {helpb slogit}) allow only {opt constraints(numlist)}.

{pmore}
{opt constraints(matname)} specifies a matrix containing the constraints;
see {manhelp makecns P}.

{pmore}
{opt constraints(clist)} is used by some estimation commands, such as
{helpb mlogit}, where {it:clist} has the form
{bind:{it:#}[{cmd:-}{it:#}][{cmd:,}{it:#}[{cmd:-}{it:#}] {it:...} ]}.

{phang}
{marker collinear}
{opt collinear} specifies that the estimation command not omit collinear
variables.  Usually, there is no reason to leave collinear variables in place,
and, in fact, doing so usually causes the estimation to fail because of the
matrix singularity caused by the collinearity.  However, with certain models,
the variables may be collinear, yet the model is fully identified because of
constraints or other features of the model.  In such cases, using the 
{cmd:collinear} option allows the estimation to take place, leaving the
equations with collinear variables intact.  This option is seldom used.

{phang}
{marker force}
{opt force} specifies that estimation be forced even though the time variable
is not equally spaced.  This is relevant only for correlation structures that
require knowledge of the time variable.  These correlation structures require
that observations be equally spaced so that calculations based on lags
correspond to a constant time change.  If you specify a time variable
indicating that observations are not equally spaced, the (time dependent) model
will not be fit.  If you also specify {opt force}, the model will be
fit, and it will be assumed that the lags based on the data ordered by
the time variable are appropriate.

{marker corr()}{...}
{dlgtab:Correlation}

{phang}
{opt corr(correlation)} specifies the within-group correlation
structure; the default corresponds to the equal-correlation model,
{cmd:corr(exchangeable)}.

{pmore}
When you specify a correlation structure that requires a lag, you indicate the
lag after the structure's name with or without a blank; e.g., {cmd:corr(ar 1)}
or {cmd:corr(ar1)}.

{pmore}
If you specify the fixed correlation structure, you specify the name of the
matrix containing the assumed correlations following the word {cmd:fixed},
e.g., {cmd:corr(fixed myr)}.

{dlgtab:Reporting}

{phang}
{marker level()}{...}
{opt level(#)}
specifies the confidence level, as a percentage, for confidence intervals.
The default is {cmd:level(95)} or as set by {helpb set level}.

{phang}
{marker noskip}
{opt noskip} specifies that a full maximum-likelihood model with only a constant
    for the regression equation be fit.  This model is not displayed but
    is used as the base model to compute a likelihood-ratio test for the model
    test statistic displayed in the estimation header.  By default, the
    overall model test statistic is an asymptotically equivalent Wald test of
    all the parameters in the regression equation being zero (except the
    constant).  For many models, this option can substantially increase
    estimation time.

{marker nocnsreport}{...}
{phang}
{opt nocnsreport} specifies that no constraints be reported.  The default is to
    display user-specified constraints above the coefficient table.

{marker display_options}{...}
{phang}
{opt noomitted} specifies that variables that were omitted because of
collinearity not be displayed.  The default is to include in the table
any variables omitted because of collinearity and to label them as "(omitted)".

{phang}
{opt vsquish} specifies that the blank space separating factor-variable
          terms or time-series-operated variables from other variables
          in the model be suppressed.

{phang}
{opt noemptycells} specifies that empty cells for interactions of factor
variables not be displayed.  The default is to include in the table interaction
cells that do not occur in the estimation sample and to label them as
"(empty)".

{phang}
{opt baselevels} and {opt allbaselevels} control whether the base levels of
factor variables and interactions are displayed.  The default is to exclude
from the table all base categories. 

{phang2}
        {opt baselevels} specifies that base levels be reported for factor
                variables and for interactions whose bases cannot be inferred
                from their component factor variables.

{phang2}
        {opt allbaselevels} specifies that all base levels of factor variables
                and interactions be reported.

INCLUDE help intpts3


{pstd}
The following options are not shown in the dialog box:

{marker coeflegend}{...}
{phang}
{opt coeflegend} specifies that the legend of the coefficients and how to
              specify them in an expression be displayed rather than the
               coefficient table.

{marker cformat}{...}
{phang}
{opt cformat(fmt)} specifies how to format coefficients, standard errors, and
confidence limits in the coefficient table.

{marker pformat}{...}
{phang}
{opt pformat(fmt)} specifies how to format p-values in the coefficient table.

{marker sformat}{...}
{phang}
{opt sformat(fmt)} specifies how to format test statistics in the coefficient
table.


{title:Also see}

{psee}
Manual:  {manlink R estimation options}

{psee}
{space 2}Help:  {manhelp estimation_commands I:estimation commands}
{p_end}
