*! version 1.0.3  11mar2011
program mi_cmd_impute, rclass
	version 11
	local version : di "version " string(_caller()) ":"

	u_mi_assert_set

	_parse comma l r : 0
	gettoken method l : l
	local 0 `"`l' `r'"'
	_mi_impute_mapmethod method : "`method'"

	u_mi_certify_data, acceptable

	// parsing step
	_mi_impute_`method'_parse `0'
	local zero	`s(zero)'
	local update	`s(noupdate)'
	local stop	`s(stop)'`s(nomiss)'
	if ("`stop'"=="") {
		u_mi_sets_okay	// check struct. vars (if any)

		if ("`update'"=="") { 
			u_mi_certify_data, proper
		}
		ret clear
		// imputation step
		`version' _xeq_esthold u_mi_xeq_on_tmp_flongsep : ///
			u_mi_impute_xeq `method' `zero'
		ret add
	}
	sret clear
end


program _mi_impute_regress_parse

	_parse comma lhs rhs : 0	
	// preliminary syntax check
	syntax [anything(equalok)] [if] [aw fw pw iw]		///
		[,						/// 
			NOCONStant				///
			*					///
		]
	if ("`weight'"!="") {
		local wgtexp [`weight' `exp']
	}

	sret clear
	// returns s()
	_mi_impute_chk_uvmethod regress `anything' `if' `wgtexp' `rhs' 
end
program _mi_impute_pmm_parse, sclass

	_parse comma lhs rhs : 0
	// preliminary syntax check
	syntax [anything(equalok)] [if] [aw fw pw iw]		///
		[,						/// 
			NOCONStant				///
			KNN(string)				///
			PMTOLerance(string)			/// undoc.
			EXPROK					/// undoc.
			*					///
		]
	if ("`weight'"!="") {
		local wgtexp [`weight' `exp']
	}
	// knn()
	if ("`knn'"!="") {
		if ("`pmtolerance'"!="") {
			di as err "only one of {bf:knn()} or "	///
				  "{bf:pmtolerance()} is allowed"
			exit 198
		}
		cap confirm integer number `knn'
		if (_rc) {
			di as err "{bf:knn()} must be a positive integer"
			exit 198
		}
		if (`knn'<=0) {
			di as err "{bf:knn()} must be a positive integer"
			exit 198
		}
	}
	// ttolerance()
	if ("`pmtolerance'"!="") {
		cap confirm number `pmtolerance'
		if (_rc) {
			di as err ///
			   "{bf:pmtolerance()} must be a number between 0 and 1"
			exit 198
		}
		if (`pmtolerance'<0 | `pmtolerance'>=1) {
			di as err ///
			   "{bf:pmtolerance()} must be a number between 0 and 1"
			exit 198
		}
	}

	sret clear
	// returns s()
	_mi_impute_chk_uvmethod pmm `anything' `if' `wgtexp' `rhs' 
end

program _mi_impute_logit_parse, sclass
	// preliminary syntax check
	syntax [anything(equalok)] [if] [fw pw iw]		///
		[,						/// 
			NOCONStant				///
			OFFset(varname)				///
			ASIS					/// 
			EXPROK					/// undoc.
			*					///
		]
	sret clear
	_mi_impute_chk_uvmethod logit `0' // returns s()
end

program _mi_impute_ologit_parse, sclass
	// preliminary syntax check
	syntax [anything(equalok)] [if] [fw pw iw]		///
		[,						/// 
			NOCONStant				///
			OFFset(varname)				///
			EXPROK					/// undoc.
			*					///
		]
	if ("`noconstant'"!="") {
		di as err "option `noconstant' not allowed"
		exit 198
	}
	sret clear
	_mi_impute_chk_uvmethod ologit `0' // returns s()
end

program _mi_impute_mlogit_parse, sclass
	// preliminary syntax check
	syntax [anything(equalok)] [if] [fw pw iw]		///
		[,						/// 
			NOCONStant				///
			Baseoutcome(string)			///
			EXPROK					/// undoc.
			*					///
		]
	sret clear
	_mi_impute_chk_uvmethod mlogit `0' // returns s()
end

program _mi_impute_monotone_parse, sclass
	_parse comma l r : 0
	if (`"`l'"'=="") {
		di as err "{bf:mi impute monotone}: at least one "	///
			  "imputation model must be specified"
		exit 198
	}
	local 0 `r'
	syntax  [, Custom REPORT DRYRUN VERBOSE NOIsily ///
		   NOMONOTONECHK 			///
		   NOMISSNOTE 				/// //undoc.
		   NOVARSCHK 				/// //undoc.
		   * 					///
		]
	local impop `options'

	if ("`dryrun'"!="" & "`verbose'"!="") {
		di as err "{bf:dryrun} and {bf:verbose} cannot be combined"
		exit 198
	}
	if ("`dryrun'"!="") {
		local noimpchk noimpchk
	}
	if ("`custom'"=="") {
		local verbose verbose
		_mi_impute_monotone_buildeq `l' , 	///
				`nomonotonechk' `nomissnote' `novarschk'
		local uvlist `s(uvlist)'
		local ivarsinc `s(ivarsinc)'
		if ("`s(nomiss)'"!="") {
			sret local nomiss nomiss
			exit
		}
	}
	else {
		local uvlist `l'
	}
	_parse expand lhs glb : uvlist, gweight
	local 0 `glb_if' `glb_in' `glb_wt'	//[in] not allowed
	syntax [if/] [fw aw pw iw]
	marksample touse			// analysis sample
	
	// parse main opts
	_mi_impute_main_parse_rhs monotone , `impop' `noimpchk' // returns s()
	local impopts	`s(impopts)'
	local monopts	`s(opts)'
	local noupdate	`s(noupdate)'
	if ("`s(stop)'"!="") {
		sret local stop stop
		exit
	}

	/* initial parsing: checks that imput. methods are specified and valid; 
			    checks that numeric imp. vars are specified and 
				registered
	*/
	local haserr 0
	forvalues i=1/`lhs_n' {
		local erreq 0
		gettoken method rest : lhs_`i'
		if (`"`method'"'=="" | `"`method'"'==",") {
			di as err "imputation method required"
			local erreq 1
			local ++haserr
		}
		else {
			cap noi _mi_impute_chkmethod method : ///
				`"`method'"' "nothing" uvonly
			if (_rc) {
				local erreq 1
				local ++haserr
			}
			local methods `methods' `method'
		}
		gettoken ivar : rest, parse(" ,")
		if (`"`ivar'"'=="" | `"`ivar'"'=="," | `"`method'"'==",") {
			di as err "imputation (left-hand-side) variable " ///
				  "required"
			local erreq 1
			local ++haserr
		}
		else {
			cap unab ivar : `ivar'
			gettoken ivar : ivar
			cap noi confirm numeric variable `ivar'
			if (_rc) {
				local erreq 1
				local ++haserr
			}
			else {
				cap noi u_mi_mustbe_registered_imputed ///
							bad : "`ivar'"
				if (_rc) {
					local erreq 1
					local ++haserr
				}
			}
			local ivars `ivars' `ivar'
		}
		if (`erreq') {
			di as err "{p 1 3 2}"
			di as err "-- above applies to equation "	///
				  "{bf:(`lhs_`i'')}"
			di as err "{p_end}"
			di as err ""
		}
	}
	if (`haserr') {
		exit 198
	}
	unab ivars : `ivars'
	// check ivars are not specified more than once
	local dups : list dups ivars
	if ("`dups'"!="") {
		local uniq: list uniq dups
		local n: word count `uniq'
		di as err "{p 0 0 2}{bf:`uniq'}: duplicates found{p_end}" 
		di as err "{p 4 4 2}Variables cannot be specified as " /// 
			 "imputation variables in multiple equations.{p_end}"
		exit 198		
	}
	
	// the following checks require 'touse'
	markout `touse' `ivars', sysmissok
	local p : word count `ivars'
	// check ivars form a monotone-missing pattern and
	//       equations are ordered in a monotone-missing pattern of ivars
	if ("`custom'"!="" & "`nomonotonechk'"=="") {
		_chk_monotone `ivars' if `touse'
		local ivarsinc  `s(ivarsinc)'
		local ivarsc 	`s(ivarsc)'
		local stmt1wc	`s(stmt1wc)'
		local ivarsmonotone `s(ivarsmonotone)'
		if ("`ivarsinc'"!="") {
			local is_ordered : list ivarsinc == ivarsmonotone
			if (!`is_ordered') {
				di as err "{p 0 0 2}"
				di as err "{bf:mi impute monotone}: "	    ///
					  "incorrect equation order{p_end}"
				di as err "{p 4 4 2}equations must be "	    ///
				   "listed in the monotone-missing order "  ///
				   "of the imputation variables (from "	    ///
				   "most observed to least observed); "	    ///
				   "{bf:`stmt1wc'}{p_end}"
				exit 198
			}
		}
		note_nomiss "`ivarsc'" "`ivarsinc'"  "`nomissnote'"
		local nomiss `s(nomiss)'
		if ("`nomiss'"!="") {
			sret local nomiss nomiss
			exit
		}
	}	// end -custom-
	else if ("`nomonotonechk'"!="") {
		local ivarsinc `ivars'
	}
	if ("`report'"!="") {
		local showchk 
	}
	else {
		local showchk qui
	}
	// parse equations of incomplete variables
	`showchk' di _n as txt "Checking equations:" _n
	local haserr 0
	local firsteq 1
	local n_eq    1
	local notallowed `ivarsinc'
	tokenize `ivarsinc'
	local i = 1
	while ("``i''"!="") {
		local erreq 0
		local comma
		local pos : list posof `"``i''"' in ivars
		local method : word `pos' of `methods'
		gettoken first rest : lhs_`pos'
		gettoken next notallowed : notallowed
		cap noi {
			u_mi_getstubname stub : "__mi_impute_expr`i'"
			if (!strmatch(`"`rest'"',"*,*")) {
				local comma ,
			}
			local addopts noimpopts ivarsnotallowed(`notallowed')
			local addopts `addopts' ivarsallowed(`allowed') 
			local addopts `addopts' globalif(`"`if'"') stub(`stub')
			local addopts `addopts' globalwgt(`"`glb_wt'"')
			`showchk' _mi_impute_`method'_parse 	///
						`rest' `comma' `addopts' exprok
		}
		if _rc {
			local erreq 1
			local ++haserr
		}
		if ("`s(impopts)'"!="") {
			di as err "{bf:`s(impopts)'} not allowed"
			local erreq 1
			local ++haserr
		}
		if ("`s(nomiss)'"!="") {
			local nomisslist `nomisslist' `s(ivars)'
		}
		else { // build new equations based on s()
			local opts `s(opts)'
			local zero `s(zero)'
			if ("`noisily'"!="" & "`s(noisily)'"=="") {
				local opts `opts' `noisily'
				local zero `s(zero)' `noisily'
			}
			local uvmodel `uvmodel' (`zero')
			local expnames `expnames' `s(expnames)' 
			local explist `explist' `s(explist)'
			// build equations to display
			local eq_`n_eq' `method' `s(ivars)'
			local eq_`n_eq' `eq_`n_eq'' `s(xspec)' {bind:`s(if)'}
			if (`"`s(wgt)'"'!="[ ]") {
				local eq_`i' `eq_`n_eq'' {bind:`s(wgt)'}
			}
			if ("`opts'"!="") {
				local eq_`n_eq' `eq_`n_eq'' , `opts'
			}
			local methodmis `methodmis' `method'
			local ++n_eq
		}
		local allowed `allowed' `next'
		if (`erreq') {
			di as err "{p 1 3 2}"
			di as err "-- above applies to equation "	///
				  "{bf:(`lhs_`i'')}"
			di as err "{p_end}"
			di as err ""
		}
		else if ("`report'"!="") {
			di as txt "{p 1 3 2}"
			di as txt "-- above applies to equation "	///
				  "{bf:(`lhs_`i'')}"
			di as txt "{p_end}"
			di as txt ""
		}
		local ++i
	}
	if (`haserr') {
		exit 198
	}
	local ivarsinc : list ivarsinc - nomisslist
	if ("`report'"=="") {
		note_nomiss "`nomisslist'" "`ivarsinc'" "`nomissnote'"
	}
	if ("`ivarsinc'"=="") {
		local nomiss nomiss
	}
	if ("`dryrun'"!="" | "`verbose'"!="") {
		di
		di as txt "Conditional models:"
		tokenize `ivarsinc'
		local p: word count `ivarsinc'
		forvalues i=1/`p' {
			local name = abbrev("``i''", 14)
			local pos  = 14 - strlen("`name'")
			di "{p `pos' 17 2}"
                	di as txt `"{bf:`name'}: `eq_`i''"'
	                di "{p_end}"
		}
		di
		if ("`dryrun'"!="") {
			local stop stop
		}
	}
	if (`"`if'"'!="") {
		local glb_if	`"if `if'"'
	}
	local zero `"`uvmodel' `glb_if' , ivars(`ivarsinc')"'
	local zero `zero' expnames(`expnames') explist(`"`explist'"')
	local zero `zero' methods(`methodmis') `impopts' `opts' `monopts'
	sret clear
	sret local zero 	`"`zero'"'
	sret local nomiss	"`nomiss'"
	sret local stop		"`stop'"
	sret local noupdate	"`noupdate'"
end

program _mi_impute_mvn_parse, sclass

	// initial parse
	syntax [anything(equalok)] [if]	[,		/// 
			STUB(passthru)			/// //undoc. 
			NOCONStant			///
			EMONLY				///
			EMONLY1(passthru)		///
			MCMCONLY			///
			BURNin(integer 100)		///
			BURNBetween(integer 100)	///
			NOMISSNOTE			/// //undoc.
			INITMcmc(passthru)		///
			*				///
		]
	if (`"`emonly1'"'!="") {
		local emonly emonly
	}
	if (`"`emonly'"'!="") {
		local initmcmc		// ignore initmcmc()'s options
	}	
	if ("`mcmconly'"!="" & "`emonly'"!="") {
		di as err "{bf:mcmconly} and {bf:emonly} cannot be combined"
		exit 198
	}
	if (`burnin'<1) {
		di as err "{bf:burnin()} must be a positive integer"
		exit 198
	}
	if (`burnbetween'<1) {
		di as err "{bf:burnbetween()} must be a positive integer"
		exit 198
	}
	if (`"`initmcmc'"'!="") {
		_chk_initmcmcopts , `initmcmc'
	}
	else {
		_chk_emopts , `emonly1'
	}
	local opts `options' `noconstant' `emonly' `mcmconly' `emonly1'
	local opts `opts' burnin(`burnin') burnbetween(`burnbetween')
	local opts `opts' `initmcmc'

	sret clear
	_mi_impute_main_parse_rhs mvn , `opts' // returns s()
	local stop	`s(stop)'
	local opts	`s(opts)'
	local impopts	`s(impopts)'
	local noupdate	`s(noupdate)'
	if ("`emonly'"!="" | "`mcmconly'"!="") {
		local stop
	}
	if ("`stop'"!="") {
		exit
	}
	
	_mi_impute_main_parse_lhs `anything' `if', ///
				`noconstant' `stub' `nomissnote'
	local zero `s(xvars)' `s(if)'
	local zero `zero' , ivars(`s(ivars)') `impopts' `opts'

	sret local zero 	`"`zero'"'
	sret local impopts	"`impopts'"
	sret local opts		"`opts'"
	sret local noupdate 	"`noupdate'"
	if ("`emonly'"!="" | "`mcmconly'"!="") {
		sret local stop
		sret local nomiss
	}
end

program _mi_impute_chk_uvmethod, sclass
	gettoken method 0 : 0

	// parse utility opts
	_parse comma before after : 0
	local 0 `after'
	syntax	[,					/// 
			GLOBALIF(passthru)		/// //undoc.
			GLOBALWGT(passthru)		/// //undoc.
			IVARSALLOWED(passthru)		/// //undoc.
			IVARSNOTALLOWED(passthru)	/// //undoc.
			STUB(passthru)			/// //undoc.
			NOCONStant			///
			EXPROK				/// undoc.
			*				///
		]
	local opts `options' `noconstant'

	_mi_impute_main_parse_rhs `method' , `opts' // returns s()
	local stop 	`s(stop)'
	local impopts	`s(impopts)'
	local noisily	`s(noisily)'
	local opts	`s(opts)'
	local noupdate	`s(noupdate)'
	if ("`stop'"!="") {
		exit
	}
	
	_mi_impute_main_parse_lhs `before', `noconstant' uvmethod 	///
			ivarsmax(1) `globalif' `globalwgt'		///
			`ivarsallowed' `ivarsnotallowed' `stub' `exprok'
	local zero `s(xvars)' `s(if)' `s(in)' `s(wgt)'
	local zero `zero' , ivars(`s(ivars)') 
	local zero `zero' expnames(`s(expnames)') explist(`s(explist)')
	local zero `zero' `impopts' `opts'

	sret local zero 	`"`zero'"'
	sret local impopts	"`impopts'"
	sret local opts		"`opts'"
	sret local noupdate 	"`noupdate'"
	sret local noisily	"`noisily'"
end

program _mi_impute_monotone_buildeq, sclass
	_parse comma l 0 : 0
	syntax [, NOMONOTONECHK NOMISSNOTE NOVARSCHK ]
	// parse <indepspec> and [if]
	gettoken lhs xspec : l, parse("=") bind
	gettoken eq xspec : xspec, parse("=")
	if (`"`xspec'"'=="") {
		local 0 `lhs'
		syntax [anything(equalok)] [if] [fw aw pw iw]
		local lhs `anything'
	}
	else {
		local 0 `xspec'
		syntax [anything(equalok)] [if] [fw aw pw iw]
		local xspec `anything'
	}
	if ("`weight'"!="") {
		local wgtexp [`weight' `exp']
	}

	// build imp. var. list
	gettoken spec rest : lhs, parse("()") match(par)
	if "`par'"!="(" {
		di as err "imputation method specification must be "	///
			  "bound in parentheses"
		exit 198
	}
	local continue 1
	local i 1
	while(`continue') {
		local eq (`spec')
		gettoken spec rest : rest, parse("()") match(par)
		if (`"`spec'"'=="") | ("`par'"=="(") {
			di as err "imputation variable required"
			exit 198
		}
		while "`par'"!="(" {
			unab spec : `spec'
			local cnt : word count `spec'
			forvalues j=1/`cnt' {
				local eq_`i' `eq'
				local ++i
			}
			local ivars `ivars' `spec'
			gettoken spec rest : rest, parse("()") match(par)
			if (`"`spec'"'=="") {
				local continue 0
				continue, break
				/* NOTREACHED */
			}
		}	
	}
	// check ivars are not specified more than once
	local dups : list dups ivars
	if ("`dups'"!="") {
		local uniq: list uniq dups
		local n: word count `uniq'
		di as err "{p 0 0 2}{bf:`uniq'}: duplicates found;{p_end}" 
		di as err "{p 4 4 2}imputation variables cannot be " /// 
			 "specified multiple times{p_end}"
		exit 198		
	}
	u_mi_mustbe_registered_imputed bad : "`ivars'"
	// check if <ivars> are monotone
	if ("`nomonotonechk'"=="") {
		_chk_monotone `ivars' `if'
		local ivarsinc  `s(ivarsinc)'
		local ivarsc 	`s(ivarsc)'
		local stmt1wc	`s(stmt1wc)'
		local ivarsmonotone `s(ivarsmonotone)'
		// show even if -nomonotonechk-
		// display a no-missing-values note
		note_nomiss "`ivarsc'" "`ivarsinc'" "`nomissnote'"
		local nomiss `s(nomiss)'
		if ("`nomiss'"!="") {
			sret local nomiss nomiss
			exit
		}
	}
	else {
		local ivarsmonotone `ivars'
	}
	// build equations
	gettoken ivar ivarsmonotone : ivarsmonotone
	local condspec `xspec'
	if (`"`condspec'"'!="" & "`novarschk'"=="") {
		_chk_ts `xspec'
		fvunab xvars : `xspec'
		local xlist `xvars'
		unopvarlist `xvars'
		local xvars `r(varlist)'
		confirm numeric variable `xvars'
		local condspec `xlist'
	}
	while("`ivar'"!="") {
		local pos : list posof "`ivar'" in ivars
		local eq  `eq_`pos''
		gettoken eq : eq, match(par)
		_parse comma l r : eq
		gettoken method l : l
		_mi_impute_chkmethod method : ///
				`"`method'"' "mi impute monotone" uvonly
		if (inlist(`"`method'"',"logit","ologit","mlogit")) {
			local fvop i.
		}
		else {
			local fvop
		}
		local uvlist `uvlist' (`method' `ivar' `condspec' `l' `r')
		local condspec `fvop'`ivar' `condspec'
		local ivarsordered `ivarsordered' `ivar'
		gettoken ivar ivarsmonotone : ivarsmonotone
	}
	sret local uvlist 	`"`uvlist' `if' `wgtexp'"'
	sret local nomiss  	"`nomiss'"
	sret local ivarsinc	"`ivarsordered'"
end

program _mi_impute_main_parse_rhs, sclass
	gettoken method 0 : 0
	u_mi_impute_get_cmdopts `method'
	local ADDOPTS `s(opts)'

	// check global -impopts-
	syntax	[, 					///
			ADD(string)			///
			REPLACE				///
			RSEED(string)			///
			DOUBLE				///
			DOTS				///
			NOUPdate			///
			FORCE				///
			NOIMPOPTS			/// //undoc.
			NOIMPCHK			/// //undoc.
			*				/// //<method> opts
		]
	local impopts : list 0 - options
	local comma , `noimpopts'
	local impopts : list impopts - comma
	local opts `options'
	local 0 , `opts'
	syntax [, `ADDOPTS' ]
	if ("`noimpopts'"!="") {
		sret local impopts 	"`impopts'"
		sret local opts 	`"`opts'"'
		sret local noisily	"`noisily'"
		sret local noupdate 	"`noupdate'"
		sret local stop 	""
		exit
	}
	// if M>0, -replace- or -add()- must be specified
	local M `_dta[_mi_M]'
if "`emonly'`mcmconly'"=="" & "`noimpchk'"=="" { // add(), replace begin
	if (`M') {
		if ("`add'`replace'"=="") {
			di as err "{bf:mi impute}: imputations exist" 
			di as err "{p 4 4 2}{bf:`M'} " 			///
			   plural(`M',"imputation") 			///
			   " found; use {bf:replace} to replace "	///
			   "existing and/or {bf:add()} "	///
			   "to add new imputations.  Before adding "	///
			   "new imputations, verify that the same "	///
			   "imputation model is specified.{p_end}"
			exit 198
                }
		if ("`add'"=="0" & "`replace'"=="") {
			di as txt "(no imputations to add)"
			local stop stop
		}
        }
	else if ("`add'"=="") {
		di as err "option {bf:add()} is required "	///
			  "when no imputations exist"
		exit 198
	}
	else if ("`add'"=="0") {
		di as txt "(no imputations to add)"
		local stop stop
	}
	// -add()-
	if ("`add'"!="") {
		cap confirm integer number `add'
		if (_rc) {
			di as err "{bf:add()} must be a positive integer"
			exit 198
		}
		if (`add'<=0) {
			di as err "{bf:add()} must be a positive integer"
			exit 198
		}
		local M_total = `M' + `add'
		if (`M_total'>1000) {
di as err "{bf:add(`add')} results in {it:M} = `M_total'" ///
  	  " exceeding the limit of 1000"
di as err "{p 4 2 0}{bf:add()} must be between"
di as err "1 and `=1000-`M'', inclusive{p_end}"
exit 198
		}
	}
} // add(), replace end

	// remove -noupdate-
	local 0 , `impopts'
	syntax [, NOUPdate * ]
	local impopts `options'

	sret local impopts 	"`impopts'"
	sret local opts 	`"`opts'"'
	sret local noupdate 	"`noupdate'"
	sret local noisily	"`noisily'"
	sret local stop	  	"`stop'"
end

program _mi_impute_main_parse_lhs, sclass
	// check left-hand-side specification
	qui syntax [anything(equalok)] [if/] [in] [fw aw pw iw]	///
			[, 					///
				UVMETHOD			/// // undoc.
				GLOBALIF(string)		/// // undoc.
				GLOBALWGT(string)		/// // undoc.
				IVARSALLOWED(varlist)		/// // undoc.
				IVARSNOTALLOWED(varlist)	/// // undoc.
				STUB(name)			/// // undoc.
				NOCONStant			///
				IVARSMAX(passthru)		///
				NOMISSNOTE			///
				EXPROK				/// 
			]
	if ("`exprok'"=="") {
		local noexpr noexpr
	}
	tempvar touse
	if (`"`if'"'!="") {
		local holdif if (`if')
	}
	mark `touse' `holdif' `in'		// analysis sample
	if ("`weight'"!="" & `"`globalwgt'"'!="") {
		di as err "{bf:mi impute monotone}: incompatible weights"
		di as err "{p 4 4 2 0}equation-specific weights,"
		di as err `"{bf:[`weight' `exp']}, cannot be combined with"'
		di as err `"the global weight, {bf:`globalwgt'}{p_end}"'
		exit 198
	}
	else if ("`globalwgt'"!="") {
		local wgtexp `globalwgt'
	}
	else {
		local wgtexp [`weight' `exp']
	}
	local opts `options'
	if (`"`globalif'"'!="" & `"`if'"'!="") {
		local holdif `holdif' & (`globalif')
	}
	else if (`"`globalif'"'!="") {
		local holdif if (`globalif')
	}
	local holdin `in'
	if ("`indent'"=="") {
		local indent 0 4 2
	}
	if ("`errindent'"=="") {
		local errindent 0 4 2
	}
	// parse and check <ivars>
	gettoken ivars aftereq: anything, parse("=")
	gettoken eq xspec: aftereq, parse("=")
	if ("`eq'"=="" & "`uvmethod'"!="") {
		gettoken ivars xspec: ivars, parse(" ")
	}
	_mi_impute_chk_ivars `ivars', `ivarsmax'
	local ivars `s(ivars)'
	local p: word count `ivars'
	// check <xspec>
	if ("`noexpr'"=="") {
		_mi_impute_chk_xspec `xspec', stub(`stub')		///
				      ivarsallowed(`ivarsallowed')	///
				      ivarsnotallowed(`ivarsnotallowed' `ivars')
		local xvars 	`s(xvars)'		// unabbr.
		local expnames 	`s(expnames)'
		local explist 	`"`s(explist)'"'
		local xlist 	`s(xlist)'	// resulting 'varlist', unabbr.
	}
	else if (`"`xspec'"'!="") {
		_chk_ts `xspec'
		fvunab xvars : `xspec'
		local xlist `xvars'
		unopvarlist `xvars'
		local xvars `r(varlist)'
		confirm numeric variable `xvars'
	}
	local q : word count `xlist'
	if (`q'>0 & "`noexpr'"=="") {
		// generate vars from expressions here
		mata: st_local("tmpvars", invtokens(st_tempname(`r(k_exp)')))
		qui u_mi_impute_genexpr "`tmpvars'" `"`explist'"'
		local explist `s(elist)'	// list of expressions
	}
	local allxvars `xvars' `tmpvars' // xvars + expression vars
	local allxvars : list allxvars - ivarsallowed
	// -noconstant-
	if ("`xlist'"=="" & "`noconstant'"!="") {
		di as err as smcl "{p `errindent'}{bf:noconstant} is " 	///
				  "not allowed without independent "	///
				  "variables{p_end}"
		exit 198
	}
	// check if imputed vars are used as regressors
	local bad : list ivars & xvars
	if ("`bad'"!="") {
		local n : word count `bad'
		di as err "{p `errindent'}"			///
			  "{bf:`bad'}: cannot be used "		///
			  "as independent " 			///
			  plural(`n',"variable") "{p_end}"
		exit 198
	}
	// check if any not-allowed-imp. vars are used as regressors
	local bad : list ivarsnotallowed & xvars
	if ("`bad'"!="") {
		local n : word count `bad'
		di as err "{p 0 4 2}" plural(`n',"variable") 
		di as err " {bf:`bad'} used to model"
		di as err "{bf:`ivars'} and " plural(`n',"has","have")
		di as err "at least as many missing values as"
		di as err "{bf:`ivars'}; this is not allowed{p_end}"
		exit 198
	}
	// check if any registered imp. vars are used as regressors
	local imputed	`_dta[_mi_ivars]'
	local tochk : list imputed - ivarsallowed
	local bad : list tochk & xvars
	if ("`bad'"!="") {
		local n1: word count `bad'
		local n2: word count `ivars'
		di as txt "{p 0 6 2}note: " plural(`n1',"variable") 	/// 
			  " {txt:`bad'} registered as "		///
			  "imputed and used to model "		///
			  plural(`n2',"variable") 		///
			  " {txt:`ivars'}; this may cause "	///
			  "some observations to be omitted "  	///
			  "from the estimation and may lead "	///
			  "to missing imputed values{p_end}"	
	}
	// further checks require `touse'
	// 'touse' must refer to the analysis sample
	markout `touse' `ivars', sysmissok
	// must use m0
	local style `_dta[_mi_style]'
	if ("`style'"=="mlong" | "`style'"=="flong") {
		qui replace `touse' = 0 if _mi_m>0
	}
	// check if <ivars> have missing
	qui _mi_ivars_musthave_missing nbadvars bad : ///
				"`ivars'" "`touse'" "nomissok" "`indent'"
	local ivarscmsg hasincomplete
	if (`nbadvars'==`p') {
		local ivarscmsg
		local nomiss nomiss
	}
	note_nomiss "`bad'" "`ivarscmsg'" "`nomissnote'"
	tempvar esamp
	mark `esamp' `holdif' `holdin' `wgtexp'
	markout `esamp' `ivars'
	if ("`style'"=="mlong" | "`style'"=="flong") {
		qui replace `esamp' = 0 if _mi_m>0
	}
	if ("`xlist'"!="") {
		// 'esamp' must refer to the estimation sample
		markout `esamp' `allxvars'	
	}
	tokenize `ivars'
	forvalues i=1/`p' {
		local ifivars `ifivars' `and' ``i''<.
		local and &
	}
	qui count if `esamp' & `ifivars'

	sret local ivars 	`"`ivars'"'
	sret local xvars 	`"`xlist'"'
	sret local xspec 	`"`xspec'"'
	sret local if 	 	`"`holdif'"'
	sret local in  		`"`holdin'"'
	sret local wgt	 	`"`wgtexp'"'
	sret local weight	"`weight'"
	sret local nomiss	"`nomiss'"
	sret local expnames	"`expnames'"
	sret local explist	"`explist'"
end

program _mi_impute_chk_ivars, sclass

	syntax [anything] [, IVARSMAX(string) ]

	if (`"`anything'"'=="") {
		di as err "{p `errindent'}"	///
			"imputation (left-hand-side) variable required{p_end}"
		exit 100
	}
	unab ivars : `anything'
	local errindent 0 4 2
	local p: word count `ivars'
	if ("`ivarsmax'"!="") {
		if (`p'>`ivarsmax') {
			di as err "{p `errindent'}"	///
			  "too many imputation variables specified{p_end}"
			exit 103
		}
	}
	confirm numeric variable `ivars'
	// ivars must be registered as imputed
	local imputed	`_dta[_mi_ivars]'
	local bad `ivars'
	unab  bad: `bad'
	local bad: list bad - imputed
	if ("`bad'"!="") {
		di as err "{p `errindent'}{bf:`bad'}: must be registered " ///
			 "as imputed; see " ///
  			 "{helpb mi register:{bind:mi register}}{p_end}"
		exit 198
	}
	sret local ivars "`ivars'"	// unabb. <ivars>
end

program _mi_impute_chk_xspec, sclass
	syntax [anything] [, 					///
				STUB(name)			///
				IVARSALLOWED(varlist)		///
				IVARSNOTALLOWED(varlist)	///
				ERRNAME(string)			///
			  ]
	local xspec `anything'
	// check <xspec>
	local q: word count `xspec'
	if (`q'>0) {
		// parse and check expressions
		if ("`stub'"=="") {
			u_mi_getstubname stub : "__mi_impute_expr"
		}
		u_mi_impute_parse_exp_ivars `xspec', 			///
					stub(`stub')			///
					errname(`errname')		///
					ivarsallowed(`ivarsallowed')	///
					ivars(`ivarsnotallowed')
	}
		
	sret local xvars 	`r(xvars)'	// unabbr.
	sret local expnames	`r(expnames)'
	sret local explist	`r(explist)'
	sret local xlist 	`"`r(xlist)'"'	// resulting 'varlist', unabbr.
end

program _chk_monotone, sclass

	syntax [varlist] [if] [in]
	local ivars `varlist'

	marksample touse, novarlist
	markout `touse' `ivars', sysmissok
 
	qui mi misstable nested `ivars' if `touse'
	local misstablevars `r(vars)'
	local ivarsc  : list ivars - misstablevars
	// ivarsinc != misstablevars because of the variable order
	local ivarsinc: list ivars - ivarsc 
	if ("`ivarsinc'"!="") {
		local stmt1wc `r(stmt1wc)'
		local is_monotone = (r(K)==1)
		if (!`is_monotone') {
			di as err ///
			   "{p 0 0 2}{bf:`ivars'}: not monotone;{p_end}" 
			di as err "{p 4 4 2}imputation variables must " /// 
			   "have a monotone-missing structure; see "	///
			   "{helpb mi_misstable:mi misstable nested}{p_end}"
			exit 459
		}
	}
	local ivarsmonotone `r(stmt1)'
	local ivarsmonotone : subinstr local ivarsmonotone `"<-> "' `""', all
	local ivarsmonotone : subinstr local ivarsmonotone `"-> "' `""', all
	
	sret local ivarsinc	"`ivarsinc'"
	sret local ivarsc	"`ivarsc'"
	sret local stmt1wc 	"`r(stmt1wc)'"

	sret local ivarsmonotone "`ivarsmonotone'"
end


program _mi_ivars_musthave_missing

	args nvars vars colon varlist touse noerror indent

	if ("`varlist'"=="") { 
		exit
	}
	if ("`indent'"=="") {
		local indent 0 4 2
	}
	if ("`noerror'"=="") {
		local font bf
		local dias err
		local rc = 459
	}
	else {
		local font bf
		local dias txt
		local rc = 0
	}

	local haserr 0 
	local bad
	foreach var of local varlist { 
		qui count if `var'==. & `touse'
		if (r(N)==0) {
			if (`haserr') { 
				di as smcl " {`font':`var'}" _c
				local bad `bad' `var'
			}
			else { 
				di as `dias' as smcl "{p `indent'}"
				di as smcl "{`font':`var'}" _c
				local bad `bad' `var'
			}
			local ++haserr
		}
	}
	c_local `nvars' "`haserr'"
	c_local `vars' "`bad'"
	if (`haserr') { 
		exit `rc'
	}
end


/*
	_mi_impute_mapmethod <lmac> : <methods>

	returns unabbreviated names of <methods> in `method'.
	The methods are
		reg:ress
		pmm
		logi:t
		olog:it

		mon:otone
		mvn

*/
program _mi_impute_mapmethod

	args lmac colon methods errout

	if ("`methods'"=="") {
		di as err as smcl 	///
		   "you must specify imputation method with {helpb mi impute}"
		exit 198
	}

	local p: word count `methods'
	if (`p'==1) {
		_mi_impute_chkmethod umethod : "`methods'" "`errout'"
		c_local `lmac' "`umethod'"
		exit
	}

	tokenize `methods'
	forvalues i=1/`p' {
		_mi_impute_chkmethod umethod : "``i''" "`errout'"
		local umlist `umlist' `umethod'
	}
	c_local `lmac' "`umlist'"
end

program _mi_impute_chkmethod

	args mac colon method errout uvonly

	local l = strlen("`method'")

	if ("`method'"==substr("regress",1,max(3,`l'))) {
		c_local `mac' "regress"
		exit
	}
	if ("`method'"=="pmm") {
		c_local `mac' "pmm"
		exit
	}
	if ("`method'"==substr("logit",1,max(4,`l'))) {
		c_local `mac' "logit"
		exit
	}
	if ("`method'"==substr("mlogit",1,max(4,`l'))) {
		c_local `mac' "mlogit"
		exit
	}
	if ("`method'"==substr("ologit",1,max(4,`l'))) {
		c_local `mac' "ologit"
		exit
	}
	if ("`uvonly'"=="" & "`method'"==substr("monotone",1,max(3,`l'))) {
		c_local `mac' "monotone"
		exit
	}
	if ("`uvonly'"=="" & "`method'"=="mvn") {
		c_local `mac' "mvn"
		exit
	}
	if ("`errout'"=="") {
		local errout "{bf:mi impute}: "
	}
	else if ("`errout'"=="nothing") {
		local errout
	}
	else {
		local errout "{bf:`errout'}: "
	}
	if ("`method'"=="") {
		di as err `"`errout'imputation method must be specified"'
	}
	else {
		di as err `"`errout'invalid imputation method {bf:`method'}"'
	}
	exit 198
end

program note_nomiss, sclass
	args ivarsc ivarsinc nonote

	if ("`nonote'"!="") exit

	if ("`ivarsinc'"!="") { // not all ivars complete
		local semicolon ;
	}
	// completely-observed imputation variables
	local n : word count `ivarsc'
	if (`n'>0) {
		di as txt "{p 0 6 2}note: " plural(`n',"variable")
		di as txt " {txt:`ivarsc'} " plural(`n',"contains","contain") 
		di as txt " no soft missing (.) values`semicolon'"
		if ("`ivarsinc'"=="") {
			di as txt "{p_end}"
			di as txt "(imputation " 			///
			   plural(`n', "variable is ", "variables are ") ///
			  "complete; imputing nothing)"
			local nomiss nomiss
		}
		else {
			di as txt "imputing nothing{p_end}"
		}
	}
	sret local nomiss `nomiss'
end

program _chk_expr_allowed
	local specout colon exprok specin

	if ("`exprok'"=="") {
		c_local `specout' `specin'
		exit
	}

	_parse comma l r : specin
	if (`"`r'"'=="") {
		c_local `specout' `l', noexpr
	}
	else {
		c_local `specout' `l' `r' noexpr
	}
end

program _chk_ts
	syntax [varlist(default=none fv)]
end

program _chk_initmcmcopts
	syntax [, INITMcmc(string asis) ]
	local 0 `initmcmc'
	syntax [anything(id="initmcmc()" name=type)] [, * ]
	if ("`type'"=="em" | "`type'"=="") {
		_chk_emopts, `options'
	}
end

program _chk_emopts

	syntax [, EMONLY1(string asis) * ]
	if (`"`emonly1'"'!="") {
		local 0 , `emonly1'
	}

	syntax [,					/// 
			ITERate(integer 100)		///
			TOLerance(real 1e-5)		///
			INIT(string)			///
			NOLOG				///
			SAVEPtrace(string asis)		///
			*				///
	]

	if (`tolerance'<0) {
		di as err "{bf:tolerance()} must be a nonnegative number"
		exit 198
	}
end
