{smcl}
{* *! version 1.0.4  18mar2011}{...}
{cmd:help mi impute regress}{right:dialog:  {dialog mi}}
{hline}

{title:Title}

{p2colset 5 31 33 2}{...}
{p2col :{manlink MI mi impute regress} {hline 2}}Impute using linear regression{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 19 2}{cmd:mi} {cmdab:imp:ute} {cmdab:reg:ress} 
{it:ivar} [{it:{help indepvars}}] [{it:{help if}}] {weight}
[{cmd:,} {it:{help mi_impute##impopts:impute_options}} {it:options}] 

{synoptset 22 tabbed}{...}
{synopthdr:options}
{synoptline}
{syntab:Main}
{synopt: {opt nocons:tant}}suppress constant term{p_end}
{synoptline}
{p 4 6 2}
You must {cmd:mi set} your data before using {cmd:mi} {cmd:impute}
{cmd:regress}; see {manhelp mi_set MI:mi set}.{p_end}
{p 4 6 2}
{cmd:aweight}s, {cmd:fweight}s, {cmd:iweight}s, and {cmd:pweight}s are
allowed; see {help weight}.{p_end}


{title:Menu}

{phang}
{bf:Statistics > Multiple imputation}


{title:Description}

{pstd}
{cmd:mi} {cmd:impute} {cmd:regress} fills in missing values of a continuous
variable using the Gaussian normal regression imputation method.  You can
perform separate imputations on different subsets of the data by specifying an
{cmd:if} condition.  You can also account for frequency, analytic, importance,
and sampling weights.


{title:Options}

{dlgtab:Main}

{phang}
{opt noconstant}; see {manhelp estimation_options R: estimation options}.

{phang}
{cmd:add()}, {cmd:replace}, {cmd:seed()}, {cmd:double}; see
{manhelp mi_impute MI:mi impute}.

{dlgtab:Reporting}

{phang}
{cmd:dots}, {cmd:noisily}; see {manhelp mi_impute MI:mi impute}.
{cmd:noisily} specifies that the output from a linear regression fit to the
observed data be displayed.

{dlgtab:Advanced}

{phang}
{cmd:force}; see {manhelp mi_impute MI:mi impute}.

{phang}
{cmd:noupdate}; see {manhelp noupdate_option MI:noupdate option}.


{title:Examples}

{pstd}
{it:Stata's normal pseudorandom-number generator} {cmd:rnormal()}
{it:was updated in Stata 11.2.  To reproduce the results shown in the}
{it:PDF documentation, prefix the} {cmd:mi impute} {it:command with}
{cmd:version 11.1}, {it:for example,}

{phang2}
        {cmd:. version 11.1: mi impute regress lnbmi attack smokes age hsgrad}
           {cmd:female, add(20) rseed(2232)}

{pstd}
{it:See} {help whatsnew} {it:for information about the update to}
{cmd:rnormal()}.


{pstd}
Impute {cmd:bmi} using linear regression
{p_end}
{phang2}
{cmd:. webuse mheart1s0}
{p_end}
{phang2}
{cmd:. mi describe}
{p_end}
{phang2}
{cmd:. mi impute regress bmi attack smokes age female hsgrad, add(20)}
{p_end}

{pstd}
Impute {cmd:bmi} in ln({cmd:bmi}) metric
{p_end}
{phang2}
{cmd:. webuse mheart0}
{p_end}
{phang2}
{cmd:. generate lnbmi = ln(bmi)}
{p_end}
{phang2}
{cmd:. mi set mlong}
{p_end}
{phang2}
{cmd:. mi register imputed lnbmi }
{p_end}
{phang2}
{cmd:. mi impute regress lnbmi age attack smokes age hsgrad female, add(20) rseed(2232)}
{p_end}
{phang2}
{cmd:. mi register passive bmi}
{p_end}
{phang2}
{cmd:. mi passive: replace bmi = exp(lnbmi)}
{p_end}


{title:Saved results}

{pstd}
{cmd:mi} {cmd:impute} {cmd:regress} saves the following in {cmd:r()}:

{synoptset 25 tabbed}{...}
{p2col 5 25 29 2: Scalars}{p_end}
{synopt:{cmd:r(M)}}total number of imputations{p_end}
{synopt:{cmd:r(M_add)}}number of added imputations{p_end}
{synopt:{cmd:r(M_update)}}number of updated imputations{p_end}
{synopt:{cmd:r(k_ivars)}}number of imputed variables (always one){p_end}

{synoptset 25 tabbed}{...}
{p2col 5 25 29 2: Macros}{p_end}
{synopt:{cmd:r(method)}}name of imputation method ({cmd:regress}){p_end}
{synopt:{cmd:r(ivars)}}names of imputation variables{p_end}
{synopt:{cmd:r(rseed)}}random-number seed used{p_end}

{synoptset 25 tabbed}{...}
{p2col 5 25 29 2: Matrices}{p_end}
{synopt:{cmd:r(N)}}number of observations in imputation sample{p_end}
{synopt:{cmd:r(N_complete)}}number of complete observations in imputation sample
{p_end}
{synopt:{cmd:r(N_incomplete)}}number of incomplete observations in imputation sample
{p_end}
{synopt:{cmd:r(N_imputed)}}number of imputed observations in imputation sample{p_end}


{title:Also see}

{psee}
Manual:  {manlink MI mi impute regress}

{psee}
{space 2}Help:  
{bf:{help mi_impute:[MI] mi impute}},
{manhelp mi_impute_pmm MI:mi impute pmm},
{manhelp mi_estimate MI:mi estimate},
{manhelp mi MI}
{p_end}
