{smcl}
{* *! version 1.1.2  15oct2009}{...}
{cmd:help ml score}
{hline}

{title:Title}

{pstd}
{hi:ml score} {hline 2}
Generating scores after maximum likelihood estimation


{title:Syntax}

{pstd}
Syntax for the scores from a specified equation:

{pmore}
{cmd:ml} {cmd:score} {newvar} {ifin}
	[{cmd:,}
		{opt eq:uation(eqname)}
		{opt miss:ing}
	]


{pstd}
Syntax for the scores from all equations:

{pmore}
{cmd:ml} {cmd:score} {it:newvarlist} {ifin}
	[{cmd:,} {opt miss:ing}]

{pmore}
{cmd:ml} {cmd:score} [{it:type}] {it:stub}{cmd:*} {ifin}
	[{cmd:,} {opt miss:ing}]


{title:Description}

{pstd}
{cmd:ml} {cmd:score} creates new variables containing the equation-level
scores.  The variables generated by {cmd:ml} {cmd:score}
are equivalent to those generated by specifying the {opt score()} to {cmd:ml}
{cmd:maximize} (and {cmd:ml} {cmd:model} ... {cmd:,} ... {cmd:maximize}).


{title:Options}

{phang}
{opt equation(eqname)} identifies from which equation the observation scores are
to come.  This option may be used only when generating one variable.

{phang}
{opt missing} specifies that observations containing variables with
missing values not be eliminated from the estimation sample.


{title:Remarks}

{pstd}
{cmd:ml} {cmd:score} is always allowed when used after estimation commands
that use method lf likelihood evaluators.

{pstd}
It is an error to call {cmd:ml} {cmd:score} after estimation commands that do
not use method lf, d1, or d2 likelihood evaluators.


{title:Examples}

{pstd}
Single-equation model:{p_end}

{phang}{cmd:. poisson accidents}{p_end}
{phang}{cmd:. ml score score}{p_end}

{pstd}
Two-equation model (generates variables {cmd:sc_1} and {cmd:sc_2}):{p_end}

{phang}{cmd:. nbreg deaths coh2 coh3, exposure(obstime)}{p_end}
{phang}{cmd:. ml score sc_*}{p_end}

{pmore}
or

{phang}{cmd:. nbreg deaths coh2 coh3, exposure(obstime)}{p_end}
{phang}{cmd:. ml score sc_1, equation(#1)}{p_end}
{phang}{cmd:. ml score sc_2, equation(#2)}{p_end}


{title:Also see}

{psee}
Manual:  {manlink R ml}

{psee}
{space 2}Help:  {manhelp ml R},
{manhelp predict R}
{p_end}
