{smcl}
{* *! version 1.0.7  03jun2010}{...}
{cmd:help set showbaselevels}, {cmd:help set showemptycells}
{cmd:help set showomitted}
{hline}

{title:Title}

{phang}Display settings for coefficient tables


{title:Syntax}

{p 8 16 2}
{cmd:set}
{cmd:showbaselevels}
[{opt on}|{opt off}|{opt all}]
[{cmd:,} {cmdab:perm:anently}]

{p 8 16 2}
{cmd:set}
{cmd:showemptycells}
[{opt on}|{opt off}]
[{cmd:,} {cmdab:perm:anently}]

{p 8 16 2}
{cmd:set}
{cmd:showomitted}
[{opt on}|{opt off}]
[{cmd:,} {cmdab:perm:anently}]


{title:Description}

{pstd}
{cmd:set} {cmd:showbaselevels} specifies whether to display base levels of
factor variables and their interactions in coefficient tables.  {cmd:set}
{cmd:showbaselevels} {cmd:on} specifies that base levels be reported for
factor variables and for interactions whose bases cannot be inferred from
their component factor variables.  {cmd:set} {cmd:showbaselevels} {cmd:all}
specifies that all base levels of factor variables and interactions be
reported.

{pstd}
{cmd:set} {cmd:showemptycells} specifies whether to display empty cells
in coefficient tables.

{pstd}
{cmd:set} {cmd:showomitted} specifies whether to display omitted
coefficients in coefficient tables.


{title:Option}

{phang}
{cmd:permanently} specifies that, in addition to making the change right now,
the setting be remembered and become the default setting when you invoke Stata.


{title:Example}

{phang}
Show all base levels for factor variables
and interactions but suppress empty cells and omitted predictors

{pmore2}
{cmd:. set showbaselevels all}{break}
{cmd:. set showemptycells off}{break}
{cmd:. set showomitted off}

{phang}
Reset the display of baselevels, empty cells, and omitted predictors to the
command-specific default behavior

{pmore2}
{cmd:. set showbaselevels}{break}
{cmd:. set showemptycells}{break}
{cmd:. set showomitted}


{title:Also see}

{psee}
Manual:  {manlink R query} (forthcoming),{break}
{manlink R set} (forthcoming)

{psee}
{space 2}Help:  {manhelp query R}, {manhelp set R}
{p_end}
