{smcl}
{* *! version 1.2.2  08jun2010}{...}
{cmd:help small stata}{right:{browse "http://www.stata.com"}}
{hline}

{title:Using Small Stata}

{pstd}
There are four flavors of Stata:

{col 13}{it:flavor}{col 29}{it:description}
{col 13}{hline 47}
{col 10}-> {bf:Small Stata}{col 29}for undergraduate students
{col 13}{bf:Stata/IC}{col 29}standard version 
{col 13}{bf:Stata/SE}{col 29}Stata/IC + large datasets
{col 13}{bf:Stata/MP}{col 29}Stata/SE + parallel processing
{col 13}{hline 47}
{col 13}See {bf:{help flavors:[U] 5 Flavors}} for descriptions

{pstd}
To determine which flavor of Stata you are running, type

	    {cmd:. about}

{pstd}
If you are using a different flavor of Stata, click on the appropriate
link:  

{col 13}{hline 47}
{col 13}{bf:{help stataic:Stata/IC}}{col 29}Using Stata/IC
{col 13}{bf:{help statase:Stata/SE}}{col 29}Using Stata/SE
{col 13}{bf:{help statamp:Stata/MP}}{col 29}Using Stata/MP
{col 13}{hline 47}

{pstd}
For information on upgrading to Stata/IC, Stata/SE or Stata/MP, point your
browser to {browse "http://www.stata.com"}.


{title:Contents}

	{help small_stata##starting:1.  Starting Small Stata}
	{help small_stata##setting:2.  Small Stata's limits}
	{help small_stata##dta:3.  Sharing .dta datasets with other users}
	{help small_stata##programming:4.  Advice to programmers:  Determining flavor}


{marker starting}{...}
{title:1.  Starting Small Stata}

{pstd}
You start Small Stata as follows:

{p 8 12 4}
    Windows:{break}
	Select {bf:Start > Programs > Stata > Small Stata {ccl stata_version}}

{p 8 12 4}
    Mac:{break}
        Double-click the file {hi:Stata.do} from the {hi:data} folder, or
        double-click the {hi:smStata} icon from the {hi:Stata} folder.

{p 8 12 4}
    Unix:{break}
        Small Stata is not available for Unix.


{marker setting}{...}
{title:2.  Small Stata's limits}

{pstd}
Small Stata is the special version of Stata for student use, and allows 
datasets of 99 variables and 1,000 observations.
The maximum number of variables in a model is 40.
These limits may not be reset.


{marker dta}{...}
{title:3.  Sharing .dta datasets with other users}

{pstd}
Datasets created by Small Stata may be used with any flavor of Stata.


{marker programming}{...}
{title:4.  Advice to programmers:  Determining flavor}

{pstd}
Programmers can determine which flavor of Stata is running by 
examining the {help creturn} values

		                 creturn values
                        {c |} {cmd:c(flavor)   c(SE)     c(MP)}
	    {hline 12}{c +}{hline 30}
	    Small Stata {c |}  "{cmd:Small}"      0         0
	    Stata/IC    {c |}  "{cmd:IC}"         0         0
	    Stata/SE    {c |}  "{cmd:IC}"         1         0
	    Stata/MP    {c |}  "{cmd:IC}"         1         1
	    {hline 12}{c BT}{hline 30}


{title:Also see}

{psee}
{space 2}Help:  
{manhelp about R},
{manhelp data_types D:data types},
{manhelp matsize R},
{manhelp memory D},
{manhelp set R},
{manhelp flavors U-5:Flavors},
{help limits},
{help stataic:Stata/IC},
{help statamp:Stata/MP},
{help statase:Stata/SE}
{p_end}
