{smcl}
{* *! version 1.2.10  18mar2010}{...}
{cmd:help streg} {right:dialogs:  {dialog streg}  {dialog streg, message(-svy-) name(svy_streg):svy: streg}{space 3}}
{right:also see:  {help streg postestimation}}
{hline}

{title:Title}

{p2colset 5 19 21 2}{...}
{p2col :{manlink ST streg} {hline 2}}Parametric survival models{p_end}
{p2colreset}{...}


{title:Syntax}

{p 8 16 2}{cmd:streg} [{varlist}] {ifin} [{cmd:,} {it:options}]

{marker options}{...}
{synoptset 29 tabbed}{...}
{synopthdr}
{synoptline}
{syntab:Model}
{synopt :{opt nocon:stant}}suppress constant term{p_end}
{synopt :{cmdab:d:istribution(}{cmdab:e:xponential)}}exponential survival distribution{p_end}
{synopt :{cmdab:d:istribution(}{cmdab:gom:pertz)}}Gompertz survival distribution{p_end}
{synopt :{cmdab:d:istribution(}{cmdab:logl:ogistic)}}loglogistic survival distribution{p_end}
{synopt :{cmdab:d:istribution(}{cmdab:ll:ogistic)}}synonym for {cmd:distribution(loglogistic)}{p_end}
{synopt :{cmdab:d:istribution(}{cmdab:w:eibull)}}Weibull survival distribution{p_end}
{synopt :{cmdab:d:istribution(}{cmdab:logn:ormal)}}lognormal survival distribution{p_end}
{synopt :{cmdab:d:istribution(}{cmdab:ln:ormal)}}synonym for {cmd:distribution(lognormal)}{p_end}
{synopt :{cmdab:d:istribution(}{cmdab:gam:ma)}}generalized gamma survival distribution{p_end}
{synopt :{cmdab:fr:ailty(}{cmdab:g:amma)}}gamma frailty distribution{p_end}
{synopt :{cmdab:fr:ailty(}{cmdab:i:nvgaussian)}}inverse-Gaussian distribution{p_end}
{synopt :{opt ti:me}}use accelerated failure-time metric{p_end}

{syntab:Model 2}
{synopt :{opth st:rata(varname)}}strata ID variable{p_end}
{synopt :{opth off:set(varname)}}include {it:varname} in model with coefficient constrained to 1{p_end}
{synopt :{opth sh:ared(varname)}}shared frailty ID variable{p_end}
{synopt :{opth anc:illary(varlist)}}use {it:varlist} to model the first ancillary parameter{p_end}
{synopt :{opth anc2(varlist)}}use {it:varlist} to model the second ancillary parameter{p_end}
{synopt :{cmdab:const:raints:(}{it:{help estimation options##constraints():constraints}}{cmd:)}}apply specified linear constraints{p_end}
{synopt:{opt col:linear}}keep collinear variables{p_end}

{syntab:SE/Robust}
{synopt :{opth vce(vcetype)}}{it:vcetype} may be {opt oim},
  {opt r:obust}, {opt cl:uster} {it:clustvar}, {opt opg}, {opt boot:strap},
  or {opt jack:knife}{p_end}

{syntab:Reporting}
{synopt :{opt l:evel(#)}}set confidence level; default is {cmd:level(95)}{p_end}
{synopt :{opt nohr}}do not report hazard ratios{p_end}
{synopt :{opt tr}}report time ratios{p_end}
{synopt :{opt nos:how}}do not show st setting information{p_end}
{synopt :{opt nohead:er}}suppress header from coefficient table{p_end}
{synopt :{opt nolr:test}}do not perform likelihood-ratio test{p_end}
{synopt :{opt nocnsr:eport}}do not display constraints{p_end}
{synopt :{it:{help streg##display_options:display_options}}}control spacing
           and display of omitted variables and base and empty cells{p_end}

{syntab:Maximization}
{synopt :{it:{help streg##maximize_options:maximize_options}}}control the maximization process; seldom used{p_end}

{p2coldent:+ {opt coefl:egend}}display coefficients' legend instead of coefficient table{p_end}
{synoptline}
{p2colreset}{...}
{p 4 6 2}
+ {opt coeflegend} does not appear in the dialog box.{p_end}
{p 4 6 2}
You must {cmd:stset} your data before using {cmd:streg}; see
{manhelp stset ST}.{p_end}
{p 4 6 2}
{it:varlist} may contain factor variables; see {help fvvarlist}.{p_end}
{p 4 6 2}
{opt bootstrap}, {opt by}, {opt fracpoly}, {opt jackknife}, {opt mfp},
{opt mi estimate}, {opt nestreg}, {opt statsby},
{opt stepwise}, and {opt svy} are allowed; see {help prefix}.
{p_end}
{p 4 6 2}
{cmd:vce(bootstrap)} and {cmd:vce(jackknife)} are not allowed with the
{cmd:mi estimate} prefix.{p_end}
{p 4 6 2}
{opt shared()},
{opt vce()},
and
{opt noheader}
are not allowed with the {helpb svy} prefix.
{p_end}
{p 4 6 2}
{opt fweight}s, {opt iweight}s, and {opt pweight}s may be specified using
{cmd:stset}; see {manhelp stset ST}. However, weights may not be specified if
you are using the {cmd:bootstrap} prefix with the {cmd:streg} command.{p_end}
{p 4 6 2} See {manhelp streg_postestimation ST:streg postestimation} for
additional capabilities of estimation commands.  {p_end}


{title:Menu}

{phang}
{bf:Statistics > Survival analysis > Regression models >}
    {bf:Parametric survival models}


{title:Description}

{pstd}
{cmd:streg} performs maximum likelihood estimation for parametric regression
survival-time models.  {cmd:streg} can be used with single- or multiple-record
or single- or multiple-failure st data.  Survival models currently supported
are exponential, Weibull, Gompertz, lognormal, loglogistic, and generalized
gamma.  Parametric frailty models and shared-frailty models are also fit
using {cmd:streg}.

{pstd}
Also see {manhelp stcox ST} for proportional hazards models.


{title:Options}

{dlgtab:Model}

{phang}
{opt noconstant}; see {helpb estimation options##noconstant:[R] estimation options}.

{phang}
{opt distribution(distname)} specifies the survival model to be fit.  A
specified {opt distribution()} is remembered from one estimation to the next
when {opt distribution()} is not specified.

{pmore}
For instance, typing {cmd:streg} {cmd:x1} {cmd:x2,}
{cmd:distribution(weibull)} fits a Weibull model.  Subsequently, you do
not need to specify {cmd:distribution(weibull)} to fit other Weibull
regression models.

{pmore}
The currently supported distributions are listed in the
{help streg##options:options table}.

{pmore}
All Stata estimation commands, including {cmd:streg}, redisplay results when
you type the command name without arguments.  To fit a model with no
explanatory variables, type {cmd:streg,} {cmd:distribution({it:distname})}....

{phang}
{cmd:frailty(gamma} | {cmd:invgaussian)} specifies the assumed distribution of
the frailty, or heterogeneity.  The estimation results, in addition to the
standard parameter estimates, will contain an estimate of the variance of the
frailties and a likelihood-ratio test of the null hypothesis that this
variance is zero.  When this null hypothesis is true, the model reduces to the
model with {opt frailty(distname)} not specified.

{pmore}
A specified {opt frailty()} is remembered from one estimation to the next when
{opt distribution()} is not specified.  When you specify {opt distribution()},
the previously remembered specification of {opt frailty()} is forgotten.

{phang}
{cmd:time} specifies that the model be fit in the accelerated failure-time
metric rather than in the log relative-hazard metric.  This option is
valid only for the exponential and Weibull models because these are the only
models that have both a proportional hazards and an accelerated failure-time
parameterization.  Regardless of metric, the likelihood function is the same,
and models are equally appropriate viewed in either metric; it is just a matter
of changing interpretation.

{pmore}
{opt time} must be specified at estimation.

{dlgtab:Model 2}

{phang}
{opth strata(varname)} specifies the stratification ID variable.  Observations
with equal values of the variable are assumed to be in the same stratum.
Stratified estimates (with equal coefficients across strata but intercepts and
ancillary parameters unique to each stratum) are then obtained.  This option
is not available if {opt frailty(distname)} is specified.

{phang}
{opth offset(varname)}; see
      {helpb estimation options##offset():[R] estimation options}.

{phang}
{opth shared(varname)} is valid with {opt frailty()} and specifies a variable
defining those groups over which the frailty is shared, analogous to
random-effects model for panel data where {it:varname} defines the panels.
{opt frailty()} specified without {opt shared()} treats the frailties as
occurring at the observation level.

{pmore}
A specified {opt shared()} is remembered from one estimation to the next when
{opt distribution()} is not specified.  When you specify {opt distribution()},
the previously remembered specification of {opt shared()} is forgotten.

{pmore}
{cmd:shared()} may not be used with {cmd:distribution(gamma)},
{cmd:vce(robust)}, {cmd:vce(cluster} {it:clustvar}{cmd:)}, {cmd:vce(opg)},
or the {helpb svy} prefix.

{pmore}
If {opt shared()} is specified without {opt frailty()} and there is no
remembered {opt frailty()} from the previous estimation, {cmd:frailty(gamma)}
is assumed to provide behavior analogous to {cmd:stcox}; see {manhelp stcox ST}.

{phang}
{opth ancillary(varlist)} specifies that the ancillary
parameter for the Weibull, lognormal, Gompertz, and loglogistic distributions
and that the first ancillary parameter (sigma) of the generalized log-gamma
distribution be estimated as a linear combination of {it:varlist}.
This option may not be used with {opt frailty(distname)}.

{pmore}
When an ancillary parameter is constrained to be strictly positive,
the logarithm of the ancillary parameter is modeled as a linear combination
of {it:varlist}

{phang}
{opth anc2(varlist)} specifies that the second ancillary parameter (kappa) for
the generalized log-gamma distribution be estimated as a linear combination of
{it:varlist}.  This option may not be used with {opt frailty(distname)}.

{phang}
{opt constraints(constraints)}, {opt collinear}; see
       {helpb estimation options##constraints():[R] estimation options}.

{dlgtab:SE/Robust}

INCLUDE help vce_asymptall

{dlgtab:Reporting}

{phang}
{opt level(#)} specifies the confidence level, as a percentage, for confidence
intervals.  The default is {cmd:level(95)} or as set by {helpb set level}.

{phang}
{opt nohr}, which may be specified at estimation or upon redisplaying
results, specifies that coefficients rather than exponentiated coefficients be
displayed, i.e., that coefficients rather than hazard ratios be
displayed.  This option affects only how coefficients are displayed, not how
they are estimated.

{pmore}
This option is valid only for models with a natural proportional-hazards
parameterization: exponential, Weibull, and Gompertz.  These three models, by
default, report hazards ratios (exponentiated coefficients).

{phang}
{opt tr} specifies that exponentiated coefficients, which are
interpreted as time ratios be displayed.  {opt tr} is appropriate only for the
loglogistic, lognormal, and gamma models, or for the exponential and Weibull
models when fit in the accelerated failure-time metric.

{pmore}
{opt tr} may be specified at estimation or upon replay.

{phang}
{opt noshow} prevents {cmd:streg} from showing the key st variables.  This
option is rarely used because most people type {cmd:stset, show} or 
{cmd:stset, noshow} to set once and for all whether they want to see these
variables mentioned at the top of the output of every st command; see 
{manhelp stset ST}.

{phang}
{opt noheader} suppresses the output header, either at estimation or upon
replay.  

{phang}
{opt nolrtest} is valid only with frailty models, in which case it suppresses
the likelihood-ratio test for significant frailty.

{phang}
{opt nocnsreport}; see
     {helpb estimation options##nocnsreport:[R] estimation options}.

{marker display_options}{...}
{phang}
{it:display_options}:
{opt noomit:ted},
{opt vsquish},
{opt noempty:cells},
{opt base:levels},
{opt allbase:levels};
    see {helpb estimation options##display_options:[R] estimation options}.

{marker maximize_options}{...}
{dlgtab:Maximization}
 
{phang}
{it:maximize_options}; {opt dif:ficult}, {opt tech:nique(algorithm_spec)}, 
{opt iter:ate(#)}, [{opt no:}]{opt lo:g}, {opt tr:ace}, {opt grad:ient}, 
{opt showstep}, {opt hess:ian}, {opt showtol:erance}, {opt tol:erance(#)}, 
{opt ltol:erance(#)}, {opt nrtol:erance(#)}, 
{opt nonrtol:erance}, {opt from(init_specs)}; see {manhelp maximize R}.  These 
options are seldom used.

{pmore}
Setting the optimization type to {cmd:technique(bhhh)} resets the default
{it:vcetype} to {cmd:vce(opg)}.

{pstd}
The following option is available with {opt streg} but is not shown in the
dialog box:

{phang}
{opt coeflegend}; see
     {helpb estimation options##coeflegend:[R] estimation options}.


{title:Examples}

    {hline}
{pstd}Setup{p_end}
{phang2}{cmd:. webuse kva}

{pstd}Fit a Weibull survival model{p_end}
{phang2}{cmd:. streg load bearings, distribution(weibull)}

{pstd}Replay results, but display coefficients rather than hazard
ratios{p_end}
{phang2}{cmd:. streg, nohr}

{pstd}Fit a Weibull survival model in the accelerated failure-time
metric{p_end}
{phang2}{cmd:. streg load bearings, d(weibull) time}

    {hline}
{pstd}Setup{p_end}
{phang2}{cmd:. webuse mfail}

{pstd}Fit a Weibull survival model using data that has multiple failures per
subject, and specify robust standard errors{p_end}
{phang2}{cmd:. streg x1 x2, d(weibull) vce(robust)}

{pstd}Same as above, but fit exponential model rather than Weibull{p_end}
{phang2}{cmd:. streg x1 x2, d(exp) vce(robust)}

    {hline}
{pstd}Setup{p_end}
{phang2}{cmd:. webuse cancer}

{pstd}Map values for {cmd:drug} into 0 for placebo and 1 for nonplacebo{p_end}
{phang2}{cmd:. replace drug = drug == 2 | drug == 3}

{pstd}Declare data to be survival-time data{p_end}
{phang2}{cmd:. stset studytime, failure(died)}

{pstd}Fit a generalized gamma survival model{p_end}
{phang2}{cmd:. streg drug age, d(gamma)}

{pstd}Test for appropriateness of Weibull model{p_end}
{phang2}{cmd:. test [kappa]_cons = 1}

    {hline}
{pstd}Setup{p_end}
{phang2}{cmd:. webuse hip3, clear}

{pstd}Fit a Weibull survival model, using {cmd:male} to model the 
ancillary parameter{p_end}
{phang2}{cmd:. streg protect age, d(weibull) ancillary(male)}

    {hline}
{pstd}Setup{p_end}
{phang2}{cmd:. webuse cancer}

{pstd}Declare data to be survival-time data{p_end}
{phang2}{cmd:. stset studytime died}

{pstd}Fit a stratified Weibull survival model{p_end}
{phang2}{cmd:. streg age, d(weibull) strata(drug)}

{pstd}Produce a "less-stratified" model than above{p_end}
{phang2}{cmd:. streg age, d(weibull) ancillary(i.drug)}

    {hline}
{pstd}Setup{p_end}
{phang2}{cmd:. webuse bc}

{pstd}List some of the data{p_end}
{phang2}{cmd:. list in 1/12}

{pstd}Declare data to be survival-time data{p_end}
{phang2}{cmd:. stset t, fail(dead)}

{pstd}Fit Weibull survival model with gamma-distributed frailty{p_end}
{phang2}{cmd:. streg age smoking, d(weibull) frailty(gamma)}

{pstd}Fit Weibull survival model with inverse-Gaussian-distributed frailty
{p_end}
{phang2}{cmd:. streg age smoking, d(weibull) frailty(invgauss)}

    {hline}
{pstd}Setup{p_end}
{phang2}{cmd:. webuse catheter}

{pstd}List some of the data{p_end}
{phang2}{cmd:. list in 1/10}

{pstd}Declare data to be survival-time data{p_end}
{phang2}{cmd:. stset time, fail(infect)}

{pstd}Fit Weibull survival model with inverse-Gaussian-distributed shared
frailty{p_end}
{phang2}{cmd:. streg age female, d(weibull) frailty(invgauss) shared(patient)}

{pstd}Same as above, but fit lognormal model rather than Weibull{p_end}
{phang2}{cmd:. streg age female, d(lnormal) frailty(invgauss) shared(patient)}

    {hline}
{pstd}Setup{p_end}
{phang2}{cmd:. webuse nhefs}

{pstd}Declare survey design for data{p_end}
{phang2}{cmd:. svyset psu2 [pw=swgt2], strata(strata2)}

{pstd}Declare data to be survival-time data{p_end}
{phang2}{cmd:. stset age_lung_cancer if age_lung_cancer < . [pw=swgt2],}
             {cmd:fail(lung_cancer)}

{pstd}Fit exponential survival model taking into account data are survey
data{p_end}
{phang2}{cmd:. svy: streg former_smoker smoker male urban1 rural, d(exp)}
{p_end}
    {hline}


{title:Saved results}

{pstd}
{cmd:streg} saves the following in {cmd:e()}:

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Scalars}{p_end}
{synopt:{cmd:e(N)}}number of observations{p_end}
{synopt:{cmd:e(N_sub)}}number of subjects{p_end}
{synopt:{cmd:e(N_fail)}}number of failures{p_end}
{synopt:{cmd:e(N_g)}}number of groups{p_end}
{synopt:{cmd:e(k)}}number of parameters{p_end}
{synopt:{cmd:e(k_eq)}}number of equations{p_end}
{synopt:{cmd:e(k_eq_model)}}number of equations in model Wald test{p_end}
{synopt:{cmd:e(k_aux)}}number of auxiliary parameters{p_end}
{synopt:{cmd:e(k_dv)}}number of dependent variables{p_end}
{synopt:{cmd:e(k_autoCns)}}number of base, empty, and omitted constraints{p_end}
{synopt:{cmd:e(df_m)}}model degrees of freedom{p_end}
{synopt:{cmd:e(ll)}}log likelihood{p_end}
{synopt:{cmd:e(ll_0)}}log likelihood, constant-only model{p_end}
{synopt:{cmd:e(ll_c)}}log likelihood, comparison model{p_end}
{synopt:{cmd:e(N_clust)}}number of clusters{p_end}
{synopt:{cmd:e(chi2)}}chi-squared{p_end}
{synopt:{cmd:e(chi2_c)}}chi-squared, comparison model{p_end}
{synopt:{cmd:e(risk)}}total time at risk{p_end}
{synopt:{cmd:e(g_min)}}smallest group size{p_end}
{synopt:{cmd:e(g_avg)}}average group size{p_end}
{synopt:{cmd:e(g_max)}}largest group size{p_end}
{synopt:{cmd:e(theta)}}frailty parameter{p_end}
{synopt:{cmd:e(aux_p)}}ancillary parameter ({cmd:weibull}){p_end}
{synopt:{cmd:e(gamma)}}ancillary parameter ({cmd:gompertz, loglogistic}){p_end}
{synopt:{cmd:e(sigma)}}ancillary parameter ({cmd:gamma, lnormal}){p_end}
{synopt:{cmd:e(kappa)}}ancillary parameter ({cmd:gamma}){p_end}
{synopt:{cmd:e(p)}}significance{p_end}
{synopt:{cmd:e(p_c)}}significance, comparison model{p_end}
{synopt:{cmd:e(rank)}}rank of {cmd:e(V)}{p_end}
{synopt:{cmd:e(rank0)}}rank of {cmd:e(V)}, constant-only model{p_end}
{synopt:{cmd:e(ic)}}number of iterations{p_end}
{synopt:{cmd:e(rc)}}return code{p_end}
{synopt:{cmd:e(converged)}}{cmd:1} if converged, {cmd:0} otherwise{p_end}

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Macros}{p_end}
{synopt:{cmd:e(cmd)}}model or regression name{p_end}
{synopt:{cmd:e(cmd2)}}{cmd:streg}{p_end}
{synopt:{cmd:e(cmdline)}}command as typed{p_end}
{synopt:{cmd:e(dead)}}{cmd:_d}{p_end}
{synopt:{cmd:e(depvar)}}{cmd:_t}{p_end}
{synopt:{cmd:e(title)}}title in estimation output{p_end}
{synopt:{cmd:e(title2)}}secondary title in estimation output{p_end}
{synopt:{cmd:e(clustvar)}}name of cluster variable{p_end}
{synopt:{cmd:e(shared)}}frailty grouping variable{p_end}
{synopt:{cmd:e(fr_title)}}title in output identifying frailty{p_end}
{synopt:{cmd:e(wtype)}}weight type{p_end}
{synopt:{cmd:e(wexp)}}weight expression{p_end}
{synopt:{cmd:e(t0)}}{cmd:_t0}{p_end}
{synopt:{cmd:e(vce)}}{it:vcetype} specified in {cmd:vce()}{p_end}
{synopt:{cmd:e(vcetype)}}title used to label Std. Err.{p_end}
{synopt:{cmd:e(frm2)}}hazard or time{p_end}
{synopt:{cmd:e(chi2type)}}{cmd:Wald} or {cmd:LR}; type of model chi-squared
	test{p_end}
{synopt:{cmd:e(offset1)}}offset for main equation{p_end}
{synopt:{cmd:e(stcurve)}}{cmd:stcurve}{p_end}
{synopt:{cmd:e(diparm}{it:#}{cmd:)}}display transformed parameter {it:#}{p_end}
{synopt:{cmd:e(opt)}}type of optimization{p_end}
{synopt:{cmd:e(which)}}{cmd:max} or {cmd:min}; whether optimizer is to perform
                         maximization or minimization{p_end}
{synopt:{cmd:e(ml_method)}}type of {cmd:ml} method{p_end}
{synopt:{cmd:e(user)}}name of likelihood-evaluator program{p_end}
{synopt:{cmd:e(technique)}}maximization technique{p_end}
{synopt:{cmd:e(singularHmethod)}}{cmd:m-marquardt} or {cmd:hybrid}; method used
                          when Hessian is singular{p_end}
{synopt:{cmd:e(crittype)}}optimization criterion{p_end}
{synopt:{cmd:e(properties)}}{cmd:b V}{p_end}
{synopt:{cmd:e(predict)}}program used to implement {cmd:predict}{p_end}
{synopt:{cmd:e(predict_sub)}}{cmd:predict} subprogram{p_end}
{synopt:{cmd:e(footnote)}}program used to implement the footnote display{p_end}
{synopt:{cmd:e(marginsprop)}}signals to the {cmd:margins} command{p_end}
{synopt:{cmd:e(asbalanced)}}factor variables {cmd:fvset} as {cmd:asbalanced}{p_end}
{synopt:{cmd:e(asobserved)}}factor variables {cmd:fvset} as {cmd:asobserved}{p_end}

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Matrices}{p_end}
{synopt:{cmd:e(b)}}coefficient vector{p_end}
{synopt:{cmd:e(Cns)}}constraints matrix{p_end}
{synopt:{cmd:e(ilog)}}iteration log (up to 20 iterations){p_end}
{synopt:{cmd:e(gradient)}}gradient vector{p_end}
{synopt:{cmd:e(V)}}variance-covariance matrix of the estimators{p_end}
{synopt:{cmd:e(V_modelbased)}}model-based variance{p_end}

{synoptset 20 tabbed}{...}
{p2col 5 20 24 2: Functions}{p_end}
{synopt:{cmd:e(sample)}}marks estimation sample{p_end}
{p2colreset}{...}


{title:Also see}

{psee}
Manual:  {manlink ST streg}

{psee}
{space 2}Help:  {manhelp streg_postestimation ST:streg postestimation};
{manhelp stcurve ST};{break}
{manhelp stcrreg ST},
{manhelp sts ST},
{manhelp stset ST},
{manhelp stcox ST}
{p_end}
