{smcl}
{* *! version 1.1.4  06nov2009}{...}
{cmd:help tsline} {right:dialogs:  {dialog tsline}  {dialog twoway}}
{hline}

{title:Title}

{p2colset 5 32 34 2}{...}
{p2col 5 20 26 2:{manlink TS tsline} {hline 2}}Plot time-series data{p_end}
{p2col :{manlink G graph twoway tsline} {hline 2}}Twoway line plots{p_end}
{p2colreset}{...}


{title:Syntax}

{pstd}
Time-series line plot

{p 8 24 2}
[{cmdab:tw:oway}]
{cmd:tsline}
	{it:varlist}
	{ifin}
	[{cmd:,}
	{it:tsline_options}]


{pstd}
Time-series range plot with lines

{p 8 25 2}
[{cmdab:tw:oway}]
{cmd:tsrline}
	{it:y_1} {it:y_2}
	{ifin}
	[{cmd:,}
	{it:tsrline_options}]


{phang}
where the time variable is assumed set by {helpb tsset}, {it:varlist} has the
interpretation

		{it:y_1} [{it:y_2} ... {it:y_k}]

{synoptset 20 tabbed}{...}
{synopt:{it:tsline_options}}description{p_end}
{synoptline}
{syntab:Plots}
{synopt:{it:{help scatter:scatter_options}}}any of the options allowed by
            {hi:[G] graph twoway scatter} with the exception of
                  {it:marker_options},
                  {it:marker_placement_options}, and
                  {it:marker_label_options},
                  which will be ignored if specified{p_end}

{syntab:Y axis, Time axis, Titles, Legend, Overall, By}
{synopt :{it:{help twoway_options}}}any options documented in {bind:{bf:[G]} {it:twoway_options}}{p_end}
{synoptline}

{synopt:{it:tsrline_options}}description{p_end}
{synoptline}
{syntab:Plots}
{synopt:{it:{help twoway_rline:rline_options}}}any of the options allowed by
             {cmd:graph} {cmd:twoway} {cmd:rline}{p_end}

{syntab:Y axis, Time axis, Titles, Legend, Overall, By}
{synopt :{it:{help twoway_options}}}any options documented in {bind:{bf:[G]} {it:twoway_options}}{p_end}
{synoptline}


{title:Menu}

    {title:tsline and tsrline}

{phang2}
{bf:Statistics > Time series > Graphs > Line plots}

    {title:twoway tsline and twoway tsrline}

{phang2}
{bf:Graphics > Twoway graph (scatter, line, etc.)}


{title:Description}

{pstd}
{cmd:tsline} draws line plots for time-series data.

{pstd}
{cmd:tsrline} draws a range plot with lines for time-series data.

{pstd}
{cmd:tsline} and {cmd:tsrline} are both commands and {it:plottype}s as defined
in {helpb twoway:[G] graph twoway}.  Thus the syntax for {cmd:tsline} is

	{cmd:. graph twoway tsline} ...

	{cmd:. twoway tsline} ...

	{cmd:. tsline} ...

{pstd}
and similarly for {cmd:tsrline}.
Being plot types, these commands may be combined with other plot types in the
{cmd:twoway} family, as in,

{phang2}
	{cmd:. twoway (tsrline} ...{cmd:) (tsline} ...{cmd:) (lfit} ...{cmd:)} ...

{pstd}
which can equivalently be written

{phang2}
	{cmd:. tsrline} ... {cmd:|| tsline} ... {cmd:|| lfit} ... {cmd:||} ...


{title:Options}

{dlgtab:Plots}

{phang}
{it:scatter_options}
    are any of the options allowed by the {cmd:graph} {cmd:twoway}
    {cmd:scatter} command except that {it:marker_options},
    {it:marker_placement_options}, and {it:marker_label_options} will be
    ignored if specified; see {manhelp scatter G:graph twoway scatter}.

{phang}
{it:rline_options}
    are any of the options allowed by the {cmd:graph} {cmd:twoway}
    {cmd:rline} command; see {manhelp twoway_rline G:graph twoway rline}.

{dlgtab:Y axis, Time axis, Titles, Legend, Overall, By}
{phang}
{it:twoway_options} are any of the options documented in 
{manhelpi twoway_options G}.  These include options for titling the graph (see
{manhelpi title_options G}), options for saving the graph to disk (see
{manhelpi saving_option G}), and the {cmd:by()} option, which will allow
you to simultaneously plot different subsets of the data (see 
{manhelpi by_option G}).

{pmore}
Also see the {cmd:recast()} option discussed in 
{manhelpi advanced_options G} for information on how to plot spikes, bars,
etc., instead of lines.


{title:Remarks}

    {title:Example 1}

{pstd}
We simulated two separate time series (each of 200 observations) and placed
them in a Stata dataset, {cmd:tsline1.dta}.  The first series simulates
an AR(2) process with {it:phi}_1=0.8 and {it:phi}_2=0.2; the second series
simulates an MA(2) process with {it:theta}_1=0.8 and {it:theta}_2=0.2.  In the
following we use {cmd:tsline} to graph these two series.

	{cmd:. sysuse tsline1, clear}
	{cmd:. tsset lags}
	{cmd:. tsline ar ma}
	  {it:({stata "tsline_ex arma":click to run})}


    {title:Example2}

{pstd}
Suppose that we kept a calorie log for an entire calendar year.  At the end of
the year, we would have a dataset (e.g., {cmd:tsline2.dta}) that contains the
number of calories consumed for 365 days.  We could then use {cmd:tsset} to
identify the date variable and use {cmd:tsline} to plot calories versus time.
Knowing that we tend to eat a little more food on Thanksgiving and Christmas
day, we use the {cmd:ttick()} and {cmd:ttext()} options to point these days
out on the time axis.

	{cmd:. sysuse tsline2, clear}
	{cmd:. tsset day}
	{cmd:. tsline calories, ttick(28nov2002 25dec2002, tpos(in))}
	{cmd:      ttext(3470 28nov2002 "thanks"}
	{cmd:            3470 25dec2002 "x-mas"}
	{cmd:            , orient(vert))}
	  {it:({stata "tsline_ex calories":click to run})}

{pstd}
We were uncertain of the exact values we logged, so we also gave a range for
each day.  Here is a plot of the summer months.

	{cmd:. sysuse tsline2, clear}
	{cmd:. tsset day}
	{cmd:. tsrline lcalories ucalories if tin(1may2002,31aug2002)}
	{cmd:      || tsline calories}
	{cmd:      || if tin(1may2002,31aug2002), ytitle(Calories)}
	  {it:({stata "tsline_ex rcalories":click to run})}

{pstd}
Options associated with the time axis allow dates to be specified in place of
elapsed time values.  For instance, we used

{pmore}
{cmd:ttick(28nov2002 25dec2002 , tpos(in))}

{pstd}
to place tick marks at the specified dates.  This works similarly for
{cmd:tlabel}, {cmd:tmlabel}, and {cmd:tmtick}.

{pstd}
Suppose that we wanted to place vertical lines for the previously mentioned
holidays.  We could specify the dates in the {cmd:tline()} option as follows:

	{cmd:. sysuse tsline2, clear}
	{cmd:. tsset day}
	{cmd:. tsline calories, tline(28nov2002 25dec2002)}
	  {it:({stata "tsline_ex calories2":click to run})}

{pstd}
We could also modify the format of the time axis so that only the day in the
year is displayed in the labeled ticks:

	{cmd:. sysuse tsline2, clear}
	{cmd:. tsset day}
	{cmd:. tsline calories, tlabel(, format(%tdmd)) ttitle("Date (2002)")}
	  {it:({stata "tsline_ex calories3":click to run})}


{title:Also see}

{psee}
Manual:  {manlink TS tsline}{break}
         {manlink G graph twoway tsline}

{psee}
{space 2}Help:  {manhelp tsset TS}; {manhelp xtline XT};
{manhelp graph_twoway G:graph twoway}
{p_end}
