*! version 1.0.5  26may2010
program u_mi_estimate_display
	version 11

	local cmdname `e(cmd_mi)'

	// get display options and the default eform opts.
	u_mi_estimate_get_commonopts `cmdname'
	local diopts `s(diopts)'
	local cmddiopts `s(cmddiopts)'

	syntax [,	`diopts'	///
			`cmddiopts'	///
			ESAMPVARYFLAG	///	// only for -using- specific.
			NOCNSReport	///	
		  	*		///	// eform_opts and factor diopts
		]
        _get_diopts msopts eform, `options'
	if `"`eform'"'!="" & "`estmetric'"!="" {
		di as txt "{p 0 6 2}note: eform options are ignored with " ///
		  "{bf:estmetric}.{p_end}"
		local eform
	}
	local M `_dta[_mi_M]'
	if ("`M'"=="") {
		local M 2
	}
	if `"`0'"'=="" {
		local comma ,
	}
	u_mi_estimate_chk_commonopts `comma' `0' maxm(`M') cmd(`cmdname')
	local cmddiopts `s(cmddiopts)'

	if ("`nocoef'"!="" & (e(k_exp_mi)==0 | "`notrcoef'"!="")) {
		if ("`post'"!="") {
			u_mi_postbv
		}
		exit
	}
	// check eform opts
	_get_eformopts, eformopts(`eform') allowed(EForm hr shr IRr or RRr)
	if "`e(cmd_mi)'"=="streg" {
		if "`e(_efopt_mi)'"=="hr" & "`e(frm2)'"=="time" {
			local eform	// ignore -hr- with AFT form
			local cmdftnote mi_streg_hrnote
		}
	}
	else if "`e(cmd_mi)'"=="xtreg" {
		local cmdftnote mi_xtreg_note
	}
	else if inlist("`e(cmd_mi)'","xtmixed","xtmelogit","xtmepoisson") & ///
		"`estmetric'`dftable'`vartable'`noretable'"=="" {
		if ("`variance'"!="") {
			local isres = inlist("`e(rstructure)'",	///
					     "exchangeable",	///
					     "toeplitz")
			local vartypes `e(vartypes)'
			local posexch : list posof "Exchangeable" in vartypes
			local posunstr : list posof "Unstructured" in vartypes
			if `isres' | `posexch' | `posunstr' {
				local cmdftnote mi_xtme_note
			}
		}
		if "`e(cmd_mi)'"=="xtmixed" & 	///
		     (inlist("`e(rstructure)'","unstructured","banded") ///
		      | "`e(rbyvar)'"!="") {
			local cmdftnote mi_xtme_note
		}
	}

	// post Cns to e() to display constraints
	local unhold 0
	if ("`e(Cns_mi)'"=="matrix") {
		tempname esthold
		_estimates hold `esthold', copy
		u_mi_postbv
		local unhold 1
	}
	// command legend
	local cmdline `"`e(cmdline)'"'
	if ("`nocoef'"=="" | "`notrcoef'`nolegend'`nocmdlegend'"!="") {
		local cmdline
	}

	// Display results
	if ("`nocmdnote'"=="") {
		mi_notes `cmdname'
	}
	if ("`vartable'"!="") { // display VI table
		u_mi_estimate_table_header, `noheader' `nomiheader' miheader
		if ("`noheader'"=="") {
			di
			di as txt "Variance information"
		}
		_mi_vartable , cmdline(`cmdline') cmdname(`cmdname') 	///
			     `nolegend' `nocoef' `notrcoef' `notable' `msopts'
		if "`e(dfadjust_mi)'"=="Small sample" {
			di as txt "{p 0 6 2 78}Note: FMIs are based on " ///
			  "Rubin's large-sample degrees of freedom.{p_end}"
		}
		local nomiheader nomiheader
		local nolegend nolegend
	}

	//_coef_table opts for coeff. and transf.
	local coeftabopts bmat(e(b_mi)) vmat(e(V_mi)) dfmat(e(df_mi)) `msopts'
	local coeftabopts `coeftabopts' pisemat(e(pise_mi)) `level' `eform'
	local coeftabopts `coeftabopts' `nocnsreport'
	local xtlist `""xtprobit","xtlogit","xtcloglog","xtpoisson","xtnbreg""'
	if (inlist("`cmdname'",`xtlist')) {
		local coeftabopts `coeftabopts' notest
	}
	else if (inlist("`cmdname'","xtmixed","xtmelogit","xtmepoisson")) {
		if ("`estmetric'`dftable'`vartable'"=="") {
			local coeftabopts `coeftabopts' first
		}
		if (inlist("`cmdname'","xtmelogit","xtmepoisson")) {
			local coeftabopts `coeftabopts' offsetonly1
		}
	}
	if ("`cmdname'"=="xtreg") {
		if inlist("`e(model)'","re","fe") {
			local coeftabopts `coeftabopts' plus
		}
	}
	local trtabopts   bmat(e(b_Q_mi))  vmat(e(V_Q_mi))  dfmat(e(df_Q_mi)) 
	local trtabopts `trtabopts' pisemat(e(pise_Q_mi)) `level'
	local trtabopts `trtabopts' noeqcheck nodiparm `msopts'
	local clegend clegend
	if ("`nocoef'"=="") { // display coeff. table
		_mi_tables, `coeftabopts' cmdname(`cmdname') `notable'	 ///
			    `citable' `dftable' `nocitable'		 ///
			    `noheader' `nomiheader' `nolegend' `clegend' ///
			    `nofetable' `nogroup'
		// coef. table determines how transf. table is displayed
		local cmdline
		local nomiheader nomiheader
		local nocmdheader nocmdheader
		local trcoeftitle trcoeftitle
		local clegend
		local nocnsreport nocnsreport
		local toshow 1
		if ("`nocitable'"!="" & "`dftable'"=="") {
			local toshow 0
		}
		if ("`notable'"=="" & `toshow') {
			_mi_cmd_table, cmdname(`cmdname') `cmddiopts' `level'
			`cmdftnote'
		}
	}
	if (e(k_exp_mi)>0 & "`notrcoef'"=="") { // display transf. table
		if ("`nocoef'"=="") di
		_mi_tables, `trtabopts' `nocnsreport' cmdname(`cmdname') ///
			    `notable' `citable' `dftable' `nocitable' 	///
			    `noheader' `nomiheader' `nocmdheader'	///
			     trcoef `trcoeftitle' nomodeltest		///
			    `nolegend' `clegend' trlegend cmdline(`cmdline')
	}
	if ("`notable'"=="") {
		// warning message
		if ("`nowarning'"=="") {
			if ("`esampvaryflag'"!="") {
				esample_warning2
			}
			else if (e(esampvary_mi)) {
				esample_warning1
			}
		}
		// footnotes
		mi_footnotes
	}

	if (`unhold') {
		_estimates unhold `esthold'
	}
	if ("`post'"!="") {
		u_mi_postbv
	}
end

program mi_notes
	args cmd

	if ("`cmd'"=="xtlogit") {
		mi_xtlogit_notes
	}
end

program mi_xtlogit_notes

	local mlist `e(names_vvl_mi)'
	local multiple : list posof "multiple" in mlist
	local multiple = `multiple' + ("`e(multiple_mi)'"!="")
	if `multiple' {
		di as txt "{p 0 6 2}note: multiple positive outcomes " ///
			 "within groups encountered{p_end}"
	}
	tempname maxgr maxobs
	mata: st_numscalar("`maxgr'",max(st_matrix("e(N_group_drop_vs_mi)")))
	mata: st_numscalar("`maxobs'",max(st_matrix("e(N_drop_vs_mi)")))
	if `maxgr'==. & `maxobs'==. {
		scalar `maxgr' = e(N_group_drop_mi)
		scalar `maxobs' = e(N_drop_mi)
		if `maxgr'<. & `maxgr'>0 {
			mi_xtlogit_note `=`maxgr'' `=`maxobs''
		}
	}
	else {
		local ngr `e(N_group_drop_mi)'
		local nobs `e(N_drop_mi)'
		forvalues i=1/`e(M_mi)' {
			if `maxgr'<. {
				local ngr = el(e(N_group_drop_vs_mi),`i',1)
			}
			if `maxobs'<. {
				local nobs = el(e(N_drop_vs_mi),`i',1)
			}
			if `maxgr'>0 {
				mi_xtlogit_note `ngr' `nobs' `i'
			}
		}
	}
end

program mi_xtlogit_note

	args ndrop nobs m

	if ("`m'"!="") {
		local diimp "in {it:m}=`m' "
	}
	di as txt "{p 0 6 2}note: `ndrop' " `"`=plural(`ndrop',"group")'"' ///
	   " (`nobs' obs) dropped `diimp'"				   ///
	   "because of all positive or all negative outcomes{p_end}" 
end

program mi_footnotes

	// omitted imputations
	local M_out = `e(M_mi)'
	local M : word count `e(m_mi)'
	mata: _note_failed(`M', `M_out')

	_svy_fpc_note "" "" "e(b_mi)"
	_svy_singleton_note, bmat(e(b_mi))
	_svy_subpop_note
	mi_varying_notes
end

program mi_varying_notes
	local mac `e(names_vvm_mi)'
	local N_g_vs : list posof "N_g" in mac
	if ("`e(N_g_vs_mi)'"=="matrix" | `N_g_vs') {
		di_varying_note "number of groups"	
	}
	local g_max_vs : list posof "g_max" in mac
	if ("`e(g_max_vs_mi)'"=="matrix" | `g_max_vs') {
		di_varying_note "number of observations per group"	
	}
	if ("`e(N_clust_vs_mi)'"=="matrix") {
		di_varying_note "number of clusters"	
	}
	if ("`e(N_strata_vs_mi)'"=="matrix") {
		di_varying_note "number of strata"	
	}
	if ("`e(N_psu_vs_mi)'"=="matrix") {
		di_varying_note "number of primary clusters"	
	}
	if ("`e(N_pop_vs_mi)'"=="matrix") {
		di_varying_note "population size" 
	}
	if ("`e(N_subpop_vs_mi)'"=="matrix") {
		di_varying_note "subpopulation size" 
	}
	if ("`e(N_sub_vs_mi)'"=="matrix") {
		di_varying_note "number of observations in a subpopulation" 
	}
	if ("`e(N_poststrata_vs_mi)'"=="matrix") {
		di_varying_note "number of poststrata"	
	}
	if ("`e(N_poststrata_vs_mi)'"=="matrix") {
		di_varying_note "number of standardization strata"
	}	
end

program di_varying_note
	args msg

	di as txt "{p 0 6 2 78}Note: `msg' varies among imputations.{p_end}"
end

program mi_streg_hrnote

	di as txt "{p 0 6 2 78}Note: option {bf:hr} is ignored with the " ///
		  "accelerated failure-time form.{p_end}"
end

program mi_xtreg_note
	if inlist("`e(model)'","re","fe","ml") {
		di as txt "{p 0 6 2 78}{help mi_xtreg_note:Note}: "	///
			  "{cmd:sigma_u} and {cmd:sigma_e} "		///
			  "are combined in the original metric.{p_end}"
	}
end

program mi_xtme_note
	di as txt "{p 0 6 2 78}{help mi_xtme_note:Note}: "	///
		  "confidence intervals are not computable for some "	///
		  "random-effects parameters because MI degrees of "	///
		  "freedom cannot be estimated.{p_end}"
end


program _mi_tables
	syntax [, 	NOTABle			///
			NOCITable		///
			CITable			///
			DFTable			///
			NOLEGend		///	//      --- legend opts
			CMDNAME(passthru)	///
			CMDLINE(passthru)	///
			TRLEGend		///
			CLEGend			///
			NOHEADer 		///	//      --- header opts
			NOMIHEADer 		///	
			NOCMDHEADer 		///	
			NOMODELTEST		///
			NOCLUSTREPORT		///
			TRCOEF			///
			TRCOEFTITLE		///
			NOFETable		///	// --- xtm<...> opts
			NOGRoup			///
			NOCNSReport		///	// --- _coef_table opts
			* 			/// 	
		]
	if ("`nofetable'"!="") {
		local notable notable
	}
	local coeftabopts `options'
	if ("`citable'`dftable'"=="") {
		local citable citable
	}
	if ("`nocitable'"!="") {
		local citable
	}
	if ("`citable'`dftable'"=="") exit
	if ("`nomiheader'"=="" | "`nocmdheader'"=="") {
		u_mi_estimate_table_header, `noheader' `nomiheader' ///
				    miheader cmdheader nright(nr) nleft(nl)	///
				    `nogroup'
		if ("`nr'"!="" & "`nl'"!="") {
			if (`nr'==`nl' & `nl'>2) di
		}
	}
	local hopts nomiheader nocmdheader nospace `nomodeltest' `trcoef'
	u_mi_estimate_table_header, `noheader' `hopts' `trcoeftitle'
	if ("`notable'"!="") exit
	di
	_mi_table_legend, `nolegend' `clegend' `cmdname' ///
			  `trlegend' `cmdline'
	if ("`citable'"!="") {
		_coef_table, `coeftabopts' `e(aux_notest)' `nocnsreport' ///
			     `noclustreport'
	}
	if ("`dftable'"!="") {
		if ("`citable'"!="" & "`noheader'"=="") {
			di
			di as txt "Degrees of freedom"
		}
		if ("`citable'"!="") {
			local noclustreport noclustreport
			if ("`trcoef'"!="") { // transf. table
				local nocnsreport nocnsreport
			}
		}
		_coef_table, dftable `coeftabopts' `e(aux_notest)' 	///
			     `nocnsreport' `noclustreport'
	}
end

program _mi_cmd_table

	syntax , CMDNAME(string) [*]

	if inlist("`cmdname'","xtmixed","xtmelogit","xtmepoisson") {
		local SYNOPTS noFETable ESTMetric noRETable
		local ecmd `e(cmd)'
	}

	syntax , CMDNAME(string) [`SYNOPTS' *]

	if ("`cmdname'"=="xtmixed") {
		if ("`estmetric'`retable'"!="") {
			exit
		}
		mata: st_global("e(cmd)","mi estimate")
		_xtmixed_display, noheader nolrtest nofetable `options'
		mata: st_global("e(cmd)","`ecmd'")
		exit
	}
	if inlist("`cmdname'","xtmelogit","xtmepoisson") {
		if ("`estmetric'`retable'"!="") {
			exit
		}
		mata: st_global("e(cmd)","mi estimate")
		_xtme_display, noheader nolrtest nofetable `options'
		mata: st_global("e(cmd)","`ecmd'")
		exit
	}
	if ("`cmdname'"=="xtreg") {
		if inlist("`e(model)'","re","fe") {
			_xtreg_varcomp_display
		}
	}
end

program _xtreg_varcomp_display
	tempname rho
	scalar `rho' = e(sigma_u_mi)^2/(e(sigma_u_mi)^2+e(sigma_e_mi)^2)
	di in smcl as txt "     sigma_u {c |} " as res %10.0g e(sigma_u_mi)
	di in smcl as txt "     sigma_e {c |} " as res %10.0g e(sigma_e_mi)
	di in smcl as txt "         rho {c |} " as res %10.0g `rho' /*
		*/ as txt "   (fraction of variance due to u_i)"
	di in smcl as txt "{hline 13}{c BT}{hline 64}"

end

program _mi_table_legend
	syntax [, NOLEGend CLEGend CMDNAME(string) 	///
		  TRLEGend CMDLINE(passthru) ]
	
	if ("`nolegend'"!="") exit
	if ("`clegend'`trlegend'"=="") exit
	
	_mi_cmdline_legend, `cmdline'
	if ("`clegend'"!="") {
		local cmdlist ratio mean proportion
		local incmdlist : list cmdname in cmdlist 
		if (`incmdlist') {
			 _mi_`cmdname'_legend vskip
		}
	}
	if ("`trlegend'"!="") {
		u_mi_trcoef_legend
		local vskip di
	}
	`vskip'
end

program _mi_summarize_legend

	mata: st_global("e(cmd)", st_global("e(cmd_mi)"))	
	_svy_summarize_legend "noblank"
	mata: st_global("e(cmd)", "mi estimate")	
end

program _mi_mean_legend
	args vskip

	_mi_summarize_legend
	c_local vskip ""	// no additional blank line
end

program _mi_ratio_legend
	args vskip

	_mi_summarize_legend
	c_local vskip ""	// no additional blank line
end

program _mi_proportion_legend
	args vskip

	_mi_summarize_legend
	c_local vskip ""	// no additional blank line
end

program _mi_cmdline_legend
	syntax [, CMDLINE(string asis) ]
	if `"`cmdline'"' != "" {
		di "{p2colset 7 16 20 2}{...}"
		di as txt `"{p2col :command:}`cmdline'{p_end}"'
	}
end

program _mi_vartable

	syntax [, NOCOEF NOLEGend NOTRCOEF NOTABle ///
		  CMDLINE(passthru) CMDNAME(passthru) * ]

	local msopts `options'

	if ("`notable'"!="") exit
	if ("`nocoef'"!="" & (e(k_exp_mi)==0 | "`notrcoef'"!="")) exit

	local clegend clegend	// always displayed, even if -nocoef-
	local trlegend trlegend	
	if ("`notrcoef'"!="" | e(k_exp_mi)==0) {
		local trlegend
	}
	else {
		di
	}
	_mi_table_legend, `nolegend' `clegend' `cmdname' ///
			  `trlegend' `cmdline'

	// create variance information table
	tempname Tab
	.`Tab' = ._tab.new, col(7) lmargin(0) ignore(.b) 
	// column        1      2     3     4     5     6      7
	.`Tab'.width	13    |10    10    10    10     10     14
	.`Tab'.strfmt    .   %10s     .     .     .     .      .
	.`Tab'.pad       .      2     2     2     2     2      6
	.`Tab'.numfmt    .  %8.0g %8.0g %8.0g %8.0g %8.0g  %8.0g
	.`Tab'.strcolor  . result    .     .      .     .      .
	
	// display variance information table header
	.`Tab'.sep, top
	.`Tab'.titlefmt  .  %27s                  .  .	. . %14s
	.`Tab'.titles   "" "Imputation variance" "" "" "" "" "Relative"
	.`Tab'.titlefmt  .   %10s  %10s  %10s %10s %10s %14s
	.`Tab'.titles	""		/// 1
			"Within"	/// 2
			"Between"	/// 3
			"Total"		/// 4
			"RVI"		/// 5
			"FMI"		/// 6
			"efficiency"	 // 7

	// display VI table for coefficients
	if ("`nocoef'"=="") {
		.`Tab'.sep
		_mi_vartable_rows `Tab', `msopts'
	}
	// display VI table for transformed coefficients
	if (e(k_exp_mi)>0 & "`notrcoef'"=="") {
		.`Tab'.sep
		_mi_vartable_rows `Tab', `msopts' trcoef
	}
	.`Tab'.sep, bottom

end

program _mi_vartable_rows

	syntax namelist(name=Tab id="table class instance") [, trcoef * ]
	local msopts `options'

	if ("`trcoef'"!="") {
		local Q _Q
	}

	// get column names from b_mi or b_Q_mi
	_ms_eq_info, matrix(e(b`Q'_mi))
	local k_eq = r(k_eq)
	forval i = 1/`k_eq' {
		local coleq `"`coleq' `"`r(eq`i')'"'"'
		local coleqdim `coleqdim' `r(k`i')'
	}

	// check for auxiliary equations
	if ("`trcoef'"=="") { // if not transformed coeff.
		local k_aux 0
		if (!missing(e(k_aux))) { 
			local k_aux `e(k_aux)'
		}
		local k_eq_model = `k_eq' - `k_aux'
	}
	else {
		local k_eq_model `k_eq'
	}
	is_svysum `e(cmd_mi)'
	if (`k_eq_model'==1 & !r(is_svysum)) {
		local hideeq hideeqname
	}

	// display equations (do not skip equations)
	local showbase = (!missing(e(k_eq_base)) & ("`trcoef'"==""))	
	local eqstart 0
	forvalues eqno=1/`k_eq' {
		gettoken eq coleq : coleq
		if (`eqno'>`k_eq_model') { // aux. equations
			local hideeq hideeqname
			local eqaux `"`eq'"'
		}
		gettoken eqdim coleqdim : coleqdim
		if (`showbase' & `eqno'==e(k_eq_base)) {
			local comment "  (base outcome)"
			_mi_vartable_base_comment `Tab', 	///
						base(`eq') comment(`comment')
		}
		else {
			_mi_vartable_showeqname `Tab', eq(`eq') `hideeq'
			_mi_vartable_showeqs `Tab', 		///
					eqno(`eqno') 		///
					eqdim(`eqdim') 		///
					eqstart(`eqstart')	///
					eqaux(`eqaux')		///
					`trcoef'		///
					`msopts'		
		}
		if (`eqno'<`k_eq' & `"`eqaux'"'=="") {
			.`Tab'.sep
		}
		local eqstart = `eqstart'+`eqdim'
	}
end

program _mi_vartable_showeqname
	
	syntax namelist(name=Tab id="table class instance") [, 	///
					eq(string asis) hideeqname  ]
	
	if `"`eq'"' == "_" {
		local hideeqname hideeqname
	}
	else	local eqlgnd "`eq':"

	if ("`hideeqname'"!="") exit

	// show the equation name
	// columns         1   2  3  4  5  6  7
	.`Tab'.strcolor result   .  .  .  .  .  .
	.`Tab'.strfmt    %-12s   .  .  .  .  .  .
	if strpos(`"`eq'"', ".") {
		local p1 = 1
		local abeq : copy local eq
		while `:length local abeq' > 12 {
			local sub = substr(`"`eq'"',`p1',12)
			local p1 = `p1' + 12
			.`Tab'.row   `"`sub'"' "" "" "" "" "" ""
			local abeq = substr(`"`eq'"',`p1',.)
		}
	}
	else {
		local abeq = abbrev(`"`eq'"',12)
	}
	.`Tab'.row   `"`abeq'"' "" "" "" "" "" ""
	.`Tab'.strcolor   text   .  .  .  .  .  .
	.`Tab'.strfmt     %12s   .  .  .  .  .  .
end

program _mi_vartable_base_comment
	
	syntax namelist(name=Tab id="table class instance") [, 	///
				base(string asis) comment(string asis)  ]

	local base = abbrev(`"`base'"', 12)
	.`Tab'.strcolor result          text   .  .  .  .  .
	.`Tab'.strfmt    %-12s             .   .  .  .  .  .
	.`Tab'.row     `"`base'"' `"`comment'"' "" "" "" "" ""
	.`Tab'.strfmt     %12s             .   .  .  .  .  .
	.`Tab'.strcolor   text        result   .  .  .  .  .
end

program _mi_vartable_showeqs

	syntax namelist(name=Tab id="table class instance") 	///
				[, 	eqno(integer 1) 	///
					eqdim(integer 1)	///
					eqstart(integer 0)	///
					eqaux(string asis)	///
					trcoef			///
					*			/// //msopts 
				]
	local diopts `options'
	local ms_diopts `diopts'
	if !`:list posof "vsquish" in diopts' {
		local ms_diopts `ms_diopts' vsquish
	}

	if ("`trcoef'"!="") {
		local Q _Q
	}

	local error1 "  (no observations)"
	local error2 "  (stratum with 1 PSU detected)"
	local error3 "  (sum of weights equals zero)"
	local error4 "  (denominator estimate equals zero)"
	local error5 "  (omitted)"
	local error6 "  (base)   "
	local error7 "  (empty)  "

	local output 0
	local first
	tempname b0 se0 btw wth tot rvi fmi re
	forvalues i=1/`eqdim' {
		if (`"`eqaux'"'!="") { // display aux. equation name
			local label = "/" + abbrev(`"`eqaux'"', 11)
			di as txt `"{ralign 14: `label' {c |}}"' _c
		}
		else { // display row name
			_ms_display, eq(#`eqno') el(`i') 	///
				     matrix(e(b`Q'_mi)) `first' `ms_diopts'
			if r(output) {
				local first
				if !`output' {
					local output 1
					local ms_diopts `diopts'
				}
			}
			else {
				if r(first) {
					local first first
				}
				continue
			}
			local note	`"`r(note)'"'
		}

		local err 0
		if "`note'" == "(base)" {
			local err 6
		}
		if "`note'" == "(empty)" {
			local err 7
		}
		if "`note'" == "(omitted)" {
			local err 5
		}

		local el = `eqstart' + `i'
		scalar `b0'  = el(e(b`Q'_mi),1,`el')
		scalar `se0' = sqrt(el(e(W`Q'_mi),`el',`el'))
		if `se0' == 0 & `"`e(census)'"' != "1" {
			scalar `se0' = .
		}

		local error 0
		if `b0' == 0 {
			if missing(`se0') {
				if `err' {
					local error : copy local err
				}
				else {
					local error 5
				}
			}
		}

		// display row values
		.`Tab'.width . . . . . . ., noreformat
		if `error' {
			local note : copy local error`error'
			.`Tab'.row "" "`note'" "" "" "" "" ""
		}
		else if missing(`se0') {
			.`Tab'.row "" . . . . . . 
		}
		else {
			scalar `btw'	= el(e(B`Q'_mi),`el',`el')
			scalar `wth'	= el(e(W`Q'_mi),`el',`el')
			scalar `tot'	= el(e(V`Q'_mi),`el',`el')
			scalar `rvi'	= el(e(rvi`Q'_mi),1,`el')
			scalar `fmi'	= el(e(fmi`Q'_mi),1,`el')
			scalar `re'	= el(e(re`Q'_mi),1,`el')

			.`Tab'.row "" `wth' `btw' `tot' `rvi' `fmi' `re'
		}
		.`Tab'.width . |. . . . . ., noreformat
	} // end forvalues	

end

program esample_warning1
	di as txt as smcl "{p 0 9 0 78}"
	di as txt as smcl "{help mi_ewarning:Warning}: " _c
	di as txt "estimation sample varies across imputations;"
	di as txt "results may be biased."
	if (e(N_min_mi)==e(N_max_mi)) {
		di as txt "Sample sizes are constant but observations vary."
	}
	else {
		di as txt 	///
		   "Sample sizes vary between `e(N_min_mi)' and `e(N_max_mi)'."
	}
	di as txt as smcl "{p_end}"
end

program esample_warning2
	di as txt as smcl "{p 0 9 0 78}"
	di as txt as smcl "{help mi_ewarning:Warning}: " _c
	di as txt "varying estimation sample flag, {bf:e(esampvary_mi)},"
	di as txt "is one; results may be biased."
	di as txt as smcl "{p_end}"
end
