*! version 1.0.4  15jul2011
program u_mi_impute_xeq, rclass
	local version : di "version " string(_caller()) ":"
	version 11
	gettoken method 0 : 0

	_parse comma lhs rhs : 0
	local before `lhs'
	local 0 `rhs'
	syntax ,		IVARS(varlist)		/// //undoc.
			[ 				///
				ADD(string)		///
				REPLACE			///
				RSEED(string)		///
				NOIsily			///
				DOTS			///
				DOUBLE			///
				FORCE			///
				EXPNAMES(string)	/// //undoc.
				EXPLIST(string)		/// //undoc.
				ALLDOTS			/// //-mvn- opt
				IMPITERDOTS		/// //-mvn- opt
				IMPLOG			/// //-mvn- opt
				NOLOG			/// //-mvn- opt
				EMONLY			///
				EMONLY1(passthru)	/// //-mvn- opt
				MCMCONLY		/// //-mvn- opt
				*			/// // <method> opts
			]
	if ("`emonly'"!="") {	// -mcmconly- is ignored
		local mcmconly
	}
	if ("`mcmconly'"!="") {
		local impiterdots
	}
	if ("`implog'"!="") {
		local dots
	}
	if ("`impiterdots'"!="") { // -impiterdots- implies -dots-
		local alldots alldots
	}
	if ("`alldots'`dots'"=="") {
		local nodots nodots
	}
	if ("`nolog'"!="") {
		local alldots
		local nodots nodots
		local dots
		local impiterdots
		local implog
	}
	local mopts `options' `noisily' `impiterdots' `implog' `dots' `alldots'
	local mopts `mopts' `emonly' `mcmconly' `nolog' `emonly1'
	// double
	if ("`double'"=="") {
		local recasttype float
	}
	else {
		local recasttype double
	}
	// add imputations
	if ("`emonly'`mcmconly'"!="") { // ignore -add()- and -replace-
		local add = 0
		local replace
	}
	local M_old `_dta[_mi_M]'
	if ("`add'"=="") {
		local add = 0
	}
	local  M = `M_old'
	if (`add'>0) {
		qui mi set M += `add'
		local  M = `M'+`add'
	}
	local M_add = `M' - `M_old'
	if (`M_old'==0) {
		local replace
	}
	// -replace-
	if ("`replace'"!="") {
		local m_start = 1
	}
	else {
		local m_start = `M_old'+1
	}
	local m_end = `M'
	local nimpute = `m_end'-`m_start'+1
	local M_update 	= `nimpute'-`M_add'
	
	// ensures that sort order is consistent in m0 and m>0
	sort _mi_id
	local p : word count `ivars'
	tokenize `ivars'
	forvalues i=1/`p' {	
		qui _recast `recasttype' ``i''
	}
	if ("`method'"=="mvn") {
		local 0 `before'
		syntax [anything(equalok)] [if]
		marksample touse
		markout `touse' `ivars', sysmissok
		qui count if `touse'
		local N = r(N)
		tempvar one
		qui gen byte `one' = 1
		qui u_mi_certify_data, acceptable proper
	}
	// create expressions
	qui u_mi_impute_genexpr "`expnames'" "`explist'"
	qui save, replace
	local basename `_dta[_mi_name]'
	cap noi { // capture noi block
		// init <method>
		tempname ImpObj
		if ("`method'"=="monotone") {
			_mi_impute_monotone_setup `before', 		///
						ivars(`ivars') 		///
						impobj(`ImpObj')	///
						nimpute(`nimpute')	///
						`mopts'
		}
		else if ("`method'"=="mvn") {
			tempname postfimp postfem postfwlf
			_mi_impute_mvn_setup `before',	ivars(`ivars') 	///
				impobj(`ImpObj')			///
				postfnames(`postfimp' `postfem' `postfwlf') ///
				one(`one') touse(`touse') `mopts' 	///
				mstart(`m_start') `force'
			local stop `s(noimp)'
		}
		else {
			_mi_impute_main_setup `before', ivars(`ivars') 	///
						impobj(`ImpObj')	///
						method(`method')	
		}
		if ("`rseed'"!="") {
			`version' set seed `rseed'
		}
		else {
			local rseed `c(seed)'
		}
if ("`stop'"=="") { // stop on -emonly-
		if ("`method'"=="mvn") {
			local mstartopt mstart(`m_start') `force'
		}
		_mi_impute_`method'_init `before', 		///
					ivars(`ivars') 		///
					impobj(`ImpObj')	///
					expnames(`expnames')	///
					`mopts' `mstartopt'
		local stop `s(noimp)'
		if ("`stop'"!="") {
			local mcmconly mcmconly
		}
if ("`stop'"=="") {	// stop on -mcmconly-
		// main loop
		_imp_title title lastchar : `m_start' `m_end' "`dots'"
		if ("`method'"!="mvn") {
			if ("`dots'"!="") {
				di
				di as txt "`title'`lastchar'"
				u_mi_dots, indent(2) `nodots'
			}
		}
		else if ("`method'"=="mvn" & "`impiterdots'"=="") {
			local title = lower(`"`title'"')
			u_mi_dots, title(`"`title'"') indent(2) `nodots'
		}
		local j = 1
		local dot_rc  0
		forvalues i=`m_start'/`m_end' { // store imputations
			qui use _`i'_`basename'
			sort _mi_id
			qui recast `recasttype' `ivars'
			// create expressions
			qui u_mi_impute_genexpr "`expnames'" "`explist'"
			// call method-specific imputer
			if ("`method'"=="monotone") {
				cap noi _mi_impute_`method' "`ImpObj'" ///
						"`i'" "`j'" "`force'" bad
			}
			else if ("`method'"=="mvn") {
				if (`i'>`m_start') {
					cap noi _mi_impute_`method' ///
							"`ImpObj'" "`i'" ///
							"`impiterdots'"  ///
							"`force'" bad
				}
				else {
					cap noi mata: `ImpObj'.post_impvals()
				}
			}
			else {
				cap noi _mi_impute_`method' "`ImpObj'"
			}
			local cmd_rc = _rc
			local dot_rc = (`cmd_rc'!=0)
			if (`cmd_rc' & (`cmd_rc'!=504 & `cmd_rc'!=459)) {
				// stop on error other than 504 or 459
				di as err "{p 0 0 2}"
				di as err "error occurred during imputation" 
				di as err "of {bf:`ivars'} on {bf:m = `i'}"
				di as err "{p_end}"
				exit `cmd_rc'
			}
			if ("`impiterdots'"=="") {
				cap noi u_mi_dots `j' `dot_rc', 	///
							every(10)`nodots'
			}
			if (`cmd_rc') { // errors 504 or 459
				// imputation step resulted in miss. values
				if ("`force'"=="") {
					// stop, do not replace existing imp.
					if ("`method'"!="monotone" & ///
					    "`method'"!="mvn") {
						dierr `cmd_rc' "`ivars'"
					}
					else {
						dierr `cmd_rc' "`bad'"
					}
					exit 498
				}
				// continue
			}
			qui compress `ivars'
			if ("`expnames'"!="") {
				qui drop `expnames'
			}
			cap drop `touse'
			cap drop `one'
			qui save _`i'_`basename', replace
			local ++j
		}
} // end mcmconly
} // end emonly 
	} // end capture noi block
	local rc = _rc
	if (`rc') {
		_mi_impute_`method'_clean "`ImpObj'" ///
			`"`postfimp'"' `"`postfem'"' `"`postfwlf'"'
		exit `rc'
	}
	if ("`emonly'`mcmconly'"!="") {
		di
		di as txt "Note: no imputation performed."
	}
	if ("`stop'"=="") { // -emonly- or -mcmconly-
		if ("`impiterdots'"=="") {
			u_mi_dots, last `nodots'
		}
		cap noi {
			if ("`method'"=="mvn") {
				mata: _mi_header("Multivariate imputation", ///
				          "Multivariate normal regression", ///
				       `m_start',`m_end',`M',`M_add',`M_update')
				mata: `ImpObj'.print()
			}
			else {
				mata: ///
	`ImpObj'.print("`method'",`m_start',`m_end',`M', `M_add',`M_update')
			}
			// saved results
			//ret clear
			mata: `ImpObj'.rresults()
			ret scalar mcmconly = 0
			ret scalar emonly = 0
		}
		local rc = _rc
	}
	else {
		local rc = 0
		if ("`mcmconly'"!="") {
			cap noi mata: `ImpObj'.rresults()
			ret scalar mcmconly = 1
			ret scalar emonly = 0
			local rc = _rc
		}
		else {
			ret scalar mcmconly = 0
			ret scalar emonly = 1
		}
	}
	ret add
	ret scalar M_update 	= `M_update'
	ret scalar M_add 	= `M_add'
	ret scalar M 		= `M'
	ret local rseed 	"`rseed'"
	ret local ivars		"`ivars'"
	ret local method	"`method'"
	_mi_impute_`method'_clean "`ImpObj'" ///
			`"`postfimp'"' `"`postfem'"' `"`postfwlf'"'
	if (`rc') {
		exit `rc'
	} 
	qui if "`basename'"!="" {
		use `basename', clear // load orig. data back in memory
		compress `ivars'
		if ("`expnames'"!="") {
			qui drop `expnames'
		}
		save, replace
	}
end

program _imp_title
	args imptitle lastchar colon mstart mend dots

	if ("`dots'"!="") {
		local endti ":"
	}
	else {
		local endti " ... "
	}
	local n = `mend'-`mstart'+1
	if (`n'>1) {
		local title Imputing {it:m}=`mstart' 
		local title `title' through {it:m}=`mend'
	}
	else {
		local title Imputing {it:m}=`mstart'
	}
	c_local `imptitle' `title'
	c_local `lastchar' `"`endti'"'
end

program _mi_impute_mvn
	args impobj i impiterdots force bad

	mata: st_local("impevery", strofreal(`impobj'.impevery))

	if ("`impiterdots'"!="") {
		u_mi_dots, title(imputing {it:m}=`i') indent(2) reps(`impevery')
	}
	mata: `impobj'.post_impvals()
	cap noi mata: `impobj'.da_impute(`i',1)
	if _rc==459 {
		if ("`force'"=="") {
			c_local `bad' `badvars'
			exit _rc
		}
	}
	else if _rc {
		exit _rc
	}
end

program _mi_impute_mvn_init, sclass
	syntax [varlist(default=none fv)] [if], 		///
				IVARS(varlist)			///
			[ 					///
				NOCONStant			///
				BURNin(integer 100)		///
				BURNBetween(integer 100)	///
				PRIor(string)			///
				INITMcmc(string)		///
				WLFWGT(string)			///
				SAVEWlf(string asis)		///
				SAVEPtrace(string asis)		///
				SAVINGPARAMS(string)		///
				EMONLY				///
				EMONLY1(string)			///
				MCMCONLY			///
				DOTS				///
				NOLOG				///
				IMPLOG				/// // undoc.
				SHOWITER			/// // undoc.
				SHOWITER1(numlist)		/// // undoc.
				ALLDOTS				///
				IMPITERDOTS			///
				EMOUTput			///
				EMLOG				/// 
				POSTFNAMES(namelist)		/// //undoc.
				PDTOLERANCE(real 1e-12)		///
				NOCHECKPD			///
				IMPOBJ(name)			///
				MSTART(string)			///
				FORCE				///
				*				///
			]
	if ("`nolog'"=="") {
		if ("`alldots'`dots'"=="") {
			di as txt _n "Performing MCMC data augmentation ... "
		}
		else {
			di as txt _n "Performing MCMC data augmentation: "
		}
	}
	if ("`implog'"=="" & "`alldots'"!="") {
		u_mi_dots, title("burn-in") indent(2) reps(`burnin')
	}
	if ("`mcmconly'"!="") {
		local mstart=0
	}
	mata: `impobj'.da_burnin(`mstart', 1)
	if ("`impiterdots'"!="") {
		di as txt "  imputing {it:m}=1 done"
	}
	sret clear
	if ("`mcmconly'"!="") {
		sret local noimp noimp
	}
end

program _mi_impute_mvn_setup, sclass
	syntax [varlist(default=none fv)] [if], 		///
				IVARS(varlist)			///
			[ 					///
				NOCONStant			///
				BURNin(integer 100)		///
				BURNBetween(integer 100)	///
				PRIor(string)			///
				INITMcmc(string)		///
				WLFWGT(string)			///
				SAVEWlf(string asis)		///
				SAVEPtrace(string asis)		///
				SAVINGPARAMS(string)		///
				EMONLY				///
				EMONLY1(string)			///
				MCMCONLY			///
				DOTS				///
				NOIsily				///
				NOLOG				///
				IMPLOG				/// // undoc.
				SHOWITER			/// // undoc.
				SHOWITER1(numlist)		/// // undoc.
				ALLDOTS				///
				IMPITERDOTS			///
				EMOUTput			///
				EMLOG				/// 
				PDTOLERANCE(real 1e-12)		///
				NOCHECKPD			///
				IMPOBJ(name)			/// //undoc
				POSTFNAMES(string)		/// //undoc
				ONE(varname)			/// //undoc
				TOUSE(varname)			/// //undoc
				MSTART(string)			/// //undoc
				FORCE				///
			]
	mata: `impobj' = _DA_Norm()
	if ("`nolog'"!="") {
		local noheaderlog qui
	}

	local xvars `varlist'
	// prior()
	CheckPrior `prior'
	local prior `s(prior)'
	local priordf `s(priordf)'

	// saving options
	local savemcmc `"`saveptrace'"'
	if (`"`savemcmc'"'!="") {
		_savingopt_parse mcfilename mcreplace : ///
					saveptrace ".stptrace" `"`savemcmc'"'
		if ("`mcreplace'"=="") {
			confirm new file `"`mcfilename'"'
		}
	}
	tokenize `postfnames'
	local postfimp `1'
	local postfem `2'
	local postfwlf `3'
	// -savingparams()-
	local impsaving `"`savingparams'"'
	if (`"`impsaving'"'!="") {
		_savingopt_parse fname replace : ///
			savingparams ".dta" `"`impsaving'"'
		if ("`replace'"=="") {
			confirm new file `"`fname'"'
		}
		u_build_postnames "`ivars'" "`xvars'" "`noconstant'"
		local postnames `s(names)'
		qui postfile `postfimp' long(iter) long(m) 		///
				    double(`postnames') 		///
				    double(wlf)				///
				    using `"`fname'"', `replace'
	}
	
	// -initmcmc()-
	if ("`emonly'"!="") {
		local initmcmc		// ignore initmcmc()
		local dainittype em
		local dainitopts `emonly1'
	}
	else {
		local 0 `initmcmc'
		syntax [anything(name=dainittype)] [, * ]
		local dainitopts `options'
		InitParse da, `dainittype' name("initmcmc()")
		local dainittype `s(init)'
	}
	if ("`dainittype'"=="em") {
		local 0 , `dainitopts'
		syntax [, 					///
				ITERate(integer 100)		///
				TOLerance(real 1e-5)		///
				INIT(string)			///
				MISSing				///
				NOLOG				///
				SAVEPtrace(string asis)		///
				SAVINGPARAMS(string asis)	/// //undoc.
				SWEEP				/// //undoc.
			]
		local emtolerance `tolerance'
		local emiterate	  `iterate'
		local emnolog	  `nolog'
		local emmissing	  `missing'

		if ("`emonly'"!="" | "`noisily'"!="") {
			local emoutput emoutput
		}

		if ("`emoutput'"=="" & "`emlog'"=="") {
			local emnolog emnolog
		}

		local eminit	  `init'
		InitParse em, `eminit' name("init()")
		local eminittype `s(init)'
		
		// -emsaveptrace()-
		local emsaveptrace `"`saveptrace'"'
		if (`"`emsaveptrace'"'!="") {
			_savingopt_parse emcfilename emcreplace : ///
				saveptrace ".stptrace" `"`emsaveptrace'"'
			if ("`emcreplace'"=="") {
				confirm new file `"`emcfilename'"'
			}
		}
		
		// -emsaving()-
		local emsaving `"`savingparams'"'
		if (`"`emsaving'"'!="") {
			_savingopt_parse emfname emreplace : ///
				savingparams ".dta" `"`emsaving'"'
			if ("`emreplace'"=="") {
				confirm new file `"`emfname'"'
			}
			u_build_postnames "`ivars'" "`xvars'" "`noconstant'"
			local postnames `s(names)'
			qui postfile `postfem' long(iteration) 	///
					   double(`postnames') ///
				    	   using `"`emfname'"', `emreplace'
		}
	}
	else {
		local dainit `initmcmc'
	}
	// -wlfwgt()-
	if (`"`wlfwgt'"'!="") {
		cap confirm matrix `wlfwgt'
		if (_rc) {
			di as err "{bf:wlfwgt()} must contain " ///
				  "valid Stata matrix"
			exit 198
		}
	}
	// -savewlf()-
	if (`"`savewlf'"'!="") {
		if ("`dainittype'"!="em" & "`wlfwgt'"=="") {
			di as err "{p 0 0 2}{bf:savewlf()} "	///
				  "requires specification of "	///
				  "{bf:wlfwgt()} when {bf:initmcmc(em)} " ///
				  "is not used{p_end}"
			exit 198
		}
		_savingopt_parse fname replace : ///
			savewlf ".dta" `"`savewlf'"'
		if ("`replace'"=="") {
			confirm new file `"`fname'"'
		}
		qui postfile `postfwlf' long(iter) long(m) ///
				    double(wlf)				 ///
				    using `"`fname'"', `replace'
	}
	
	qui count if `touse'
	local N = r(N)

	`noheaderlog' mata: `impobj'.init("`ivars'","`xvars'","`one'","`touse'")
	sret clear
	if ("`emonly'"!="") {
		sret local noimp noimp
	}
end

program InitParse, sclass

	syntax [anything(name=method)] [, * ]
	if ("`method'"=="em") {
		local ADDOPTS ac cc
		local default ac
	}
	else if ("`method'"=="da") {
		local ADDOPTS em
		local default em
	}
	else {
		di as err "InitParse:  unknown method {bf:`method'}"
		exit 198
	}
	sret clear

	local 0 , `options' 
	syntax [,			///
			Betas(string)	///
			SDs(string)	///
			VARs(string)	///
			COV(string)	///
			CORR(string)	///
			`ADDOPTS'	///
			NAME(string) 	///
		  	* 		/// //options
		]

	if ("`name'"=="") {
		local name init()
	}

	if ("`options'"!="") {
		di as err as smcl "`name':  {bf:`options'} not allowed"
		exit 198
	}	
	local opts `betas'`sds'`cov'`corr'`vars'
	local addopts `cc'`ac'`em'

	if ("`addopts'`opts'"=="") {
		sret local init "`default'"
		exit 0
	}
	
	if ("`addopts'"!="") {
		if ("`cc'"!="" & "`ac'"!="") {
			di as err as smcl ///
				"`name':  {bf:cc} and {bf:ac} cannot " ///
				"be combined"
			exit 198
		}
		if ("`opts'"!="") {
			di as err as smcl ///
				"`name':  {bf:`addopts'} cannot be " ///
				"combined with other {bf:`name'}'s suboptions"
			exit 198
		}
		sret local init "`addopts'"
		exit 0
	}
	if ("`cov'"!="" & ("`sds'`vars'`corr'"!="")) {
		di as err as smcl "`name':  {bf:cov()} cannot be "	///
		   "combined with {bf:sds()}, {bf:vars()} or {bf:corr()}"
		exit 198
	}
	if ("`sds'"!="" & "`vars'"!="") {
		di as err as smcl "`name':  {bf:sds()} and {bf:vars()}" ///
			"cannot be combined"
		exit 198
	}
	sreturn local init "user"
end

program u_build_postnames, sclass
	args yvars xvars noconstant

	tokenize `yvars'
	local p: word count `yvars'
	forvalues i=1/`p' {
		local xlist `xvars'
		while ("`xlist'"!="") {
			gettoken var xlist: xlist
			local bnames `bnames' beta_``i''_`var'
		}
		if ("`noconstant'"=="") {
			local bnames `bnames' beta_``i''_cons
		}
		local cnames `cnames' var_``i''
		forvalues j=`=`i'+1'/`p' {
			local cnames `cnames' cov_``i''_``j''
		}
	}

	sret clear
	sret local names "`bnames' `cnames'"
end

program CheckPrior, sclass

	syntax [anything] [, df(string) ]
	local prior `anything'

	local n : word count `prior'
	if (`n'>1) {
		di as err "{bf:prior()}: only one of {bf:uniform}, "	///
			  "{bf:jeffreys}, or {bf:ridge} is allowed"
		exit 198
	}
	if ("`prior'"=="") {
		local prior uniform
	}
	local len = strlen("`prior'")
	if ("`prior'"==substr("uniform",1,`len')) {
		if ("`df'"!="") {
			di as err 	///
			"{bf:prior()}: suboption {bf:df()} is not allowed " ///
				  "with {bf:uniform} or {bf:jeffreys}"
			exit 198
		}
		local prior uniform
	}
	else if ("`prior'"==substr("jeffreys",1,`len')) {
		if ("`df'"!="") {
			di as err ///
		"{bf:prior()}: suboption {bf:df()} is not allowed " ///
				  "with {bf:uniform} or {bf:jeffreys}"
			exit 198
		}
		local prior jeffreys
	}
	else if ("`prior'"==substr("ridge",1,`len')) {
		if ("`df'"=="") {
			di as err ///
			  "{bf:prior()}: suboption {bf:df()} is required " ///
				  "with {bf:ridge}"
			exit 198
		}
		else {
			cap confirm number `df'
			local rc1 = _rc
			if (`rc1' | `df'<0) {
di as err "{bf:prior()}: suboption {bf:df()} must contain nonnegative number"
exit 198
			}
			if (`df'>=2^28)	{
di as err "{bf:prior()}: degrees of freedom in {bf:df()} are too large; the maximum is 2^28"
exit 198
			}
		}
		local prior ridge
	}
	else {
		di as err "{bf:prior()}: {bf:`prior'} is not allowed"
		exit 198
	}

	sret clear
	sret local prior `prior'
	sret local priordf `df'
end

program _mi_impute_mvn_clean
	args a f1 f2 f3
	cap mata: mata drop `a'
	cap postclose `f1'
	cap postclose `f2'
	cap postclose `f3'
end

program _mi_impute_regress_clean
	args a
	cap mata: mata drop `a'
end

program _mi_impute_pmm_clean
	args a
	cap mata: mata drop `a'
end

program _mi_impute_logit_clean
	args a
	cap mata: mata drop `a'
end

program _mi_impute_ologit_clean
	args a
	cap mata: mata drop `a'
end

program _mi_impute_mlogit_clean
	args a
	cap mata: mata drop `a'
end

program _mi_impute_monotone_clean
	args a
	mata : st_local("clnames", `a'.clnames)
	mata : st_local("eststub", `a'.eststub)
	local n : word count `clnames'
	tokenize `clnames'
	forvalues i=1/`n' {
		cap estimates drop `eststub'`i'
		cap mata: mata drop ``i''
	}
	cap mata: mata drop `a'
end

program _mi_impute_monotone_init
	syntax [anything(everything)] [, IMPOBJ(name) *]

	mata: st_local("k_eq", strofreal(`impobj'.k_eq))
	mata: st_local("clnames", `impobj'.clnames)
	local eststub "__mi_impute_estimates"
	mata: `impobj'.eststub = "`eststub'"
	forvalues i=1/`k_eq' {
		mata: st_local("method", `impobj'.M[`i'].method)
		mata: st_local("spec", `impobj'.M[`i'].spec)
		mata: st_local("expnames", `impobj'.M[`i'].expvarlist)
		gettoken clname clnames : clnames
		gettoken ivar ivarscp : ivarscp
		// replace existing missing values in ivar with (.)
		mata: `clname'.fillmis()
		// recompute expressions
		qui u_mi_impute_replace_expr "`expnames'"
		_mi_impute_`method'_init `spec' impobj("`clname'")
		qui estimates store `eststub'`i', nocopy
		mata: `impobj'.Nv[`i']	   = `clname'.N
		mata: `impobj'.Nv_c[`i']   = `clname'.N_c
		mata: `impobj'.Nv_inc[`i'] = `clname'.N_inc
		mata: `impobj'.Nv_e[`i']   = `clname'.N_e
		mata: `impobj'.fwnote = max((`impobj'.fwnote,`clname'.fwnote))
	}
end

program _mi_impute_monotone_setup
	syntax [anything(equalok)] [if], 			///
					IVARS(varlist)		///
				[,				///
					IMPOBJ(name)		///
					METHODS(string)		///
					NIMPUTE(integer 1)	///
					NOIsily			///
					NOLEGend		///
					*			///
				]
	marksample touse
	markout `touse' `ivars', sysmissok
	mata: `impobj' = _Imp_monotone()
	mata: `impobj'.touse = st_data(.,"`touse'")
	mata: `impobj'.ivars = "`ivars'"
	mata: `impobj'.methods = "`methods'"

	_parse expand lhs glb : 0
	mata: `impobj'.init(`lhs_n', `nimpute')
	local eststub "__mi_impute_est"	// perm. temp. name
	forvalues i=1/`lhs_n' {
		gettoken method methods : methods
		_parse comma l r : lhs_`i'
		local 0 `r'
		syntax [, EXPNAMES(string) IVARS(string) * ]
		mata: `impobj'.add_method(`i',			///
					  "`method'",		///
					  `"`lhs_`i''"', 	///
					  "`expnames'")
		mata: u_mi_get_mata_instanced_var("clname", "__imethod")
		local clnames `clnames' `clname'
		_mi_impute_main_setup `lhs_`i'' impobj(`clname') method(`method')
	}
	mata: `impobj'.clnames = "`clnames'"

end

program _mi_impute_monotone
	args impobj m ind force bad

	mata: st_local("k_eq", strofreal(`impobj'.k_eq))
	mata: st_local("ivars", `impobj'.ivars)
	mata: st_local("clnames", `impobj'.clnames)
	mata: st_local("eststub", `impobj'.eststub)
	local ivarscp `ivars'
	local haserr 0
	forvalues i=1/`k_eq' {
		mata: st_local("method", `impobj'.M[`i'].method)
		mata: st_local("spec", `impobj'.M[`i'].spec)
		mata: st_local("expnames", `impobj'.M[`i'].expvarlist)
		gettoken clname clnames : clnames
		gettoken ivar ivarscp : ivarscp
		// replace existing missing values in ivar with (.)
		mata: `clname'.fillmis()
		// recompute expressions
		qui u_mi_impute_replace_expr "`expnames'"
		qui estimates restore `eststub'`i'
		cap noi _mi_impute_`method' "`clname'"
		if _rc==504 | _rc==459 {
			local badvars `badvars' `ivar'
			if ("`force'"=="") {
				c_local `bad' `badvars'
				exit _rc
			}
			local ++haserr
		}
		else if _rc {
			exit _rc
		}
		mata: `impobj'.Nv_imp[`i',`ind'] = `clname'.N_imp[1]
	}
	c_local `bad' `badvars'
	if (`haserr') {
		exit 459
	}
end

// creates an object and sets the analysis sample
program _mi_impute_main_setup

	syntax [varlist(numeric default=none fv)] [if] [in] [fw aw pw iw],  ///
				IVARS(varlist)		///
				IMPOBJ(name)		///
				METHOD(string)		///
			[				///
				*			///
			]
	// 'touse' determines analysis sample
	local 0 `if' `in'
	syntax [if] [in]
	marksample touse
	markout `touse' `ivars', sysmissok

	mata: `impobj' = _Imp_`method'()
	mata: `impobj'.setup("`ivars'", "`touse'")
end

program _mi_impute_main_init
	// get additional options specific to each method
	local hold0 `0'
	gettoken before after : 0, parse(",")
	if ("`before'"==",") {
		local after , `after'
		local before
	}
	local 0 `after'
	syntax , METHOD(string) [ * ]
	u_mi_impute_get_cmdopts `method'
	local ADDOPTS `s(opts)'
	local 0 `hold0'

	syntax [varlist(numeric default=none fv)] [if] [in] [fw aw pw iw],  ///
				IVARS(varlist)		/// //undoc.
				METHOD(string)		/// //undoc.
			[ 				///
				CMD(string)		/// //undoc.
				CMDNAME(string)		/// //undoc.
				IMPOBJ(string)		/// //undoc.
				EXPNAMES(string)	/// //undoc.
				EXPLIST(string)		/// //undoc. 
				DOTS			/// //ignored
				NOIsily			///
				NOCONStant		///
				KNN(passthru)		/// //imp. method opts
				PMTOLerance(passthru)	///
				nredraws(passthru)	/// //undoc.
				*			///
			]
	local xvars `varlist'
	local cmdopts `options'

	if ("`cmd'"=="") {
		local cmd `method'
	}
	if ("`cmdname'"=="") {
		local cmdname `method'
	}

	if ("`weight'"!="") {
		local wgtexp [`weight'`exp']
	}
	
	// mark analysis sample
	tempvar touse
	mark `touse' `if' `in'
	markout `touse' `ivars', sysmissok

	// handle weights
	qui if ("`weight'"!= "" & "`weight'"!="pweight")  {
		// pweights are not used at the imputation step
		tempvar impwgt
		gen double `impwgt' `exp' if `touse'
		local wtype `weight'
	}
	// mark estimation sample
	marksample esamp
	markout `esamp' `ivars'
	local 0 `wgtexp', `options' `noisily' `noconstant' ///
			  `knn' `pmtolerance' `nredraws'
	syntax [fw aw iw pw] [, `ADDOPTS' * ]
	if ("`offset'"!="") {
		markout `esamp' `offset'
		local rmcollopts offset(`offset')
	}
	if ("`method'"=="logit") {
		local rmcollopts logit `asis' noskipline
		local rmvarlist `ivars' `xvars'
	}
	else {
		local rmvarlist `xvars'
	}
	if ("`noisily'"!="") {
		di
		di as txt "Running {bf:`cmdname'} on observed data:"
	}
	else {
		// displays a note about omitted variables
		_rmomitvars `rmvarlist' if `esamp' `wgtexp', 	///
				`noconstant' expand `rmcollopts'
	}
	if ("`noisily'"!="") {
		DiExpHeader "`expnames'"
	}
	// run <command>
	qui `noisily' `cmd' `ivars' `xvars' if `esamp' `wgtexp', ///
					`noconstant' `cmdopts'
	if ("`method'"=="logit" & "`e(rules)'"=="matrix") {
		tempname omt
		mata: st_numscalar("`omt'",allof(st_matrix("e(rules)")[.,1],4))
		if el(e(rules),1,1)!=0 & !`omt' {
di as err "{bf:mi impute `method'}: perfect predictor(s) detected"	///
  "{p 4 4 2}Variables predicting an outcome perfectly detected when "   ///
  "{bf:`cmdname'} executed on the observed data. First, specify "	///
  "{bf:mi impute}'s option {bf:noisily} to identify the identities "	///
  "of the problem covariates.  Then either remove perfect predictors "	///
  "from the model or specify {bf:mi impute}'s option {bf:asis}.{p_end}"
exit 498
		}
	}
	if (e(converged)==0) {
		di as err "{bf:`cmdname'} failed to converge on observed data"
		exit 430
	}
	if "`wtype'" == "aweight" { // need this to adjust variance estimate
		summ `impwgt' if e(sample), meanonly
		tempname awgtmean               
		scalar `awgtmean' = r(mean)
		local wgtadj `", "`awgtmean'""'
	} 
	// init object
	mata: `impobj'.init("`ivars'","`touse'","`impwgt'" `wgtadj')
end

program _mi_impute_regress_init
	_mi_impute_main_init `0' method(regress) cmd(_regress) cmdname(regress)
end

program _mi_impute_pmm_init
	_mi_impute_main_init `0' method(pmm) cmd(_regress) cmdname(regress)
end

program _mi_impute_logit_init
	_mi_impute_main_init `0' method(logit) cmd(logit) cmdname(logit)
end

program _mi_impute_ologit_init
	_mi_impute_main_init `0' method(ologit) 
end

program _mi_impute_mlogit_init
	_mi_impute_main_init `0' method(mlogit) 
end

program _mi_impute_main, eclass
	args impobj ptype stub opt

	if ("`ptype'"=="") {
		local ptype xb
	}
	// draw parameters from posterior distr.	
	mata: st_local("rc", strofreal(`impobj'.draw_parms()))
	if (`rc') {
		mata: `impobj'.N_imp = `impobj'.N_imp, 0
		exit 504
	}
	// repost coef. to obtain predictions
	tempvar touse
	qui gen byte `touse'=.
	mata: st_store(.,"`touse'",`impobj'.touse)
	tempname b
	mata: st_matrix("`b'", `impobj'.beta')
	eret repost b = `b', esample(`touse')
	if ("`stub'"=="") {
		tempvar pred
		qui predict double `pred' if e(sample), `ptype' `opt'
		qui count if e(sample) & `pred'<.
		if e(k)==e(k_aux) { // for ologit only; empty if
		}
		else if (r(N)==0) {
			mata: `impobj'.N_imp = `impobj'.N_imp, 0
			exit 459
		}
		local prednames `pred'
	}
	else {
		tempname pred
		qui predict double `pred'* if e(sample), `ptype'
		local 0 `pred'*
		syntax [varlist]
		local prednames `varlist'
	}
	// impute values
	mata: st_local("rc", strofreal(`impobj'.impute("`prednames'")))
	if (`rc') {
		exit 459
	}
end

program _mi_impute_regress, eclass
	args impobj
	_mi_impute_main `impobj' xb
end

program _mi_impute_pmm, eclass
	args impobj
	_mi_impute_main `impobj' xb
end

program _mi_impute_logit, eclass
	args impobj
	_mi_impute_main `impobj' pr "" "rules"
end

program _mi_impute_ologit, eclass
	args impobj
	_mi_impute_main `impobj' xb
end

program _mi_impute_mlogit, eclass
	args impobj
	_mi_impute_main `impobj' pr stub
end

program DiExpHeader
	args varlist

	if ("`varlist'"=="") exit

	local p : word count `varlist'
	tokenize `varlist'
	di
	forvalues i=1/`p' {
		local exp : variable label ``i''
		local name = abbrev("``i''", 12)
		local pos  = 12 - strlen("`name'")
		di "{p `pos' 15 2}"
		di as txt "`name':  " as res `"`exp'"'
		di "{p_end}"
	}
end

program _rmomitvars, sclass
	_rmcoll `0'
	if (`r(k_omitted)') {
		local xvars
		local list `r(varlist)'
		foreach term of local list {
			_ms_parse_parts `term'
			if (!strmatch(`"`r(op)'"',"*o*")) {
				local xvars `xvars' `term'
			}
		}
	}
	else {
		local xvars `r(varlist)'
	}

	sret clear
	sret local varlist "`xvars'"
end

program dierr
	args err ivars

	if (`err'==504) {
		di as err "{p 0 0 2}Coefficients (or residual variance) "  ///
			  "estimated from the observed data are missing. " ///
			  "This may happen, for example, when the number " ///
			  "of parameters exceeds the number of "	   ///
			  "observations. Choose an alternate imputation " ///
			  "model.{p_end}"
	}
	else if (`err'==459) {
		_errmiss "`ivars'"
	}
end

program _errmiss
	args ivars

	local n: word count `ivars'

	di as err "{p}{bf:`ivars'}: missing imputed values produced{p_end}"
	di as err "{p 4 4 2}This may occur when imputation variables"
	di as err "are used as independent variables or when independent"
	di as err "variables contain missing values.  You can specify option "
	di as err "{bf:force} if you wish to proceed anyway."
	di as err "{p_end}"

end
