*! version 1.0.2  09jun2011
program define unzipfile
	version 11.0
	syntax anything[, replace]

	gettoken ZipFileName rest : anything

	if (`"`rest'"' != "") {
		di as error "invalid syntax"
		exit 198
	}
	if (`"`replace'"' != "") {
		local overwrite "overwrite"
	}
	
	mata : zipfile_cmd()
end

version 11.0
mata:

void zipfile_cmd()
{
	string scalar cmd, overwrite, Tok, ReverseTok, FileName, Path
	real scalar rc
	
	Tok = st_local("ZipFileName")
	overwrite = st_local("overwrite")
	Tok = subinstr(Tok, "\", "/")
	if (strpos(Tok, "/")) {
		ReverseTok = strreverse(Tok)
		FileName = ///
		strreverse(substr(ReverseTok, 1, strpos(ReverseTok, "/")-1))
		Path = /// 
		strreverse(substr(ReverseTok, strpos(ReverseTok, "/"), .))
		if(strpos(FileName, ".") == 0) {
			FileName = FileName + ".zip"
			Tok = Path + FileName
		}
	}
	else {
		if(strpos(Tok, ".") == 0) {
			Tok = Tok + ".zip"
		}
	}

	if (overwrite != "") {
		cmd = sprintf(`"_unzipfile "%s",  overwrite"', Tok)	
	}
	else {
		cmd = sprintf(`"_unzipfile "%s""', Tok)	
	}


	rc = _stata(cmd)
	if (rc) {
		exit(601)
	}
}
end

exit


