{smcl}
{* *! version 1.1.3  19jul2011}{...}
{cmd:help xtdpdsys postestimation} {right:dialogs:  {dialog xtdpd_p:predict}  {dialog xtdpd_estat:estat}}
{right:also see:  {help xtdpdsys}{space 6}}
{hline}

{title:Title}

{p2colset 5 37 39 2}{...}
{p2col :{manlink XT xtdpdsys postestimation} {hline 2}}Postestimation tools for xtdpdsys{p_end}
{p2colreset}{...}


{title:Description}

{pstd}
The following postestimation commands are of special interest after 
{cmd:xtdpdsys}:

{synoptset 16}{...}
{p2coldent :command}description{p_end}
{synoptline}
{synopt :{helpb xtdpdsys postestimation##estatabond:estat abond}}test for
autocorrelation{p_end}
{synopt :{helpb xtdpdsys postestimation##estatsargan:estat sargan}}Sargan test
of overidentifying restrictions{p_end}
{synoptline}
{p2colreset}{...}


{pstd}
The following standard postestimation commands are also available:

{synoptset 11}{...}
{p2coldent :command}description{p_end}
{synoptline}
{p2col :{helpb estat}}VCE and estimation sample summary{p_end}
INCLUDE help post_estimates
INCLUDE help post_lincom
INCLUDE help post_margins
INCLUDE help post_nlcom
{p2col :{helpb xtdpdsys postestimation##predict:predict}}predictions, residuals,
 influence statistics, and other diagnostic measures{p_end}
INCLUDE help post_predictnl
INCLUDE help post_test
INCLUDE help post_testnl
{synoptline}
{p2colreset}{...}


INCLUDE help xtdpd_postspecial


INCLUDE help xtdpd_predict


INCLUDE help xtdpd_postspecial2a


INCLUDE help xtdpd_postspecial2c


INCLUDE help xtdpd_postspecial2d


{title:Examples}

{pstd}Setup{p_end}
{phang2}{cmd:. webuse abdata}{p_end}
{phang2}{cmd:. xtdpdsys n w k, vce(robust)}{p_end}

{pstd}Obtain default AR tests{p_end}
{phang2}{cmd:. estat abond}{p_end}

{pstd}Request a higher order than originally computed{p_end}
{phang2}{cmd:. estat abond, artests(3)}{p_end}

{pstd}Obtain the Sargan test{p_end}
{phang2}{cmd:. estat sargan}{p_end}

{pstd}Compute the linear prediction{p_end}
{phang2}{cmd:. predict nhat, xb}

{pstd}Test that the coefficients on the first-difference of {cmd:w} and the
lagged first difference of {cmd:w} are jointly zero{p_end}
{phang2}{cmd:. test D1.w = 0, notest}{p_end}
{phang2}{cmd:. test LD.w = 0, accumulate}


{title:Also see}

{psee}
Manual:  {manlink XT xtdpdsys postestimation}

{psee}
{space 2}Help:  {manhelp xtdpdsys XT}
{p_end}
