*! version 4.3.3  09jun2011
program xtmixed, eclass byable(onecall) prop(xt mi)
	global XTM_ver = _caller()
	version 9
	
	if _by() {
		local by "by `_byvars'`_byrc0':"
	}
	if replay() {
		if "`e(cmd)'" != "xtmixed" {
			error 301
		}
		if _by() {
			error 190
		}
		_xtmixed_display `0'
		exit
	}

	if _caller() >= 11 {
		local vv : di "version " string(_caller()) ":"
	}
	capture noisily `vv' `by' Estimate `0'
	local rc = _rc
	ereturn local cmdline `"xtmixed `0'"'
	capture mata: _xtm_cleanup()
	capture mac drop XTM_*
	exit `rc'
end

program Estimate, sortpreserve eclass byable(recall)
	if _caller() >= 11 {
		local vv : di "version " string(_caller()) ":"
	}
	version 9
	local globopts `"Level(cilevel) PPARSEPOST"'
	local globopts `"`globopts' REML MLe VARiance EMITERate(integer 20)"'
	local globopts `"`globopts' EMTOLerance(real 1e-10) EMLOG EMDOTs"'
	local globopts `"`globopts' noGRoup noHEADer ESTMetric"'
	local globopts `"`globopts' noSTDerr noLRtest noLOg EMONLY NOEMSHOW"'
	local globopts `"`globopts' noFETable noRETable matsqrt matlog"'
	local globopts `"`globopts' posttheta RESiduals(string)"'
	local globopts `"`globopts' standardize(varname)"'

	// undocumented, for use by predict and estat

	local globopts `"`globopts' grouponly getblups(string) REISE"'

	// mlopts

	local mlopts `"NONRTOLerance NRTOLerance(string)"'
	local mlopts `"`mlopts' TRace GRADient HESSian showstep"'
	local mlopts `"`mlopts' TECHnique(string) SHOWNRtolerance"'
	local mlopts `"`mlopts' ITERate(string) TOLerance(string)"'
	local mlopts `"`mlopts' LTOLerance(string) GTOLerance(string)"'
	local mlopts `"`mlopts' DIFficult dots"'

	// diopts
	
	local diopts `"level(string) VSQuish"'
	local diopts `"`diopts' NOBASElevels ALLBASElevels BASElevels"'
	local diopts `"`diopts' NOCNSReport FULLCNSReport"'
	local diopts `"`diopts' NOOMITted NOEMPTYcells"'
	local diopts `"`diopts' COEFLegend selegend"'

	local globallow `"`globopts' `mlopts' `diopts'"'

	// parse

	_parse expand cmd glob : 0 , common(`globallow')

	forvalues k = 1/`cmd_n' {			// Parse global if/in
                local cmds `"`cmds' `"`cmd_`k''"'"'
        }
        _mixed_parseifin `=`cmd_n'+1' `cmds' "`glob_if' `glob_in'"

	// If linear regression and residual structure, insert an _all
	// empty level

	local 0 `", `glob_op'"'
	syntax [ , RESiduals(string) *]
	if (`cmd_n' == 1) & `"`residuals'"' != "" {
		local cmd_n 2
		local cmd_2 _all:, noconstant
	}

	forvalues k=0/`=`cmd_n'-1' {			// Parse subcmds
		_mixed_parsecmd `k' `cmd_`=`k'+1''
		if `k' > 0 {
			if "`varnames_`k''" != "" {
				NoOmit `varnames_`k''
				local varnames_`k' "`r(vars_noomit)'"
			}
		}
		local allnms `allnms' `levnm_`k'' `varnames_`k''
	}
	if "`depname'" == "" {
		di as err "dependent variable not specified"
		exit 198
	}
	local allnms `allnms' `depname'

	local 0 `"`glob_if' `glob_in'"'			// set estimation sample
	syntax [if] [in]
	marksample touse
	local allnms : subinstr local allnms "_all" "" , word all
	markout `touse' `allnms' , strok

	tempvar one					// processing macs
	qui gen byte `one' = 1 if `touse'
	local lev_beg 0
	local last_levnm "______"
	tempname lev_nvars sublevels
	if (`cmd_n' > 1)  matrix `sublevels' = J(1,`=`cmd_n'-1', 0)

	forvalues k=0/`=`cmd_n'-1' {			// reconcile levels
		local k1 = `k' - 1			// and sublevels

		if "`levnm_`k''" != "`last_levnm'" {

			if `k' > 0 {			// level var repeated
				if 0`:list levnm_`k' in levnms' {	
					if `"`levnm_`k''"' != `""' {
						RepeatedLevelError `levnm_`k''
						exit 198
					}
				}
				local levnms `levnms' `levnm_`k''

				_mixed_fixupconstant `lev_beg' `k1' /// 
						     `last_const'
				_mixed_setsublevels  `lev_beg' `k1' `sublevels'
				`vv' ///
				_mixed_rmcollevel `lev_beg' `k1' `depname'  ///
					   "`lev_constant'" "`lev_isfctrs'" ///
					   "`collin_`k1''" `touse'	    ///
					   `lev_varnames'
			}

			local lev_varnames `""`varnames_`k''""'
			if "`constant_`k''" != "" {
				local lev_constant 0
			}
			else {
				local lev_constant 1
			}
			local last_const   = cond("`constant_`k''"=="", `k', -1)
			local lev_isfctrs  `isfctr_`k''
			local lev_beg      `k'
		}
		else {
			local lev_varnames `"`lev_varnames' "`varnames_`k''""'
			local lev_isfctrs `lev_isfctrs' `isfctr_`k''

			if "`constant_`k''" != "" {
				local lev_constant `lev_constant' 0
			}
			else {
				local lev_constant `lev_constant' 1
			}
			if "`constant_`k''" == "" {
				local last_const = `k'
			}
		}

		local last_levnm `levnm_`k''
		local kh `k'
	}

	_mixed_fixupconstant `lev_beg' `kh' `last_const'
	_mixed_setsublevels  `lev_beg' `kh' `sublevels'
	version 10: ///		
	_mixed_rmcollevel `lev_beg' `kh' `depname' "`lev_constant'"	///
		   "`lev_isfctrs'" "`collin_`kh''" `touse' `lev_varnames'

	tempname fctrlevs hasfv noomit noomitcols

	forvalues k=0/`=`cmd_n'-1' {
		if `isfctr_`k'' {			// create factors
			tempvar ifctr
			qui egen long `ifctr' = group(`varnames_`k'') if `touse'
			label variable `ifctr'				///
			      `"R.`:subinstr local varlist_`k' " " " R."'"'
			local varlist_`k' `ifctr'

			sum `ifctr' , meanonly
			matrix `fctrlevs' = (nullmat(`fctrlevs'), r(max))
		}
		else {				// handle ts ops
			if `k' == 0 {
				local varlist_00 `varnames_0'
			}
			fvrevar `varnames_`k'' if `touse', tsonly
			local varlist_`k' `r(varlist)'
		}

		if "`constant_`k''" == "" {		// handle constants
			local varlist_`k' `varlist_`k'' `one'
			if `k' == 0 {
				local varlist_00 `varlist_00' `one'
			}
			local varnames_`k' `varnames_`k'' _cons
		}
		if `k' == 0 {
			if "`varlist_0'" != "" {
				NoOmit `varlist_00'
				local omitted `r(omitted)'
				matrix `noomitcols' = r(noomitcols)
				scalar `hasfv' = `r(hasfv)'
				matrix `noomit' = r(noomit)
			}
			else {
				scalar `hasfv' = 0
				local omitted 0
			}
		}
		if `k' > 0 & !`isfctr_`k'' {
			foreach var of local varlist_`k' {
				matrix `fctrlevs' = (nullmat(`fctrlevs'), 1)
			}
							// Fixup covariance
			if (`:list sizeof varlist_`k'' + 		///
			    ("`constant_`k''"=="")) <= 1 {
				local cov_`k' = "identity"
			}
		}

	}
	tsrevar `depname' if `touse'			// handle ts depvar
	local depvar `r(varlist)'

	foreach nm of local levnms {			// encode levels
		tempvar level 
		if ("`nm'" == "_all")  local nm `one'
		local nms `nms' `nm'
		qui egen long `level' = group(`nms') if `touse'
		local levelvars `levelvars' `level'
	}

	// global options are in glob_op  -- your parsing goes here
	local 0 `", `glob_op'"'
	syntax [ , `globopts' *]

	_get_diopts diopts options, `options'
	mlopts mlopts, `options'
	local coll `s(collinear)'
	local 0 `", `mlopts'"'
	syntax [, technique(string) COLlinear *]
	if `:list posof "bhhh" in technique' {
		di as err "option technique(bhhh) not allowed"
		exit 198
	}
	local mlopts `"technique(`technique') `options'"'

// error checking options goes here

	if "`mle'" != "" {
		local ml ml
	}
	if "`ml'" != "" {
		if "`reml'" != "" {
			di as err "ml and reml may not be specified at " _c
			di as err "the same time"
			exit 198
		}
		local reml 0
		local method ML
	}
	else {
		local reml 1
		local method REML
	}
	if "`emonly'" != "" & "`emdots'" == "" & "`noemshow'" == "" {   
		local emlog emlog
	}
	if "`emlog'" != "" & "`emdots'" != "" {
		di as err "emlog and emdots may not be specified together"
		exit 198
	}
	if "`variance'" != "" & "`estmetric'" != "" {
		di as err "variance and estmetric may not be specified together"
		exit 198
	}


	if "`pparsepost'" != "" {
		ereturn clear
		foreach mac in depvar depname cmd_n {
			ereturn local `mac' ``mac''
		}
		forvalues l = 0/`=`cmd_n'-1' {
			foreach mac in levnm isfctr cov	k sublevels	///
				       constant varlist varnames {
				ereturn local `mac'_`l' ``mac'_`l''
			}
		}
		exit
	}
							// set up _xtm_model
	tempvar nn rgroup

	// Get residual variance structure

	if `"`levelvars'"' != "" {
		local k : word count `levelvars'
		local lastlev : word `k' of `levelvars'
	}

	GetVarStruct `"`residuals'"' "`touse'" "`rgroup'" "`lastlev'"
	local rstructure `s(structure)'
	local tvar	 `s(tvar)'
	local origgroup	 `s(ogroup)'
	local rgroup	 `s(rgroup)'
	local nrgroups	 `s(nrgroups)'
	local rglabels  `"`s(rglabels)'"'
	local rstructlab `"`s(rstructlab)'"'
	local order `s(order)'
	tempname ar_p ma_q max_t
	scalar `ar_p' = `s(ar_p)'
	scalar `ma_q' = `s(ma_q)'

	// Handle time variable for certain residual structures
	tempvar time gap 
	tempname umap
	ProcessTimeVar "`tvar'" `time' `gap' `rstructure' ///
	               `touse' "`lastlev'" `umap' `order'

	if "`maxt'" != "" {
		scalar `max_t' = `maxt'
		// Need to remap default order to max order for banded
		if "`rstructure'" == "banded" & `order' == -1 {
			local order = `maxt'-1
			local rstructlab Banded(`order')
		}
		if "`rstructure'" == "toeplitz" & `order' == -1 {
			local order = `maxt'-1
			local rstructlab Toeplitz(`order')
		}
		if `maxt' < 2 {
			di as err "{p 0 4 2}This residual structure "
			di as err "requires at least two unique time "
			di as err "points{p_end}"
			exit 459
		}
	}

	global XTM_res = ("`rstructure'" != "independent") | "`rgroup'" != "" 

	local nlevs = `cmd_n' - 1
	local allempty 1
	forvalues k=1/`nlevs' {			// check for empty levels
		if "`varlist_`k''" != "" {
			local allempty 0
		}
	}
	if `allempty' & `nlevs' & !$XTM_res {
		di as txt "{p 0 4 2}Note: all random-effects equations are "
		di as txt "empty; model is linear regression{p_end}"
		local cmd_n 1
		local levelvars
	}

	if $XTM_res & "`stderr'" != "" {
		di as err "{p 0 4 2}nostderr allowed only with the default "
		di as err "identity residual-variance structure{p_end}"
		exit 198
	}

	if $XTM_res & "`emonly'" != "" {
		di as err "{p 0 4 2}emonly allowed only with the default "
		di as err "identity residual-variance structure{p_end}"
		exit 198
	}

	qui gen long `nn' = _n if `touse'
	gsort -`touse' `levelvars' `time' `nn'

	tempname obs re_n
	qui count if `touse'
	scalar `obs' = r(N)
	scalar `re_n' = `cmd_n' - 1

	// Set the parameterization method

	if "`matsqrt'`matlog'" == "" {
		if $XTM_ver < 11 {
			local matlog matlog
		}
	}
	if "`matlog'" != "" {
		if "`matsqrt'" != "" {
			di as err "{p 0 6 2}at most one of matlog and"
			di as err " matsqrt may be specified{p_end}"
			exit 198
		}
	}
	
	mata: _xtm_setup()

	// obtain blups if specified and exit
	if `"`getblups'"' != "" {
		CheckBlups `getblups'
		SetBlupMats `touse'
		GetBlups `"`getblups'"' `reise'
		exit	
	}
	if "`standardize'" != "" {
		mata: _xtm_standardize_res()
		exit
	}
		
	if `reml' {
		local crittype log restricted-likelihood
	}
	else {
		local crittype log likelihood
	}
	if "`log'" != "" {
		local q qui
	}

	tempname delta deltaf theta thetaf gamma s h err beta Vbeta V rho

// fit reference regression model
	
	if `cmd_n' == 1 | "`lrtest'" == "" {
		`vv' ///
		MyReg `depvar' `varlist_0' if `touse', reml(`reml')
		local ll_0 `r(ll0)'
		local gam `r(lnsig)'
	}

	if `cmd_n' == 1 { 	// model is linear regression 
		local ll_2 `ll_0'
		mat `beta' = e(b)    // from regress
		mat `Vbeta' = e(V)  
		local c = colsof(`Vbeta')
		if !`reml' & `c'{         // ml uses different sigma^2
			mat `Vbeta' = `Vbeta' * e(df_r)/e(N)
		}
		mat `gamma' = `gam'
		mat colnames `gamma' = lnsig_e:_cons
		mat `V' = 0
		if "`stderr'" == "" {
			mat `V' = 1/(2*e(N))
		}
		local lrtest nolrtest
		local emconv 1
		mat `rho' = 0
		local omitted 0
	}
	else {
// starting values

		mata: _xtm_start("`delta'",0.375)   

// EM iterations
		if `emiterate' {
		   `q' IterateEM `delta', crit(`crittype') iter(`emiterate') ///
			tol(`emtolerance') `emlog' `emdots' 
		    local emconv = r(converged)
		}
		mat `deltaf' = `delta'

// Transform to NR parameterization

		mata: _xtm_delta_to_theta("`theta'","`delta'","`err'")
		if scalar(`err') {
			di as err "initial values/EM solution not feasible"
			exit 430 
		}
		mat `thetaf' = `theta'
		mata: _xtm_ml_eqlist("eqlist")

// Equation list and starting values for residual variance parameters

		tempname startval
		mata: _xtm_res_eqlist("reqlist")
		if !$XTM_res {
			mat `rho' = 0
			mat `startval' = `theta'
		}
		else {
			mata: _xtm_res_start("`rho'")
			mat `startval' = `theta', `rho'
		}
		global XTM_ctheta = colsof(`theta')

		local df_c : word count `eqlist' `reqlist'
		mat `h' = J(1,`df_c',1)

		if _caller() >= 11 {
			local dscale derivscale(`h')
		}
		else {
			local dscale dzeros(`h')
		}
	
		if "`emonly'" == "" {
			`q' di
			`q' di as txt "Performing gradient-based optimization: " 

			`vv' ///
			cap noi `q' ml model d0 mixed_ll `eqlist' ///
			        `reqlist', ///
				max init(`startval', copy) ///
				search(off) crittype(`crittype') `dscale' ///
				collinear missing nopreserve `mlopts' 

			if _rc | "`e(converged)'" == "0" {	
				if _rc == 1 {
					exit 1
				}
				if $XTM_res {
					ereturn clear
					error 430
				}
				local noconv noconv
				mat `delta' = `deltaf'
				mat `theta' = `thetaf'
			}
			else {
				tempname bb
				mat `bb' = e(b)
				if $XTM_ctheta {
					mat `theta' = `bb'[1,1..$XTM_ctheta]
				}
				else {
					mata: _xtm_null_rowvector("`theta'")
				}
				if $XTM_res {
					mat `rho' = `bb'[1,`=$XTM_ctheta+1'...]
				}
				mata: _xtm_theta_to_delta("`delta'", ///
							  "`theta'","`err'")	
				local opt `e(opt)'	
				local ml_method `e(ml_method)'
				local technique `e(technique)'
			}
		}
		if $XTM_res {
			tempname rho2
			mata: _xtm_drho_to_rho("`rho'","`rho2'","`err'")
			mat `rho' = `rho2'
		}
		scalar `s' = -1 
		mata: _xtm_mixed_ll("`delta'","`rho'","`s'",0)
		local ll_1 = r(ll)
		scalar `s' = r(mse)
		local ll_2 = `ll_1'

// Reparameterize
		mata: _xtm_theta_to_gamma("`gamma'","`theta'","`s'")
		tempname initfinal
		mat `initfinal' = `gamma'
		if $XTM_res {
			mat `initfinal' = `gamma', `rho'
		}
		if "`noconv'" == "" & "`emonly'" == "" & "`stderr'" == "" {
			if _caller() >= 11 {
				mat `h' = e(ml_scale), 1
			}
			else {
				mat `h' = e(ml_d0_s), 1
			}
			local c = colsof(`theta')
			forvalues i = 1/`c' {
			    mat `h'[1,`i'] = `h'[1,`i'] * ///
				abs(`gamma'[1,`i']/`theta'[1,`i'])
			}
			`q' di 
			`q' di as txt "Computing standard errors:" 
			`vv' ///
			cap ml model d0 mixed_ll_reparm ///
			    `eqlist' /lnsig_e `reqlist', ///
			    max init(`initfinal',copy) search(off) iter(0) ///
			    `dscale' collinear missing nopreserve `mlopts'
			if _rc {
				if _rc == 1 {
					exit 1
				}
				local nostd nostd
				local ll_2 = `ll_1'
			}
			else {
				local ll_2 = e(ll)
				if reldif(`ll_1',`ll_2') > 1e-10 {
					local nostd nostd
				}
			}
			if "`nostd'" != "" {
				di as err "standard-error calculation failed"
				if $XTM_res {
					ereturn clear
					error 430
				}
			}
		}

// Get final beta

        	mata: _xtm_mixed_ll("`delta'","`rho'","`s'",1) 
		mata: _xtm_beta("`beta'","`Vbeta'","`s'")
		if "`noconv'"=="" & "`emonly'"=="" & ///
			"`nostd'" == "" & "`stderr'"=="" {
			mat `gamma' = e(b)
			mat `V' = e(V)	
		}
		else {
			local eqnames : subinstr local eqlist "/" "", all
			mat coleq `gamma' = `eqnames' lnsig_e
			mat colnames `gamma' = _cons
			local c = colsof(`gamma')
			mat `V' = J(`c',`c',0)
		}
	}

// Post Parameters

	if `"`varnames_0'"' == "" {
		`vv' ///
		PostParms `depname', re(`gamma') vre(`V') touse(`touse') ///
		     noomit(`noomit') omitted(`omitted')
	}
	else {
		`vv' ///
		PostParms `depname' `varnames_0', beta(`beta') ///
			vbeta(`Vbeta') re(`gamma') vre(`V') /// 
			touse(`touse') noomit(`noomit') omitted(`omitted')
	}

// Out of the variance estimates, count how many sigmas and rhos 

	mat `gamma' = e(b)
	local eqs : coleq `gamma'
	local k_rs 0
	forval i = `=e(k_f)+1'/`e(k)' {
		local eq : word `i' of `eqs'
		if substr("`eq'",1,3) == "lns" | substr("`eq'",1,5) == "r_lns" {
			local ++k_rs
		}
	}
	ereturn scalar k_rs = `k_rs'
	ereturn scalar k_rc = e(k_r) - e(k_rs)
	ereturn scalar k_res = cond($XTM_res, colsof(`rho'), 0)

	if "`emonly'" != "" {
		ereturn local emonly emonly
		ereturn scalar converged = `emconv'
	}
	else {
		ereturn scalar converged = ("`noconv'"=="")
	}
	ereturn local depvar `depname'
	ereturn scalar ll = `ll_2'

// Comparison test
	
	if `cmd_n' > 1 & "`lrtest'" == "" {
		ereturn scalar ll_c = `ll_0'
		ereturn scalar df_c = `df_c'
		ereturn scalar chi2_c = 2*(e(ll) - e(ll_c))
		if e(chi2_c) < 0 {
			ereturn scalar chi2_c = 0
		}
		ereturn scalar p_c = chi2tail(e(df_c),e(chi2_c))
		if e(df_c) == 1 & e(chi2_c) > 1e-5 & !$XTM_res {
			ereturn scalar p_c = 0.5*e(p_c)
		}
	}

//  data resorted in what follows

	SaveGroupInfo `"`levelvars'"' 

	if "`matlog'" == "" {
		ereturn local optmetric matsqrt
	}
	else {
		ereturn local optmetric matlog
	}

	if "`posttheta'" != "" {
		ereturn matrix theta = `theta'
	}

	ereturn local crittype `crittype'
	ereturn local method `method'
	ereturn local opt `opt'
	ereturn local ml_method `ml_method'
	ereturn local technique `technique'
	ereturn local title Mixed-effects `e(method)' regression

	forvalues k=1/`=`cmd_n'-1' {
		if `isfctr_`k'' {
			local varnames_`k'				///
			      `"R.`:subinstr local varnames_`k' " " " R."'"'
		}
		local zvars     `"`zvars' `varnames_`k''"'
		local vartypes  `"`vartypes' `=proper("`cov_`k''")'"'
		local lvnms     `"`lvnms' `levnm_`k''"'
		local dimz	`"`dimz' `:list sizeof varnames_`k''"'
	}
	ereturn local revars `zvars'
	ereturn local vartypes `vartypes'
	ereturn local ivars `lvnms'
	ereturn local redim `dimz'
	ereturn local cmd xtmixed
	ereturn local predict xtmixed_p
	ereturn local estat_cmd xtmixed_estat
	ereturn local resopt `"`residuals'"'
	ereturn local rstructure `rstructure'
	ereturn local rbyvar `origgroup'	
	ereturn local rglabels `"`rglabels'"'
	ereturn local rstructlab `"`rstructlab'"'
	ereturn scalar nrgroups = `nrgroups'
	if "`time'" != "" {
		ereturn local timevar `tvar'
	}
	if `ar_p' {
		ereturn scalar ar_p = `ar_p'
	}
	if `ma_q' {
		ereturn scalar ma_q = `ma_q'	
	}
	if `order' >= 0 {
		ereturn scalar res_order = `order'
	}
	if "`e(rstructure)'" == "unstructured" | 	/// 
	   "`e(rstructure)'" == "banded" {
		ereturn matrix tmap = `umap'
	}

	if "`varnames_0'" == "_cons"  | "`varnames_0'" == "" {
		ereturn scalar chi2 = .
		ereturn scalar p = .
		ereturn scalar df_m = 0
	}
	else {
		_prefix_model_test xtmixed
	}
	ereturn local chi2type Wald
	ereturn scalar rc = cond(`e(converged)',0,430)

	_xtmixed_display, level(`level') `lrtest' ///
		`variance' `group' `header' `estmetric' ///
		`grouponly' `fetable' `retable' `diopts'
end

program ConstantNote
	args lev_k

	di as text							///
"{p 0 6}Note: level `lev_k' already has a constant, {cmd:noconstant} assumed for all other entries for the level{p_end}"

end

program RepeatedLevelError
    di as error 							///
    "{p 0 4}`0' level variable, specified at more than one level{p_end}"
end

program PostParms, eclass
	if _caller() >= 11 {
		local vv : di "version " string(_caller()) ":"
	}
	syntax [anything] [, beta(string) vbeta(string) re(string) ///
			    vre(string) touse(string) noomit(name) ///
			    omitted(integer 0)]
	tempname bc vc Cns
	GetCns `Cns' k_autoCns
	local r2 = colsof(`re')
	if "`beta'" != "" {	
		local r1 = colsof(`beta') + `omitted'
	}
	else {
		local names: colfullnames `re'
		mat colnames `vre' = `names'
		mat rownames `vre' = `names'
		_ms_op_info `re'
		if r(tsops) {
			quietly tsset, noquery
		}
		eret post `re' `vre' `Cns', depname(`depvar') ///
			esample(`touse') buildfvinfo
		_post_vce_rank
		if `:length local Cns' {
			ereturn scalar k_autoCns = `k_autoCns'
		}
		eret scalar k_f = 0
		eret scalar k_r = `r2'
		eret scalar k = `r2'
		exit
	}
	gettoken depvar xvars : anything

	if strpos("`depvar'",".") {
		gettoken ts rest : depvar, parse(".")
		gettoken dot depvar : rest, parse(".")
	}

	foreach v of local xvars {
		local col `col' `depvar':`v'
	}	
	if `omitted' {
		mata: _add_omitted("`beta'","`vbeta'","`noomit'",`omitted')
	}
	`vv' ///
	mat colnames `beta' = `col'
	mat `bc' = `beta', `re'	
	mat `vc' = (`vbeta' , J(`r1',`r2',0) \ J(`r2',`r1',0), `vre')
	local names: colfullnames `bc'
	`vv' ///
	mat colnames `vc' = `names'
	`vv' ///
	mat rownames `vc' = `names'
	_ms_op_info `bc'
	if r(tsops) {
		quietly tsset, noquery
	}
	eret post `bc' `vc' `Cns', depname(`depvar') esample(`touse') ///
		buildfvinfo
	_post_vce_rank
	if `:length local Cns' {
		ereturn scalar k_autoCns = `k_autoCns'
	}
	eret scalar k_f = `r1'
	eret scalar k_r = `r2'
	eret scalar k = `r1' + `r2'
end

program SaveGroupInfo, eclass
	args levnames

	qui count if e(sample)
	ereturn scalar N = `r(N)'
	local levels : list uniq levnames
	local k : word count `levels'
	if `k' == 0 {
		exit
	}
		
	tempname gmin gmax gavg Ng
	mat `Ng' = J(1,`k',0)
	mat `gmin' = J(1,`k',0)
	mat `gavg' = J(1,`k',0)
	mat `gmax' = J(1,`k',0)

	forvalues i = 1/`k' {
		GroupStats `:word `i' of `levels'' if e(sample)	
		mat `Ng'[1,`i'] = r(ng)
		mat `gmin'[1,`i'] = r(min)
		mat `gavg'[1,`i'] = r(avg)
		mat `gmax'[1,`i'] = r(max)
		local ++i
	}
	ereturn matrix N_g `Ng'
	ereturn matrix g_min `gmin'
	ereturn matrix g_avg `gavg'
	ereturn matrix g_max `gmax'
end

program GroupStats, rclass
	syntax name [if]
	marksample touse

	if "`namelist'" == "_all" {
		tempvar one
		qui gen byte `one' = 1 if `touse'
		local namelist `one'
	}
	tempname T
	qui {
		bysort `touse' `namelist': /// 
			gen long `T' = cond(_n==_N,_N,.) if `touse'
		sum `T' if `touse'
	}
	return scalar ng = r(N)
	return scalar min = r(min)
	return scalar max = r(max)
	return scalar avg = r(mean)
end

program IterateEM, rclass
	syntax name(name=theta) [, iter(integer 1) tol(real 1.0) ///
			crit(string) emlog emdots ]

	tempname thetaold s lold lnew delta err
	mat `thetaold' = `theta'

	if "`emlog'" == "" {
		local st *
	}
	if $XTM_res {
		di as txt _n "Obtaining starting values by EM: " _c
	}
	else {
		di as txt _n "Performing EM optimization: " _c
	}
	if "`emdots'" != "" {
		local didot `"di as txt "." _c"'
	}
	else {
		di
		`st' di
	}
	scalar `lold' = -1
	scalar `lnew' = 1
	
	local i 0	
	while `i' <= `iter'-1 & ///
	   reldif(scalar(`lold'),scalar(`lnew')) > `tol' {
		mata: _xtm_em_iter("`thetaold'","`theta'","`s'")
		if missing(r(ll)) {
			if "`emdots'" != "" {
				di _n
			}
			di as err "likelihood evaluates to missing"
			exit 430
		}
`st'di as txt "Iteration `i':" _col(16) "`crit' = " as res %10.0g `r(ll)'
		`didot'
		mat `thetaold' = `theta'
		scalar `lold' = scalar(`lnew')
		scalar `lnew' = r(ll)
		local ++i
	}
	scalar `s' = -1
	mata: _xtm_mixed_ll("`theta'","","`s'",0)
`st'di as txt "Iteration `i':" _col(16) "`crit' = " as res %10.0g `r(ll)'
	if "`emdots'" != "" {
		di 
	}
	return scalar converged = (`i'<`iter')
end

program MyReg, rclass
	if _caller() >= 11 {
		local vv : di "version " string(_caller()) ":"
	}
	syntax anything(name=model) [if] [, reml(integer 0)]
	
	gettoken depvar xvars : model

	// strip _cons off the end of xvars
	local k: word count `xvars'
	if `k' {
		if "`:word `k' of `xvars''" == "_cons" {
			local xvars : subinstr local xvars "_cons" ""
		}
		else {
			local nocons nocons
		}
	}
	else {
		local nocons nocons
	}
	`vv' ///
	qui _regress `depvar' `xvars' `if', `nocons'
	tempname lnsig ll0 logdet fact
	if `reml' {	
		mata: _xtm_logdetr00("`logdet'")
		scalar `lnsig' = log(e(rmse))
		scalar `ll0' = -e(df_r)/2*(log(2*_pi) + 1 + 2*`lnsig') ///
			       -`logdet'
	}
	else {		
		scalar `lnsig' = log(e(rss)/e(N))/2
		scalar `ll0' = e(ll)
		
	}
	return scalar lnsig = `lnsig'
	return scalar ll0 = `ll0'
end

program SetBlupMats 
	args touse
	tempname gamma theta delta err s2 b rho

	if `"`e(cmd)'"' != "xtmixed" {
di as err "BLUP calculations require a previously fitted {cmd:xtmixed} model"
		exit 301
	}

	qui count if `touse'
	if r(N) != e(N) {
	    di as err "BLUP calculation failed; estimation data have changed"
	    exit 459
	}

	mat `b' = e(b)
	mat `b' = `b'[1,`=e(k_f)+1'...]
	local k = colsof(`b') - e(k_res)
	mat `gamma' = `b'[1,1..`k']
	local p = colsof(`gamma')
	scalar `s2' = exp(2*`gamma'[1,`p'])
	if `e(k_res)' {
		mat `rho' = `b'[1,`=`k'+1'...]
	}
	else {
		mat `rho' = 0
	}

	local k 0
	capture {
		 mata: _xtm_gamma_to_theta("`theta'","`gamma'","`err'")
		 local k = scalar(`err')
		 mata: _xtm_theta_to_delta("`delta'","`theta'","`err'")
		 local k = `k' + scalar(`err')
	}
	if `k' | _rc {
		di as err "BLUP calculation failed; e(b) unsuitable"
		exit 459
	}
	local ll 0
	capture {
		mata: _xtm_mixed_ll("`delta'","`rho'","`s2'",2)
		local ll = r(ll)
	}
	if _rc | reldif(`ll',e(ll)) > 1e-12 {
	    di as err "BLUP calculation failed; estimation data have changed"
	    exit 459
	}
end

program CheckBlups
	local k : word count `0'
	if mod(`k',2) {
		di as err "getblups() incorrectly specified"
		exit 198
	}
	forvalues i = 1/`=`k'/2' {
		gettoken level 0 : 0
		gettoken stub 0 : 0
		if `:list stub in stublist' {
			di as err "stubs must be unique"
			exit 198
		}
		local stublist `stublist' `stub'
		if `"`level'"' != "_all" {
			unab level : `level'
		}
		local ivars `e(ivars)'
		local p : list posof "`level'" in ivars
		if !`p' {
			di as err `"`level' is not a group variable"'
			exit 198
		}
		local m 0
		forvalues j = `p'/`:word count `ivars'' {
			if `"`:word `j' of `ivars''"' != "`level'" {
				continue, break
			}
			local np : word `j' of `e(redim)'	
			forvalues k = 1/`np' {
				confirm new variable `stub'`=`m'+`k''
			}
			local m = `m' + `np'
		}
	}
end

program GetBlups
	args blist reise
	mata: _xtm_fillBmat() 

	local k : word count `blist'
	forvalues i = 1/`=`k'/2' {
		gettoken level blist : blist
		gettoken stub blist : blist
		if `"`level'"' != "_all" {
			unab level : `level'
		}
		GetBlupsLevel `level' `stub' `reise'
	}
end

program GetBlupsLevel
	args lvar stub reise

	local ivars `e(ivars)'
	local zvars `e(revars)'

	// get z variables
	local w : word count `ivars'
	forvalues i = 1/`w' {
		local lev : word `i' of `ivars'
		local dim : word `i' of `e(redim)'
		if "`lev'" != "`lvar'" {
			local dont *
		}
		forvalues j = 1/`dim' {
			gettoken z zvars : zvars 
			`dont'local zs `zs' `z'
		}
		local dont
	}

	local uivars : list uniq ivars
	local p : list posof "`lvar'" in uivars 	// p is the true level
	local nz : word count `zs'

	if "`reise'" != "" {
		local lab r.e. std. errors
		local dose 1
	}
	else {
		local lab r.e.
		local dose 0
	}

	forvalues i = 1/`nz' {
		qui gen double `stub'`i' = . 
		label var `stub'`i' `"BLUP `lab' for `lvar': `:word `i' of `zs''"'
	}
	mata: _xtm_blup_save("`stub'",`p',`dose')
end

program GetVarStruct, sclass sort
	args structspec touse rgroup lastlev

	local 0 `structspec'
	syntax [anything] [, by(varname) t(varname numeric)]
	local group `by'

	local struct `anything'
	ParseVarStruct `"`struct'"' 
	sreturn local tvar `t'
	sreturn local rstructlab `s(structlab)'
	sreturn local order `s(order)'
	local structure `s(structure)'

	if "`group'" != "" {
		qui replace `touse' = 0 if missing(`group')
		qui egen long `rgroup' = group(`group') if `touse'
		if "`lastlev'" != "" & "`structure'" != "independent" {
			CheckConstantWithin `lastlev' `rgroup' `touse'
		}
		qui sum `rgroup' if `touse', meanonly
		if r(max) == 1 {
			di as txt "{p 0 4 2}Note: grouping variable constant "
			di as txt "over estimation data; by() option "
			di as txt "ignored{p_end}"
			local rgroup
			sreturn local nrgroups 1
		}
		else {
			sreturn local nrgroups `r(max)'
			GetGroupLabels `group' `touse'
			sreturn local rglabels `"`s(rglabels)'"'
		}
		sreturn local ogroup `group'
		sreturn local rgroup `rgroup'
	}
	else {
		sreturn local nrgroups 1
	}
	sreturn local structure `structure'
end

program GetGroupLabels, sclass
	args group touse
	preserve
	qui drop if !`touse'
	tempvar tokeep
	sort `group'
	qui by `group': gen byte `tokeep' = _n == 1
	qui keep if `tokeep'
	// Now loop over the "data"
	cap confirm string variable `group'
	if !_rc {
		forval i = 1/`=_N' {
			local lab = abbrev(`group'[`i'], 30)
			local rglabels `"`rglabels' `"`lab'"'"'
		}
		sreturn local rglabels `"`rglabels'"'
		exit
	}
	local vl : value label `group'
	if "`vl'" != "" {
		forval i = 1/`=_N' {
			local lab : label (`group') `=`group'[`i']' 30
			local rglabels `"`rglabels' `"`lab'"'"'
		}
		sreturn local rglabels `"`rglabels'"'
		exit
	}
	forval i = 1/`=_N' {
		cap confirm integer number `=`group'[`i']'
		if _rc {
			di as err "{p 0 4 2}numeric by() variable must be "
			di as err "integer-valued{p_end}"
			exit 459
		}
		local lab : di `group'[`i'] 
		local lab = abbrev(`"`lab'"', 30)
		local rglabels `"`rglabels' `"`lab'"'"'
	}
	sreturn local rglabels `"`rglabels'"'
end

program ParseVarStruct, sclass
	args struct 
	local k : word count `struct'
	if `k' == 1 {
		gettoken struct rest : struct, parse("0123456789")	
	}
	else {
		gettoken struct rest : struct
	}
	local k : word count `rest'
	if `k' > 1 {
		di as err "{p 0 4 2}invalid residuals() specification{p_end}"
		exit 198
	}
	local ar_p 0
	local ma_q 0 
	local l = length(`"`struct'"')
	if `"`struct'"' == "ar" {
		local resid ar
		if "`rest'" == "" {
			local ar_p 1
		}
		else {	
			local ar_p `rest'
		}
		confirm integer number `ar_p'
		cap assert `ar_p' > 0
		if _rc {
			di as err "{p 0 4 2}AR parameter must be a "
			di as err "positive integer{p_end}"
			exit 198
		}
		local structlab AR(`ar_p')
		local order `ar_p'
		local rest
	}
	else if `"`struct'"' == "ma" {
		local resid ma
		if "`rest'" == "" {
			local ma_q 1
		}
		else {
			local ma_q `rest'
		}
		confirm integer number `ma_q'
		cap assert `ma_q' > 0
		if _rc {
			di as err "{p 0 4 2}MA parameter must be a "
			di as err "positive integer{p_end}"
			exit 198
		}
		local structlab MA(`ma_q')
		local order `ma_q'
		local rest
	}
	else if `"`struct'"' == substr("toeplitz", 1, max(2, `l')) {
		local resid toeplitz
		if "`rest'" == "" {
			local to_p -1
			local specified 0
		}
		else {
			local to_p `rest'
			local specified 1
		}
		confirm integer number `to_p'
		cap assert `to_p' >= 0
		if _rc & `specified' {
			di as err "{p 0 4 2}Toeplitz parameter must be a "
			di as err "nonnegative integer{p_end}"
			exit 198
		}
		if `to_p' == 0 {
			di as txt "{p 0 4 2}Note: A Toeplitz structure of "
			di as txt "order 0 is the independent structure{p_end}"
			sreturn local structure independent
			sreturn local structlab Independent
			sreturn local ar_p `ar_p'
			sreturn local ma_q `ma_q'
			sreturn local order -1
			exit
		}
		local structlab Toeplitz(`to_p')
		local order `to_p'
		local rest
	}
	else if `"`struct'"' == substr("banded", 1, max(2, `l')) {
		local resid banded
		if "`rest'" == "" {
			local ba_p -1
			local specified 0
		}
		else {
			local ba_p `rest'
			local specified 1
		}
		confirm integer number `ba_p'
		cap assert `ba_p' >= 0 
		if _rc & `specified' {
			di as err "{p 0 4 2}Banded parameter must be a "
			di as err "nonnegative integer{p_end}"
			exit 198
		}
		local structlab Banded(`ba_p')
		local order `ba_p'
		local rest
	}
	else if `"`struct'"' == substr("exchangeable", 1, max(2, `l')) {
		local resid exchangeable
		local structlab Exchangeable
	}
	else if `"`struct'"' == substr("unstructured", 1, max(2, `l')) {
		local resid unstructured
		local structlab Unstructured
	}
	else if `"`struct'"' == substr("exponential", 1, max(3, `l')) {
		local resid exponential
		local structlab Exponential
	}
	else if `"`struct'"' == substr("independent", 1, max(3, `l')) {
		local resid independent
		local structlab Independent
	}
	else if `"`struct'"' == "" {
		local resid independent
		local structlab Independent
	}
	else {
		di as err "{p 0 4 2}invalid residual() structure{p_end}"
		exit 198
	}
	if "`rest'" != "" {
		di as err "{p 0 4 2}residual() structure does not take "
		di as err "any additional arguments{p_end}"
		exit 198
	}
	sreturn local structure `resid'
	sreturn local structlab `structlab'
	sreturn local ar_p `ar_p'
	sreturn local ma_q `ma_q'
	if "`order'" == "" {
		local order -1
	}
	sreturn local order `order'
end

program CheckConstantWithin, sortpreserve
	// check that group is constant within lev
	args lev group touse

	tempvar gr
	qui egen long `gr' = group(`lev' `touse')
	sort `gr'
	cap by `gr': assert `group' == `group'[1] if `touse'
	if _rc {
		di as err "{p 0 4 2}option residuals(): by variable is not "
		di as err "constant within lowest-level panels{p_end}"
		exit 459
	}
end

program ProcessTimeVar, sort
	args tvar time gap struct touse level umap order

	if "`struct'" == "ar"  | "`struct'" == "ma" | 		/// 
	   "`struct'" == "toeplitz" {
		if "`tvar'" == "" {
			di as err "{p 0 4 2}t() required for this structure"
			di as err "{p_end}"
			exit 198
		}
		qui replace `touse' = 0 if missing(`tvar')
		cap assert `tvar' == int(`tvar') if `touse'
		if _rc {
			di as err "{p 0 4 2}time variable must be "
			di as err "integer-valued{p_end}"
			exit 459
		}
		tempvar gr diff
		qui egen long `gr' = group(`level' `touse')
		sort `gr' `tvar'
		qui bysort `gr': gen long `time' = `tvar'-`tvar'[1]+1 ///
				 if `touse' 
		qui by `gr': gen long `diff' = `time' - `time'[_n-1] /// 
				 if _n > 1 & `touse'
		cap assert `diff' > 0 if `touse' & !missing(`diff')
		if _rc {
			di as err "{p 0 4 2}repeated time values within 
			di as err "lowest-level panels{p_end}"
			exit 459
		}
		qui by `gr': gen byte `gap' = `time'[_N] > _N if `touse'
		cap assert !`gap' if `touse'
		if _rc {
			di as txt "{p 0 4 2}Note: time gaps exist in the "
			di as txt "estimation data{p_end}"
		}
		drop `diff'
		if "`struct'" != "toeplitz" {
			qui by `gr': gen `diff' = _N > `order' if `touse'
			qui count if `diff' & `touse'
			if !r(N) {
				local tt = upper("`struct'")
				di as err "{p 0 4 2}`tt' order must be less "
				di as err "than the size of the largest "
				di as err "lowest-level panel{p_end}"
				exit 459
			}
		}
		else {
			qui by `gr': gen `diff' = _N > `order' if `touse'
			qui count if `diff' & `touse'
			if !r(N) {
				di as err "{p 0 4 2}Toeplitz order must be "
				di as err "less than the size of the "
				di as err "largest lowest-level panel{p_end}"
				exit 459
			}
			qui sum `time' if `touse'
			local maxt = r(max)
			c_local maxt `maxt'
		}
		exit
	}
	else if "`struct'" == "unstructured" | "`struct'" == "banded" {
		if "`tvar'" == "" {
			di as err "{p 0 4 2}t() required for this structure"
			di as err "{p_end}"
			exit 198
		}
		qui replace `touse' = 0 if missing(`tvar')
		cap assert `tvar' == int(`tvar') if `touse'
		if _rc {
			di as err "{p 0 4 2}t() variable must be "
			di as err "integer-valued{p_end}"
			exit 459
		}
		cap assert `tvar' >= 0 if `touse'
		if _rc {
			di as err "{p 0 4 2}t() variable must be "
			di as err "nonnegative-valued{p_end}"
			exit 459
		}
		tempvar gr 
		qui egen long `gr' = group(`level' `touse')
		qui levelsof `tvar' if `touse', local(levs)
		qui egen long `time' = group(`tvar') if `touse'
		local maxt : word count `levs'
		matrix `umap' = J(1, `maxt', 0)
		local j 1
		foreach i of local levs {
			mat `umap'[1, `j'] = `i'
			local ++j
		}
		sort `gr' `time' 
		cap by `gr': assert `time' != `time'[_n-1] if `touse'
		if _rc {
			di as err "{p 0 4 2}repeated t() values within "
			di as err "lowest-level panels{p_end}"
			exit 459
		}
		qui by `gr': gen byte `gap' = (`time' != _n) | ///
		                              (_N != `maxt') if `touse'
		gsort `gr' -`gap'
		qui by `gr': replace `gap' = `gap'[1] if `touse'
		if "`struct'" == "banded" & `order' > `maxt' - 1 {
			di as err "{p 0 4 2}banded order must be less "
			di as err "than the number of unique time values{p_end}"
			exit 459
		}
		c_local maxt `maxt'
		exit
	}
	else if "`struct'" == "exponential" {
		if "`tvar'" == "" {
			di as err "{p 0 4 2}t() required for this structure"
			di as err "{p_end}"
			exit 198
		}
		qui replace `touse' = 0 if missing(`tvar')
		qui gen double `time' = `tvar' if `touse'
		c_local gap
		exit
	}
	else if "`tvar'" != "" {
		di as txt "{p 0 4 2}Note: t() not required for this residual "
		di as txt "structure; ignored{p_end}"
		c_local time
		c_local gap
		exit
	}
	c_local time
	c_local gap
end

program GetCns
	version 11
	args Cns autoCns
	if "`e(Cns)'" == "matrix" {
		version 11: matrix `Cns' = e(Cns)
		c_local `autoCns' = e(k_autoCns)
	}
	else	c_local Cns
end

program NoOmit, rclass
	syntax varlist(fv ts)
	local hasfv = "`s(fvops)'" == "true"	
	fvexpand `varlist'
	local full_list `r(varlist)'
	local cols : word count `full_list'
	tempname noomit noomitcols
	mat `noomit' = J(1,`cols',1)
	local omitted 0
	local i 1
	foreach var of local full_list {
		_ms_parse_parts `var'
		if `r(omit)' {
			local ++omitted	
			mat `noomit'[1,`i'] == 0
			if !`hasfv' {
				local hasfv 1
			}
		}
		else {
			local vars_noomit "`vars_noomit' `var'"
			capture assert `noomitcols'[1,1]>0
			if !_rc {
				mat `noomitcols' = `noomitcols'[1,1...],`i'
			}
			else {
				mat `noomitcols' = J(1,1,`i')
			}
		}
		local ++i
	}
	return local omitted = "`omitted'"
	return local vars_noomit "`vars_noomit'"
	return matrix noomitcols = `noomitcols'
	return scalar hasfv = `hasfv'
	return matrix noomit = `noomit'
end

version 11
local SS        string scalar
local RS        real scalar
local RRVEC     real rowvector
local RMAT      real matrix
mata:

void _add_omitted(`SS' bname, `SS' vname, `SS' noomitname, `RS' k)
{
        `RS'            ncols, p
        `RRVEC'         noomitcols, b
        `RMAT'          V


        p = cols(st_matrix(noomitname))
        ncols = cols(st_matrix(bname))+k

        noomitcols = range(1,ncols,1)'
        noomitcols = select(noomitcols,(st_matrix(noomitname),J(1,ncols-p,1)))

        b = J(1,ncols,0)
        V = J(ncols,ncols,0)
        b[noomitcols] = st_matrix(bname)
        V[noomitcols', noomitcols] = st_matrix(vname)

        st_matrix(bname, b)
        st_matrix(vname, V)
}

end

exit
